# pmcom.tcl: pass commands to personality module (seperate input window)
#########################################################
#Written By Armin Karcher
# 12/95
# At Lawrence Berkeley National Laboratory
#########################################################

proc kakka2 { } {
 set t pm_command
    if {![winfo exists .$t]} {
    toplevel .$t -bg  #00f
    set h $t.main
    set bf $t.btnfrm
    pack [frame .$bf   		\
		-bd 2 		\
		-bg  #00f ] 	\
		-pady 2 
    pack [button .$bf.b0 -text "Help" \
		-relief raised  \
		-bd 2  \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0\
		-command {cal_help .pmcom_help pmcom_helpfile}] \
	-side left   -padx 5

    pack [button .$bf.b1 -text "Close Window" \
		-relief raised  \
		-bd 2  \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0\
		-command "destroy .$t"] -side left -padx 5 

    pack [frame .$h   		\
		-bd 2 		\
		-bg  #00f ] 	\
			-pady 2 \
			-anchor w
    pack [frame .$h.f \
		-bd 2 \
		-bg  #00f] \
			-pady 2
    pack [label .$h.f.l \
		-text "Send Command To PM on Card #"\
		-bg #8dd ] \
			-side left \
			-padx 2
    pack [entry .$h.f.e -textvariable cardnum \
		 -width 4\
		-relief sunken \
		-bg #aff  \
		-highlightcolor #f00 \
		-highlightbackground #8dd \
		-selectbackground #0ff        ] \
			-side left
    pack [frame .$h.s -bd 2 -bg #00f] \
		-pady 2 \
		-padx 4 \
		-side top
    label .$h.s.lch -text "Chanel Mask" \
		-bg #8dd
    entry .$h.s.ech -textvariable chan \
		-width 7\
		-relief sunken \
		-bg #aff  \
		-highlightcolor #f00 \
		-highlightbackground #8dd \
		-selectbackground #0ff
    label .$h.s.lad -text "Address/Tag" \
		-bg #8dd
    entry .$h.s.ead -textvariable tag \
		-width 4\
		-relief sunken \
		-bg #aff  \
		-highlightcolor #f00 \
		-highlightbackground #8dd \
		-selectbackground #0ff
    pack .$h.s.lch .$h.s.ech  -padx 2 -side left -in .$h.s 
    pack  .$h.s.lad .$h.s.ead -padx 2 -side left -in .$h.s 

    pack [  frame .$h.data -bd 2 -bg #00f] -pady 2 -side top
    pack [  label .$h.data.l -text "32 one-byte entries, separate by spaces:" \
		-bg #aff]\
			-side top  \
			-in .$h.data  \
			-pady 1
    label .$h.data.l1 \
		-text "First 8 bytes:"\
		-bg #8dd

    set chip_data1 "0 0 0 0 0 0 0 0"
    set chip_data2 "0 0 0 0 0 0 0 0"
    set chip_data3 "0 0 0 0 0 0 0 0"
    set chip_data4 "0 0 0 0 0 0 0 0"
    	

    entry .$h.data.e1 -textvariable chip_data1 \
		-width 24\
		-relief sunken \
		-bg #aff  \
		-highlightcolor #f00 \
		-highlightbackground #8dd \
		-selectbackground #0ff
    label .$h.data.l2 -text "Second 8 bytes"\
		-bg #8dd

    entry .$h.data.e2 -textvariable chip_data2 \
		-width 24\
		-relief sunken \
		-bg #aff  \
		-highlightcolor #f00 \
		-highlightbackground #8dd \
		-selectbackground #0ff
    label .$h.data.l3 -text "Third 8 bytes:"\
		-bg #8dd

    entry .$h.data.e3 -textvariable chip_data3 \
		-width 24\
		-relief sunken \
		-bg #aff  \
		-highlightcolor #f00 \
		-highlightbackground #8dd \
		-selectbackground #0ff
    label .$h.data.l4 -text "Fourth 8 bytes:"\
		-bg #8dd

    entry .$h.data.e4 -textvariable chip_data4 \
		-width 24\
		-relief sunken \
		-bg #aff  \
		-highlightcolor #f00 \
		-highlightbackground #8dd \
		-selectbackground #0ff

    pack	.$h.data.l1 \
		.$h.data.e1 \
		.$h.data.l2 \
		.$h.data.e2 \
		.$h.data.l3 \
		.$h.data.e3 \
		.$h.data.l4 \
		.$h.data.e4 \
			-pady 1 \
			-side top \
			-in .$h.data 

    set s $t.cmd
    pack [frame .$s -bg #00f ] -side top


#
# inputs are: card#, opcode, address (4bit), chanel mask, bytecount, direction, data
#Opcodes are sent least significant bit first (of 5).
#

    pack [button .$s.b0 -text "No Op" \
		-relief raised  \
		-bd 2  \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0\
		-command {
	set chip_data 0
	set chip_data "$chip_data1 $chip_data2 $chip_data3 $chip_data4"
	for { set ii 0 } {$ii < 1000000} {incr ii 1} {
	vme_pmCommand $cardnum 0 $tag $chan 0 0 $chip_data}}] -fill x    

    pack [button .$s.b1 -text "Clear Readout" \
		-relief raised  \
		-bd 2  \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0\
		-command {
	set chip_data 0
	set chip_data "$chip_data1 $chip_data2 $chip_data3 $chip_data4"
	vme_pmCommand $cardnum 0x10 $tag $chan 0 0 $chip_data}] -fill x   

    pack [button .$s.b2 -text "Synch" \
		-relief raised  \
		-bd 2  \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0\
		-command {
	set chip_data 0
	set chip_data "$chip_data1 $chip_data2 $chip_data3 $chip_data4"
	vme_pmCommand $cardnum 0x8 $tag $chan 0 0 $chip_data}] -fill x    

    pack [button .$s.b3 -text "L1 Trigger Accept" \
		-relief raised  \
		-bd 2  \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0\
		-command {
	set chip_data 0
	set chip_data "$chip_data1 $chip_data2 $chip_data3 $chip_data4"
	vme_pmCommand $cardnum 0x18 $tag $chan 0 0 $chip_data}] -fill x  

    pack [button .$s.b4 -text "Read Event" \
		-relief raised  \
		-bd 2  \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0\
		-command {
	set chip_data 0
	set chip_data "$chip_data1 $chip_data2 $chip_data3 $chip_data4"
	vme_pmCommand $cardnum 0x4 $tag $chan 0x304 0 $chip_data}] -fill x 

###^^^Enough room for THREE (3) chips (for testing purposes)^^^###

    pack [button .$s.b5 -text "Calibration Strobe" \
		-relief raised  \
		-bd 2  \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0\
		-command {
	set chip_data 0
	set chip_data "$chip_data1 $chip_data2 $chip_data3 $chip_data4"
	vme_pmCommand $cardnum 0x14 $tag $chan 0 0 $chip_data}] -fill x  

    pack [button .$s.b6 -text "Write Control Register" \
		-relief raised  \
		-bd 2  \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0\
		-command {
	set chip_data 0
	set chip_data "$chip_data1 $chip_data2 $chip_data3 $chip_data4"
	vme_pmCommand $cardnum 0x1b $tag $chan 4 1 $chip_data}] -fill x

    pack [button .$s.b7 -text "Write Calibration and Mask Register" \
		-relief raised  \
		-bd 2  \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0\
		-command {
	set chip_data 0
	set chip_data "$chip_data1 $chip_data2 $chip_data3 $chip_data4"
	vme_pmCommand $cardnum 0x7 $tag $chan 32 1 $chip_data}]  -fill x
#######
###### Nev loop
#######

    label .$s.wnev -text "Nr. of Loop event:"\
		-bg #8dd
    set nev 0

    entry .$s.nev -textvariable nev \
		-width 7\
		-relief sunken \
		-bg #aff  \
		-highlightcolor #f00 \
		-highlightbackground #8dd \
		-selectbackground #0ff
                
    pack .$s.wnev \
         .$s.nev \
	 -pady 1 \
	 -side top 
 
        pack [button .$s.b8 -text "Start Loop on write ctrl Registers" \
		-relief raised  \
		-bd 2  \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0\
		-command {
	set chip_data 0
	set chip_data "$chip_data1 $chip_data2 $chip_data3 $chip_data4"
	for { set ii 0 } {$ii < $nev} {incr ii 1} {
	    vme_pmCommand $cardnum 0x1b $tag $chan 4 1 $chip_data}}] -fill x
 
    pack [button .$s.b9 -text "Master Reset" \
		-relief raised  \
		-bd 2  \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0\
		-command {
	set chip_data 0
	set chip_data "$chip_data1 $chip_data2 $chip_data3 $chip_data4"
	vme_pmCommand $cardnum 0xF $tag $chan 0 0 $chip_data}] -fill x  

	}
    }
