/*********************************************************/
/* Dump event to file check.txt                          */
/* flag = 0 if it is begin run record                    */
/* Returns zero if okay                                  */
/*********************************************************/

#include "cal_svtdef.h"
#include "tk.h"
#include <stdio.h>
#include "error.h"
#include "reglist.h"
#include "cal_global.h"
#include "cal_functions.h"
#include "opcodes.h"

int get_bit(int, int);

int cal_dump(int flag, FILE* fp) {

static int its_xy;
int mask,ichip,itemp,fchip;
int dummy, ishift, i, j, k, ibit, status;
int event_number;
int nbytes, header, hit;
int nchips;
static int nchips_top;
int temp;
int count,ix,iy,ixp,iyp;
int begin_data[MAX_NUM_CHIP];
int end_data[MAX_NUM_CHIP];
char byte;
int chnum, tot, tstamp, nrun;
int address, event_data, trcount, trtstamp, startbit;
unsigned int crap;
int bithi[4] = {31, 63, 95, 127};
int bitlo[4] = {0,  32, 64,  96};
int int_byte;
int jshift, this_shift;
int new_temp[MAX_NUM_CHIP][4];
int cr[MAX_NUM_CHIP];
static int local_ignored_chip[MAX_NUM_CHIP];
static nignored;
/*--------------------------------------------------------------------*/
/* Open the file                                                      */
/*--------------------------------------------------------------------*/
/*  if (fp == NULL) {                                                 */
/*    fp = fopen("check.txt","w");                                    */
/*  }                                                                 */
/*--------------------------------------------------------------------*/
/* if the file is NULL, exit                                          */
/*--------------------------------------------------------------------*/
   if (fp == NULL) return 0;
/*--------------------------------------------------------------------*/
/* If flag = 10, close the file                                       */
/*--------------------------------------------------------------------*/
  if (flag == 10 && fp != stdout) {
      if (fp != NULL) {
	  fclose(fp);
          fp = NULL;
      }
      return 0;
  }
/*--------------------------------------------------------------------*/
/* Event number, number of bytes, number of chips                     */
/*--------------------------------------------------------------------*/
  dummy  = cal_extract(1,&nbytes,cal_data_point);
  dummy  = cal_extract(1,&nrun,(cal_data_point+4));

  if (flag != 0) {
     dummy  = cal_extract(1,&event_number,(cal_data_point+8));
     nchips     = (int) *(cal_data_point+12);
     nchips = nchips & 0xff;
     ishift = 13;
     fprintf(fp,"\n********* Event Dump ******************************\n");
     status = fflush(fp);
     if (nchips_top != 0) {
       fprintf(fp,
     "Event no. %d Run no. %d No. bytes %d No. chips %d No. chips top %d \n\n",
	       event_number,nrun,nbytes,nchips,nchips_top);
     } else {
       fprintf(fp,
     "Event no. %d Run no. %d No. bytes %d No. chips %d \n\n",
	       event_number,nrun,nbytes,nchips);
     }
     status = fflush(fp);
     fprintf(fp," \n");
     status = fflush(fp);
   } else {
     for (i=0; i<MAX_NUM_CHIP; i++) {
       local_ignored_chip[i] = 0;
     } 
     nignored = 0;
     nchips     = (int) *(cal_data_point+8);
     nchips     = nchips & 0xff;
     nchips_top = (int) *(cal_data_point+10);
     nchips_top = nchips_top & 0xff;
     ishift = 9;
     fprintf(fp,"********* Begin run Dump **************************\n");
     status = fflush(fp);
     if (nchips_top == 0) {
       fprintf(fp,"Run no. %d No. of chips %d \n",nrun,nchips);
     } else {
       fprintf(fp,"Run no. %d No. of chips %d No. of chips top %d \n",
	       nrun,nchips,nchips_top);
     }
     status = fflush(fp);
     fprintf(fp,"--------------------- 128 bytes -------------------\n");
     status = fflush(fp);
     for (i=0; i<128; i++) {
       if (i != 0 && i%16 == 0) {
	 fprintf(fp,"\n");
	 fflush(fp);
       }
       fprintf(fp,"%2x ",*(cal_data_point+ishift));
       status = fflush(fp);

/* extract the mask of ignored chips on the fly          */
/* also count them                                       */
       if (i>1 && i<5) {
	 mask = *(cal_data_point+ishift) & 0xff;
         fchip = 8*(i-2);
	 for (ichip = fchip; ichip< (fchip+8); ichip++) {
	   if (ichip > nchips) break;
	       itemp = 1;
	       if (ichip != fchip) itemp = itemp << (ichip-fchip);
	       if ( (mask&itemp) != 0) {
		 local_ignored_chip[ichip]=1;
		 nignored++;
	       }
	 }
       }


       ishift++;
     }
     fprintf(fp,"\n---------------------------------------------------");
     status = fflush(fp);



   }
/*--------------------------------------------------------------------*/
/* If this is a begin run record decode the user bits, and get out    */
/* NB actually the list of ignored chips has already been extracted   */
/*--------------------------------------------------------------------*/
  if (flag == 0) {
    dummy = (int) *(cal_data_point+9);
    if ( (dummy & 0x1) != 0) {
      its_xy = 1;
      fprintf(fp,"\n This IS an XY scan run");
      status = fflush(fp);
    } else {
      its_xy = 0;
      fprintf(fp,"\n This is NOT an XY scan run");
      status = fflush(fp);
    }
    if ( (dummy & 0x2) != 0) {
      fprintf(fp,"\n These data were originally compressed");
      status = fflush(fp);
    }
    if (nignored != 0) {
      fprintf(fp,"\n Data from the following chips was ignored.. \n Chips: ");
      for (ichip=0; ichip<nchips; ichip++) {
	  if (local_ignored_chip[ichip] == 1) fprintf(fp,"%d  - ",ichip);
	}
    }
    fprintf(fp,"\n********* End of Begin run Dump ********************\n");
    status = fflush(fp);
    return 0;
  }
/*--------------------------------------------------------------------*/
/* Dump control registers                                             */
/*--------------------------------------------------------------------*/
  if (flag != 0) {
     fprintf(fp," --------------------------------- \n");
     status = fflush(fp);
     fprintf(fp," ---- Control registers (hex) ---- \n");
     status = fflush(fp);
     fprintf(fp," --------------------------------- \n");
     status = fflush(fp);
     for (i=0; i<nchips; i++) {
       dummy = cal_extract(1,&temp,(cal_data_point+ishift));
       cr[i] = temp;
       fprintf(fp,"Chip %d Control register %x \n",i,temp);
       status = fflush(fp);
       ishift = ishift + 4;
     }
  }
  fprintf(fp,"\n");
  status = fflush(fp);
  fprintf(fp,"Chip ThrDAC CalDAC Jitter ShapTime SampRate Skip Dir Read ClkTru Test   ClkB\n");
  status = fflush(fp);
  fprintf(fp,"-------------------------------------------------------------------------------\n");
  status = fflush(fp);
  for (i=0; i<nchips; i++) {
    fprintf(fp,"%2d     ",i);
    status = fflush(fp);
    fprintf(fp,"%2d    ",(cr[i]&0x3f));               /* thr dac */
    status = fflush(fp);
    fprintf(fp,"%2d      ", ((cr[i]>>6)&0x3f));          /* cal dac */
    status = fflush(fp);
    fprintf(fp,"%2d   ",Gc_to_bin((cr[i]>>12)&0x1f)); /* jitter  */
    status = fflush(fp);
    temp = (cr[i]>>17) & 0x3;
    fprintf(fp,"%3d nsec  ",100*(temp+1));             /* shaping */
    status = fflush(fp);
    temp = (cr[i]>>19) & 0x3;
    if (temp == 0) fprintf(fp,"30 MHZ   ");
    if (temp == 1) fprintf(fp,"20 MHZ   ");
    if (temp == 2) fprintf(fp,"15 MHZ   ");
    if (temp == 3) fprintf(fp,"NOWrite  ");             /* sampling */
    status = fflush(fp);
    temp = (cr[i]>>21) & 0x3;
    if (temp == 0) fprintf(fp,"no   ");
    if (temp == 1) fprintf(fp,"2nd  ");
    if (temp == 2) fprintf(fp,"3rd  ");
    if (temp == 3) fprintf(fp,"4th  ");                /* skip control */
    status = fflush(fp);
    temp = (cr[i]>>23) & 0x1;
    if (temp == 0) fprintf(fp,"L    ");
    if (temp == 1) fprintf(fp,"R    ");                 /* direction */
    status = fflush(fp);
    temp = (cr[i]>>24) & 0x1;
    if (temp == 0) fprintf(fp,"N    ");
    if (temp == 1) fprintf(fp,"Y    ");                 /* respond to read */
    status = fflush(fp);
    temp = (cr[i]>>25) & 0x1;
    if (temp == 0) fprintf(fp,"N   ");
    if (temp == 1) fprintf(fp,"Y   ");                 /* clock through */
    status = fflush(fp);
    temp = (cr[i]>>26) & 0xf;
    if (temp > 7) fprintf(fp,"0x%4x ",temp);
    if (temp>3 && temp<8) fprintf(fp,"0x0%3x ",temp);
    if (temp>1 && temp<4) fprintf(fp,"0x00%2x ",temp);
    if (temp<2) fprintf(fp,"0x000%1x ",temp);         /* pattern */
    status = fflush(fp);
    temp = (cr[i]>>30) & 0x1;
    if (temp == 0) fprintf(fp,"  N");
    if (temp == 1) fprintf(fp,"  Y");                 /* clock B */
    status = fflush(fp);

    fprintf(fp,"\n");
    status = fflush(fp);
  }
/*--------------------------------------------------------------------*/
/* Dump calibration masks                                             */
/*--------------------------------------------------------------------*/
  if (flag != 0) {
     fprintf(fp,"\n                             Calibration masks\n");
     for (i=0; i<nchips; i++) {
       status = fflush(fp);
       for (j=0; j<4; j++) {
          dummy = cal_extract(1,&temp,(cal_data_point+ishift));
          new_temp[i][j] = temp;
          ishift = ishift + 4;
        }
     }
     fprintf(fp,"---------------------------------------------------------------------------\n");
     status = fflush(fp);
     fprintf(fp,"                          1       2       3       4       4       5      6\n");
     status = fflush(fp);
     fprintf(fp,"channel   0       8       6       4       2       0       8       6      3\n");
     status = fflush(fp);
     fprintf(fp,"---------------------------------------------------------------------------");
     for (i=0; i<nchips; i++) {
       if (i > 9) fprintf(fp,"\nChip %d   ",i);
       if (i < 10) fprintf(fp,"\nChip  %d   ",i);
       status = fflush(fp);
       for (k=0; k<64; k++) {
         j    = k/32;
         ibit = k - 32*j;
         fprintf(fp,"%d",get_bit(new_temp[i][j],ibit));
         status = fflush(fp);
       }    
     }
     fprintf(fp,"\n");
     status = fflush(fp);
     fprintf(fp,"---------------------------------------------------------------------------\n");
     status = fflush(fp);
     fprintf(fp,"                                                  1       1       1      1\n");
     status = fflush(fp);
     fprintf(fp,"          6       7       8       8       9       0       1       2      2\n");
     status = fflush(fp);
     fprintf(fp,"channel   4       2       0       8       6       4       2       0      7\n");
     status = fflush(fp);
     fprintf(fp,"---------------------------------------------------------------------------");
     status = fflush(fp);
     for (i=0; i<nchips; i++) {
       if (i > 9) fprintf(fp,"\nChip %d   ",i);
       if (i < 10) fprintf(fp,"\nChip  %d   ",i);
       status = fflush(fp);
       for (k=64; k<128; k++) {
         j    = k/32;
         ibit = k - 32*j;
         fprintf(fp,"%d",get_bit(new_temp[i][j],ibit));
         status = fflush(fp);
       }    
     }
   }
   fprintf(fp,"\n\n\n");
   status = fflush(fp);
/*--------------------------------------------------------------------*/
/* Dump channel masks                                             */
/*--------------------------------------------------------------------*/
  if (flag != 0) {
     fprintf(fp,"\n                             Channel masks\n");
     status = fflush(fp);
     for (i=0; i<nchips; i++) {
       for (j=0; j<4; j++) {
          dummy = cal_extract(1,&temp,(cal_data_point+ishift));
          new_temp[i][j] = temp;
          ishift = ishift + 4;
        }
     }
     fprintf(fp,"---------------------------------------------------------------------------\n");
     status = fflush(fp);
     fprintf(fp,"                          1       2       3       4       4       5      6\n");
     status = fflush(fp);
     fprintf(fp,"channel   0       8       6       4       2       0       8       6      3\n");
     status = fflush(fp);
     fprintf(fp,"---------------------------------------------------------------------------");
     for (i=0; i<nchips; i++) {
       if (i > 9) fprintf(fp,"\nChip %d   ",i);
       if (i < 10) fprintf(fp,"\nChip  %d   ",i);
       status = fflush(fp);
       for (k=0; k<64; k++) {
         j    = k/32;
         ibit = k - 32*j;
         fprintf(fp,"%d",get_bit(new_temp[i][j],ibit));
         status = fflush(fp);
       }    
     }
     fprintf(fp,"\n");
     status = fflush(fp);
     fprintf(fp,"---------------------------------------------------------------------------\n");
     status = fflush(fp);
     fprintf(fp,"                                                  1       1       1      1\n");
     status = fflush(fp);
     fprintf(fp,"          6       7       8       8       9       0       1       2      2\n");
     status = fflush(fp);
     fprintf(fp,"channel   4       2       0       8       6       4       2       0      7\n");
     status = fflush(fp);
     fprintf(fp,"---------------------------------------------------------------------------");
     for (i=0; i<nchips; i++) {
       if (i > 9) fprintf(fp,"\nChip %d   ",i);
       if (i < 10) fprintf(fp,"\nChip  %d   ",i);
       status = fflush(fp);
       for (k=64; k<128; k++) {
         j    = k/32;
         ibit = k - 32*j;
         fprintf(fp,"%d",get_bit(new_temp[i][j],ibit));
         status = fflush(fp);
       }    
     }
   }
   fprintf(fp,"\n\n\n");
   status = fflush(fp);
/*--------------------------------------------------------------------*/
/* Get data pointers for chips                                        */
/*--------------------------------------------------------------------*/
  for (i=0; i<nchips; i++) {
    dummy = cal_extract(1,&temp,(cal_data_point+ishift));
    begin_data[i] = temp;
    ishift = ishift + 4;
  }
  for (i=0; i<nchips; i++) {
    dummy = cal_extract(1,&temp,(cal_data_point+ishift));
    end_data[i] = temp;
    ishift = ishift + 4;
  } 
/*--------------------------------------------------------------------*/
/* xy dump                                                            */
/*--------------------------------------------------------------------*/
  if (its_xy == 1) {
     fprintf(fp," --------------------------------- \n");
     status = fflush(fp);
     fprintf(fp," ----- Coordinates --------------- \n");
     status = fflush(fp);
     fprintf(fp," --------------------------------- \n");
     status = fflush(fp);
     ixp = begin_data[0] - 8;
     iyp = begin_data[0] - 4;
     dummy = cal_extract(1,&ix,(cal_data_point+ixp));
     dummy = cal_extract(1,&iy,(cal_data_point+iyp));
     fprintf(fp," X = %d   Y = %d  (micron) \n",ix,iy);
     status = fflush(fp);
     fprintf(fp," --------------------------------- \n\n");
     status = fflush(fp);
  }  
/*--------------------------------------------------------------------*/
/* Chip data dump                                                     */
/*--------------------------------------------------------------------*/
  fprintf(fp," --------------------------------- \n");
  status = fflush(fp);
  fprintf(fp," ---------- Chip data ------------ \n");
  status = fflush(fp);
  fprintf(fp," --------------------------------- \n");
  status = fflush(fp);
  for (i=0; i<nchips; i++) {
    fprintf(fp,"\nChip %2d: ",i);
    status = fflush(fp);
    count = 0;
    for (j=begin_data[i]; j<=end_data[i]; j++) {
      if (count == 20) {
	count = 0;
	fprintf(fp,"\n         ");
        status = fflush(fp);
      } 
      byte = *(cal_data_point+j);
      int_byte = (unsigned int) byte;
      int_byte = int_byte & 0xff;
      fprintf(fp,"%2x ",int_byte);
      status = fflush(fp);
      count++;
    }
  }
/*--------------------------------------------------------------------*/
/* Get the headers                                                    */
/*--------------------------------------------------------------------*/
 fprintf(fp,"\n");
 status = fflush(fp);
 fprintf(fp,"\n");
 status = fflush(fp);
 fprintf(fp,"----------------------- Headers ---------------------------\n");
 status = fflush(fp);
 fprintf(fp,"Chip  Address Sbit Data/Status  TrigCount   TrigTimeStamp  \n");
 status = fflush(fp);
 fprintf(fp,"-----------------------------------------------------------\n");
 status = fflush(fp);
 for (i=0; i<nchips; i++) {
    jshift = begin_data[i];
    cal_get_header(cal_data_point, jshift, &startbit, &address, &event_data, 
		   &trcount, &trtstamp);
    fprintf(fp,
     "%2d      %2d     %1d       %1d         %3d           %3d\n",
     i,address,startbit,event_data,trcount,trtstamp);
     status = fflush(fp);
}
 fprintf(fp,"-----------------------------------------------------------\n");
 status = fflush(fp);
/*--------------------------------------------------------------------*/
/* now get all of the hits                                            */
/*--------------------------------------------------------------------*/
 fprintf(fp,"\n");
 status = fflush(fp);
 fprintf(fp,"--------- Hits -----------------\n");
 status = fflush(fp);
 fprintf(fp,"Chip   Channel   TimeStamp   TOT\n");
 status = fflush(fp);
 fprintf(fp,"--------------------------------\n");
 status = fflush(fp);
 for (i=0; i<nchips; i++) {
    ishift = begin_data[i] + 2;
    while ( (ishift+2) < end_data[i]) {
      cal_get_hit(cal_data_point, ishift, &chnum, &tot, &tstamp);
      fprintf(fp,"%2d      %3d       %3d       %3d\n",i,chnum,tstamp,tot);
      status = fflush(fp);
      ishift = ishift + 2;
    }
  }   
 fprintf(fp,"--------------------------------\n");
 status = fflush(fp);
/*--------------------------------------------------------------------*/
/* Done                                                               */
/*--------------------------------------------------------------------*/
  return 0;
}
/*--------------------------------------------------------------------*/
/* utility for bit extraction                                         */
/*--------------------------------------------------------------------*/
int get_bit(int var, int bit) {
int mask, temp;
   mask = 1;
   if (bit != 0) mask = mask << bit;
   temp = var & mask;
   if (temp != 0) temp=1;
   return temp;
}

