#define HS_TYPES_DEFINED

typedef enum _hsItemType {
    HS_1D_HISTOGRAM, HS_2D_HISTOGRAM, HS_NTUPLE, HS_INDICATOR, HS_CONTROL,
    HS_TRIGGER, HS_NONE
} hsItemType;

typedef enum _hsErrorType {
    HS_NO_ERRORS, HS_POS_ERRORS, HS_BOTH_ERRORS, HS_ITEMNOTFOUND_ERRORS
} hsErrorType;

void hs_initialize(char *id_string) {}
void hs_update(void) {}
void hs_complete(void) {}
void hs_complete_and_wait(void) {}
void hs_histoscope(int return_immediately) {}
int hs_create_1d_hist(int uid, char *title, char *category,
                        char *x_label, char *y_label,
                        int n_bins, float min, float max) { return (int)0; }
int hs_create_2d_hist(int uid, char *title, char *category,
                        char *x_label, char *y_label,
                        char *z_label, int x_bins, int y_bins, float x_min,
                        float x_max, float y_min, float y_max) { return (int)0;
}
int hs_create_ntuple(int uid, char *title, char *category,
                         int n_variables,char **names) { return (int)0; }
int hs_create_indicator(int uid, char *title, char *category,
                         float min, float max) { return (int)0; }
int hs_create_control(int uid, char *title, char *category,
                        float min, float max, float default_value) { return (int
)0; }
int hs_create_trigger(int uid, char *title, char *category) { return (int)0; }
void hs_fill_1d_hist(int id, float x, float weight) {}
void hs_fill_2d_hist(int id, float x, float y, float weight) {}
int hs_fill_ntuple(int id, float *values) { return (int)0; }
void hs_set_indicator(int id, float value) {}
void hs_read_control(int id, float *value) {}
int hs_check_trigger(int id) { return (int)0; }
void hs_set_1d_errors(int id, float *err_valsP, float *err_valsM) {}
void hs_set_2d_errors(int id, float *err_valsP, float *err_valsM) {}
void hs_reset(int id) {}
int hs_save_file(char *name) { return (int)0; }
void hs_delete(int id) {}
void hs_hbook_setup(char *topDirectory) {}
void hs_reset_hbook_setup(char *topDirectory) {}
/***** API for HistoScope Client/Users. *****/
void hs_change_uid(int id, int newuid) {}
void hs_change_category(int id, char *newcategory) {}
void hs_change_title(int id, char *newtitle) {}
int hs_id(int uid, char *category) { return (int)0; }
int hs_id_from_title(char *title, char *category) { return (int)0; }
int hs_list_items(char *title, char * category, int *ids, int num,
                  int matchFlg) { return (int)0; }
int hs_uid(int id) { return (int)0; }
int hs_category(int id, char *category_string) { return (int)0; }
int hs_title(int id, char *title_string) { return (int)0; }
int hs_type(int id) { return (int)0; }
int hs_read_file(char *filename, char *prefix) { return (int)0; }
int hs_read_file_items(char *filename, char *prefix, char *category,
        int *uids, int n_uids) { return (int)0; }
int hs_save_file_items(char *filename, char *category,
        int *uids, int n_uids) { return (int)0; }
void hs_delete_category(char *category) {}
int hs_num_items(void) { return (int)0; }
void hs_1d_hist_block_fill(int id, float *data, float *err, float *err_m) {}
void hs_2d_hist_block_fill(int id, float *data, float *err, float *err_m) {}
int hs_1d_hist_num_bins(int id) { return (int)0; }
void hs_2d_hist_num_bins(int id, int *num_x_bins, int *num_y_bins) {}
void hs_1d_hist_range(int id, float *min, float *max) {}
void hs_2d_hist_range(int id, float *x_min, float *x_max, float *y_min,
        float *y_max) {}
int hs_num_entries(int id) { return (int)0; }
void hs_1d_hist_bin_contents(int id, float *data) {}
int hs_1d_hist_errors(int id, float *err, float *err_m) { return (int)0; }
void hs_2d_hist_bin_contents(int id, float *data) {}
int hs_2d_hist_errors(int id, float *err, float *err_m) { return (int)0; }
void hs_1d_hist_overflows(int id, float *underflow, float *overflow) {}
void hs_2d_hist_overflows(int id, float *overflows) {}
float hs_1d_hist_x_value(int id, float x) {return (float)0; }
float hs_2d_hist_xy_value(int id, float x, float y) {return (float)0; }
float hs_1d_hist_bin_value(int id, int bin_num) {return (float)0; }
float hs_2d_hist_bin_value(int id, int x_bin_num, int y_bin_num) {return (float)
0; }
void hs_1d_hist_minimum(int id, float *x, int *bin_num, float *value) {}
void hs_2d_hist_minimum(int id, float *x, float *y, int *x_bin_num,
        int *y_bin_num, float *value) {}
void hs_1d_hist_maximum(int id, float *x, int *bin_num, float *value) {}
void hs_2d_hist_maximum(int id, float *x, float *y, int *x_bin_num,
        int *y_bin_num, float *value) {}
void hs_1d_hist_stats(int id, float *mean, float *std_dev) {}
void hs_2d_hist_stats(int id, float *x_mean, float *y_mean, float *x_std_dev,
        float *y_std_dev) {}
float hs_hist_integral(int id) {return (float)0; }
void hs_hist_set_gauss_errors(int id) {}
int hs_sum_histograms(int uid, char *title, char *category,
                      int id1, int id2, float const1, float const2) { return (in
t)0; }
int hs_multiply_histograms(int uid, char *title, char *category,
                           int id1, int id2, float consta) { return (int)0; }
int  hs_divide_histograms(int uid, char *title, char *category,
                          int id1, int id2, float consta) { return (int)0; }
int hs_1d_hist_derivative(int uid, char *title, char *category, int id) { return
 (int)0; }
int hs_num_variables(int id) { return (int)0; }
int hs_variable_name(int id, int column, char *name) { return (int)0; }
int hs_variable_index(int id, char *name) { return (int)0; }
float hs_ntuple_value(int id, int row, int column) {return (float)0; }
void hs_ntuple_contents(int id, float *data) {}
void hs_row_contents(int id, int row, float *data) {}
void hs_column_contents(int id, int column, float *data) {}
int hs_merge_entries(int uid, char *title, char *category,
                                           int id1, int id2) { return (int)0; }
void hs_sum_category(char *cat_top1, char *cat_top2, char *prefixsum) {}
void hs_sum_file(char *file, char *cat_top, char *prefixsum) {}

