#include "cal_svtdef.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "error.h"
#include "reglist.h"
#include "tk.h"
#include "opcodes.h"
#include "cal_global.h"
#include "cal_functions.h"
#include <histoscope.h>
#include "cal_format_check.h"


#define TRUE 1
#define MIN -3
#define MAX 3
#define NHIST (MAX-MIN+1)
#define NUM_CHIP_CHANNELS 128
#define MAX_TOTAL_NUMBER_OF_CHANNELS NUM_CHIP_CHANNELS*MAX_NUM_CHIP

char* Cal_unpack_array(Tcl_Interp*, char*, char*);
void short_display_message(Tcl_Interp*, char*);
int cal_side(int);


static int shorts_testCmd(ClientData clientData, Tcl_Interp* interp, 
			int argc, char* argv[]) {

static char *sanity_check;
int sanity_flag;
static char msg3[] = "cal_close_histoscope_connection";
int fired_channel, this_channel, dfa_channel, i88;
int number_of_faults[NHIST][MAX_TOTAL_NUMBER_OF_CHANNELS];
int look_at_it[NHIST];
int id[NHIST*(MAX_NUM_CHIP+1)];
int nb_chan, nb_chip;
int dummy, i, j, k, ichip, ibit, ichan, pm_ch_mask, i87, hist_num;
int chip_address, pm_chan, event_number, ishift, data_len;
int min_chip, max_chip, short_thresh;
int  short_charge_top, short_charge_bottom, short_nrep;
int begin_data[MAX_NUM_CHIP], end_data[MAX_NUM_CHIP];
int itemp, nhits, chnum, tot, tstamp, this_chip, ihit, irep, bad;
char message[200];
FILE* fp;
char temp[100];
char* C_min_chip;
char* C_max_chip;
char* C_short_thresh;
char* C_short_charge_top;
char* C_short_charge_bottom;
char* C_dummy;
char* C_short_nrep;
char index[100];
char title[200];
char event_message[200];
static char command[200];
static char* command_result;
vme_rc rc;
static char*  eventseq_result;


static char cmd10[] = ".pltw.text insert end \"Done...\n\"";
static char cmd1[]  = "make_pltw_widget";
static char cmd3[]  = ".pltw.text insert end \" \n \n ************ Begin testing *********** \n\"";
static char cmd4[]  = ".pltw.text insert end \" Now setting up personality module and hybrid.....\n\"";
static char cmd110[]= "vme_clear daq_0(led)";
static char cmd111[]= "vme_set daq_0(led)";
static char abort[] = "Aborting.....";
static char cmd21[] = "disconnect_histoscope";
/*-----------------------------------------------------*/
/* Make sure call has right number of arguments        */
/*-----------------------------------------------------*/
 if (argc != 1) {
   interp->result = "wrong number of arguments";
   return TCL_ERROR;
 }
 event_number = 0;
/*------------------------------------------------------------------------*/
/* Open the output file                                                   */
/*------------------------------------------------------------------------*/
 sprintf(command,"misc_file_handler 5 0");
 dummy = Tcl_GlobalEval(interp,command);
 if (strcmp(interp->result,"OK") != 0) {
   sprintf(event_message,"%s",interp->result);
   short_display_message(interp,event_message);
   short_display_message(interp,abort);
   return TCL_OK;
 }
/*---------------------------------------------------------*/
/* zero the number_of_faults counter.                      */
/*---------------------------------------------------------*/
 for (i=0; i<NHIST; i++) {
   for (j=0; j<MAX_TOTAL_NUMBER_OF_CHANNELS; j++) {
     number_of_faults[i][j] = 0;
   }
 }
/*---------------------------------------------------------*/
/* make sure that the text widget exists, if not make it   */
/*---------------------------------------------------------*/
  dummy = Tcl_Eval(interp,cmd1);
/*---------------------------------------------------------*/
/* Display begin mesage                                    */
/*---------------------------------------------------------*/
  sprintf(event_message,"Begin test for shorts");
  short_display_message(interp, event_message);
/*---------------------------------------------------------*/
/* unpack variables that we need                           */
/*---------------------------------------------------------*/
  Cal_unpack_variables(interp);
  C_min_chip              = Tcl_GetVar(interp, "short_min_chip" , 0);
  C_max_chip              = Tcl_GetVar(interp, "short_max_chip" , 0);
  C_short_thresh          = Tcl_GetVar(interp, "short_thresh"   , 0);
  C_short_charge_top      = Tcl_GetVar(interp, "short_charge_top"   , 0);
  C_short_charge_bottom   = Tcl_GetVar(interp, "short_charge_bottom"   , 0);
  C_short_nrep            = Tcl_GetVar(interp, "short_nrep" , 0);
  dummy   = Tcl_GetInt(interp, C_min_chip,            &min_chip);
  dummy   = Tcl_GetInt(interp, C_max_chip,            &max_chip);
  dummy   = Tcl_GetInt(interp, C_short_thresh,        &short_thresh);
  dummy   = Tcl_GetInt(interp, C_short_charge_top,    &short_charge_top);
  dummy   = Tcl_GetInt(interp, C_short_charge_bottom, &short_charge_top);
  dummy   = Tcl_GetInt(interp, C_short_nrep,          &short_nrep);
  j = -1;
  for (i=MIN; i<MAX+1; i++) {
    j++;
    sprintf(index,"(%d)",i);
    C_dummy = Cal_unpack_array(interp, "short_chan", index);      
    dummy   = Tcl_GetInt(interp, C_dummy, &look_at_it[j]);
  }
/*----------------------------------------------------------------------*/
/* Now book histograms                                                  */
/*----------------------------------------------------------------------*/
/**  hs_initialize("shorts_testCmd.c");                                **/
/**  hs_histoscope(TRUE);                                              **/
/**  for (i=min_chip; i<(max_chip+1); i++) {                           **/
/**    j = -1;                                                         **/
/**    for (k=MIN; k<MAX+1; k++) {                                     **/
/**      j++;                                                          **/
/**      if (look_at_it[j] == 1) {                                     **/
/**         if (k >= 0) {                                              **/
/**	   sprintf(title,"Chip %d..channel +%d",i,k);                  **/
/**	 } else {                                                      **/
/**	   sprintf(title,"Chip %d..channel %d",i,k);                   **/
/**	 }                                                             **/
/**         hist_num = i * NHIST + j;                                  **/
/**         id[hist_num] = hs_create_1d_hist(100+hist_num, title, "",  **/
/**			"Channel number", "Hits",                      **/
/**			NUM_CHIP_CHANNELS, 0, NUM_CHIP_CHANNELS);      **/
/**                                                                    **/
/**       }                                                            **/
/**    }                                                               **/
/**  }                                                                 **/
/**  j = -1;                                                           **/
/**  for (k=MIN; k<MAX+1; k++) {                                       **/
/**    j++;                                                            **/
/**    if (k >= 0) {                                                   **/
/**	sprintf(title,"All chips..channel +%d",k);                     **/
/**    } else {                                                        **/
/**	sprintf(title,"All chips..channel %d",k);                      **/
/**    }                                                               **/
/**    hist_num = (max_chip+1) * NHIST + j;                            **/
/**    id[hist_num] = hs_create_1d_hist(100+hist_num, title, "",       **/
/**	 		   "Channel number", "Hits",                   **/
/**			   (max_chip-min_chip+1)*NUM_CHIP_CHANNELS, 0, **/
/**			   (max_chip-min_chip+1)*NUM_CHIP_CHANNELS);   **/
/**  }                                                                 **/
/**  hs_update();                                                      **/
/*----------------------------------------------------------------------*/
/* setup the DAQ card at the beginning                                  */
/*----------------------------------------------------------------------*/
  command_result = cal_setup_pm(interp);
  if (strcmp(command_result,"OK") != 0) {
     short_display_message(interp, command_result);
     short_display_message(interp, abort);
     goto end_histoscope;
   }
/*-----------------------------------------------------------*/
/* Setup the hybrid at the beginning                         */
/* NB: This does a bunch of "good" things, but it also       */
/*     writes control registers and masks.  That's OK, we'll */
/*     then rewrite these with what we REALLY want           */
/*-----------------------------------------------------------*/
   command_result = cal_setup_hybrid();
   if (strcmp(command_result,"OK") != 0) {
     short_display_message(interp, command_result);
     short_display_message(interp, abort);
     goto end_histoscope;
   }
/*--------------------------------------------------------*/
/* figure out what channels we expect to receive data on  */
/*--------------------------------------------------------*/
      pm_ch_mask = 0;
      for (i87=0; i87<number_of_chips; i87++) {
          cal_get_chip_address(i87,&chip_address,&pm_chan);
          if (ignore[i87] == 0) pm_ch_mask = pm_ch_mask | pm_chan;
      }
/*----------------------------------------------------------*/
/* Now actually write the "correct" control registers       */
/*----------------------------------------------------------*/
  for (ichip=min_chip; ichip<(max_chip+1); ichip++) {
      cal_thresh_dac[ichip] = short_thresh;
      if (number_of_sides == 1 || ichip < (number_of_chips/2)) {
	cal_cal_dac[ichip]    = short_charge_top;
      } else {
	cal_cal_dac[ichip]    = short_charge_bottom;
      }
      build_creg(ichip);
      creg_into_data(ichip);
      rc = cal_write_control_registers(ichip);
        if (rc != VME_OK) {
         sprintf(event_message,"Error sending WRITECTRL command");
         short_display_message(interp, event_message);
         short_display_message(interp, abort);
         goto end_histoscope;
        } 
    }
/*--------------------------------------------------------------------*/
/* Now write all masks to zero                                        */
/*--------------------------------------------------------------------*/
  for (ichip=0; ichip<number_of_chips; ichip++) {
    for (i=0; i<8; i++) {
      calib_mask[ichip][i]   = 0;
      channel_mask[ichip][i] = 0;
    }
    rc = cal_write_masks(ichip);
    if (rc != VME_OK) {
      sprintf(event_message,"Error sending WRITEMASK command");
      short_display_message(interp, event_message);
      short_display_message(interp, abort);
      goto end_histoscope;
    } 
  }
/*===================================================================*/
/* Loop over channels                                                */
/*===================================================================*/
    for (ichan=0; ichan<128; ichan++) {
      sprintf(event_message,"Processing channel %d",ichan);
      short_display_message(interp, event_message);
/*--------------------------------------------------------------------*/
/* Write out the masks                                                */
/* first zero them - then set them in software - then write them      */
/*--------------------------------------------------------------------*/
      for (ichip=min_chip; ichip<(max_chip+1); ichip++) {
	for (i88=0; i88<8; i88++) calib_mask[ichip][i88]=0;
	for (i88=0; i88<8; i88++) channel_mask[ichip][i88]=0;
      }

      for (ichip=min_chip; ichip<(max_chip+1); ichip++) {
	for (i88=0; i88<8; i88++) calib_mask[ichip][i88]=0;
	dummy = cal_mask_manipulate(ichip, ichan, 1, 1, 0);
	fired_channel = 128*ichip + ichan;
	for (i87=(fired_channel+MIN); i87<=(fired_channel+MAX); i87++) {
	  nb_chip = i87/128;
	  nb_chan = i87 - 128*nb_chip;
	  if (nb_chip < 0)                          goto next_i87;
	  if (nb_chip > max_chip)                   goto next_i87;
	  if (cal_side(ichip) != cal_side(nb_chip)) goto next_i87;
	  dummy = cal_mask_manipulate(nb_chip, nb_chan, 0, 1, 0);
	next_i87: {}
	}
      }

      for (ichip=min_chip; ichip<(max_chip+1); ichip++) {
	rc = cal_write_masks(ichip);
	if (rc != VME_OK) {
	  sprintf(event_message,"Error sending WRITEMASK command");
	  short_display_message(interp, event_message);
	  short_display_message(interp, abort);
	  goto end_histoscope;
	}
      }
/*--------------------------------------------------------------------*/
/* Loop over short_nrep                                               */
/*--------------------------------------------------------------------*/
  for (irep=0; irep<short_nrep; irep++) {
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*send noop to toggle VRAM direction. bug fix attempt 10/30/96 Armin     */
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*sp    rc = vmePmCommand(CARD, NOOP, 0, pm_ch_mask, 0, 1, chip_data); sp*/
/*sp    if (rc != VME_OK) {                                            sp*/
/*sp      sprintf(event_message,"Error sending READEVENT");            sp*/
/*sp      short_display_message(interp, event_message);                sp*/
/*sp      short_display_message(interp, abort);                        sp*/
/*sp      goto end_histoscope;                                         sp*/
/*sp    }                                                              sp*/
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Toggle the led bit                                                    */
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*sp    dummy = Tcl_GlobalEval(interp,cmd111);                         sp*/
/*sp    if (rc != VME_OK) {                                            sp*/
/*sp      sprintf(event_message,"Error setting LED bit");              sp*/
/*sp      short_display_message(interp, event_message);                sp*/
/*sp      short_display_message(interp, abort);                        sp*/
/*sp      goto end_histoscope;                                         sp*/
/*sp    }                                                              sp*/
/*sp    dummy = Tcl_GlobalEval(interp,cmd110);                         sp*/
/*sp    if (rc != VME_OK) {                                            sp*/
/*sp      sprintf(event_message,"Error clearing LED bit");             sp*/
/*sp      short_display_message(interp, event_message);                sp*/
/*sp      short_display_message(interp, abort);                        sp*/
/*sp      goto end_histoscope;                                         sp*/
/*sp    }                                                              sp*/
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Send out a READEVENT command to the hybrid                            */
/*  ---- For now set the wordcount at 0xff. It doesnt work with more     */
/*  ---- Oct 22, 1996.  Try to change it to 0xfff, timeout               */
/*       ---> make it longer than 0xff but shorter than 0xfff            */
/* 1-Mar-1997 --> make it 0x800 as in cal_procedure.c                    */
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*sp    rc = vmePmCommand(CARD, READEVENT, 0, pm_ch_mask, 0x800,       sp*/
/*sp        0, chip_data);                                             sp*/
/*sp    if (rc != VME_OK) {                                            sp*/
/*sp      sprintf(event_message,"Error sending READEVENT");            sp*/
/*sp      short_display_message(interp, event_message);                sp*/
/*sp      short_display_message(interp, abort);                        sp*/
/*sp      goto end_histoscope;                                         sp*/
/*sp    }                                                              sp*/
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* The new RPC function which combines in one call all the stuff that     */
/* was commented out above (and much more)....                            */
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
    eventseq_result = EventSeq(CARD, READEVENT, 1, pm_ch_mask,
			       0x800, 0, 1);
    if (strcmp("OK",eventseq_result) != 0) {
      short_display_message(interp, eventseq_result);
      short_display_message(interp, abort);
      goto end_histoscope;
    } 
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Now build the event data                                              */
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
    event_number++;
    command_result = cal_data(interp,&data_len,event_number);
    if (strcmp("OK",command_result) != 0) {
      short_display_message(interp, command_result);
      short_display_message(interp, abort);
      goto end_histoscope;
    } 
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* format check                                                     */
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
    sanity_flag = format_check_flag | (NUMBER_OF_BYTES | CHIP_ADDRESS);
    sanity_check = cal_format_check(cal_data_point, sanity_flag);
    if (strcmp("OK", sanity_check) != 0) {
      short_display_message(interp, sanity_check);
      short_display_message(interp, abort);
      goto end_histoscope;
    }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* Find pointers to begin and end data for chips                    */
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  ishift = 13 + 36 * number_of_chips;
  for (i87=0; i87<number_of_chips; i87++) {
    dummy = cal_extract(1, &itemp, (cal_data_point+ishift));
    begin_data[i87] = itemp;
    ishift = ishift + 4;
  }
  for (i87=0; i87<number_of_chips; i87++) {
    dummy = cal_extract(1, &itemp, (cal_data_point+ishift));
    end_data[i87] = itemp;
    ishift = ishift + 4;
  }
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* Loop over chips and channels that fired                          */
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  for (ichip=min_chip; ichip<(max_chip+1); ichip++) {
    fired_channel = 128*ichip + ichan;
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* Now loop over chips to get the hits                              */
/* NB : 4 bytes = no hits                                           */
/* fill the relevant histograms.  Also fill the number_of_faults    */
/* counter.  Note that for the "+0" histogram this is reverse       */
/* logic for now.  But we will fix it later.                        */
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  for (this_chip=0; this_chip<number_of_chips; this_chip++) {
    nhits = (end_data[this_chip] - begin_data[this_chip] - 3) / 2;
    for (ihit=1; ihit<=nhits; ihit++) {
        ishift = begin_data[this_chip] + 2*ihit;
        cal_get_hit(cal_data_point, ishift, &chnum, &tot, &tstamp);
        this_channel = 128*this_chip + chnum;

        if (abs(ichip-this_chip) > 1)                      goto next_hit;
	if (cal_side(ichip) != cal_side(this_chip))        goto next_hit;
        if ( abs(fired_channel-this_channel) > abs(MIN) &&
             abs(fired_channel-this_channel) > abs(MAX))   goto next_hit;
        j = -1;
        for (k=MIN; k<MAX+1; k++) {
	  j++;
	  if (look_at_it[j] == 1 && (this_channel-fired_channel) == k) {

/**	    hist_num = ichip * NHIST +j;                               **/
/**	    hs_fill_1d_hist(id[hist_num], (float) ichan, 1.);          **/
/**	    hist_num = (max_chip+1) * NHIST + j;                       **/
/**	    hs_fill_1d_hist(id[hist_num], (float) fired_channel, 1.);  **/

	    number_of_faults[j][fired_channel] = 
	      number_of_faults[j][fired_channel] + 1;
	  }
	}

    next_hit: {}
     }
  }
  }
/*--------------------------------------------------------------------*/
/* close the loops...update histoscope                                */
/*--------------------------------------------------------------------*/
/**      hs_update();                                                **/
      free(cal_data_point);
  }     /* close the loop over the number of repetitions */
    }   /* close loop over channels */
/*------------------------------------------------------------*/
/* fixup the reverse logic for the "+0" counter               */
/*------------------------------------------------------------*/
  j = -1;
  for (k=MIN; k<MAX+1; k++) {
    j++;
    if (k==0 && look_at_it[j] == 1) {
      for (ichip=min_chip; ichip<(max_chip+1); ichip++) {
	for (i=0; i<NUM_CHIP_CHANNELS; i++) {
	  this_channel = NUM_CHIP_CHANNELS*ichip + i;
	  number_of_faults[j][this_channel] = short_nrep - 
	              number_of_faults[j][this_channel];
	}
      }
    }
  }

/*-----------------------------------------------------------------*/
/*-----------------------------------------------------------------*/
/* ************* REMOVED 28 january 1998 ************************* */
/* Write out a summary of bad channels to both the widget          */
/* and the file "short_summary.txt"                                */
/* To write to the widget I will use the existing                  */
/* "short_display_message" function.  Note that this function      */
/* already adds a "\n", so there must be additional line breaks    */
/* for the writing to the file.  Messy....                         */
/* ************* REMOVED 28 january 1998 ************************* */
/*-----------------------------------------------------------------*/
/*-----------------------------------------------------------------*/

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* open the file first                                                       */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/*  fp = fopen("short_summary.txt","w");                                     */
/*  if (fp == NULL) {                                                        */
/*    sprintf(message,                                                       */
/*	    "Cannot open file short_summary.txt with list of bad channels"); */
/*    short_display_message(interp, message);                                */
/*  } else {                                                                 */
/*    sprintf(message,                                                       */
/*	    "The following list will also be in file short_summary.txt");    */
/*    short_display_message(interp, message);                                */
/*  }                                                                        */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */


/*------------------------------------------------------------------------*/
/* Set the file pointer to NULL so that short_summary.txt                 */
/* file does not get written out  28 January 1998                         */
/*------------------------------------------------------------------------*/
 fp = NULL;
/*------------------------------------------------------------------------*/
/* Dump the parameters to the file                                        */
/*------------------------------------------------------------------------*/
 sprintf(command,"misc_file_handler 5 2");
 dummy = Tcl_GlobalEval(interp,command);
 if (strcmp(interp->result,"OK") != 0) {
   sprintf(event_message,"%s",interp->result);
   short_display_message(interp,event_message);
   short_display_message(interp,abort);
   goto end_histoscope;
 }
/*------------------------------------------------------------------------*/
/* Index of the beginning of the stuff to be written to the file          */
/*------------------------------------------------------------------------*/
 sprintf(command,"misc_file_handler 5 3");
 dummy = Tcl_GlobalEval(interp,command);
 if (strcmp(interp->result,"OK") != 0) {
   sprintf(event_message,"%s",interp->result);
   short_display_message(interp,event_message);
   short_display_message(interp,abort);
   goto end_histoscope;
 }
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* Header stuff                                                    */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  sprintf(message,"List of bad channels");
  short_display_message(interp, message);
  if (fp != NULL) fprintf(fp,"%s \n",message);       


  sprintf(message,"-------------------- \n");
  short_display_message(interp, message);
  if (fp != NULL) fprintf(fp,"%s \n",message);

  sprintf(message,
    "  Chan  Chip  Chan     -3     -2     -1     +0     +1     +2     +3");
  short_display_message(interp, message);
  if (fp != NULL) fprintf(fp,"%s \n",message);

  sprintf(message,
       "-------------------------------------------------------------------");
  short_display_message(interp, message);
  if (fp != NULL) fprintf(fp,"%s \n",message);

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* now loop over chips                                             */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  for (ichip=min_chip; ichip<(max_chip+1); ichip++) {
    if (ignore[ichip] == 1) continue;
    for (chnum=0; chnum<NUM_CHIP_CHANNELS; chnum++) {
      this_channel = NUM_CHIP_CHANNELS*ichip + chnum;
      if (ichip < number_of_chips_top) {
	dfa_channel = this_channel + 1;
      } else {
        dfa_channel = this_channel - NUM_CHIP_CHANNELS*number_of_chips_top + 1;
      }
      j   = -1;
      bad = 0;
      for (k=MIN; k<MAX+1; k++) {
	j++;
	if (look_at_it[j] == 1 && number_of_faults[j][this_channel] !=0) bad=1;
      }
      if (bad == 1) {
	sprintf(message,"%5d %5d %5d " ,dfa_channel, ichip, chnum);
	j = -1;
	for (k=MIN; k<MAX+1; k++) {
	  j++;
	  sprintf(temp,"%7d",number_of_faults[j][this_channel]);
	  strcat(message,temp);
	}
	short_display_message(interp, message);
	if (fp != NULL) fprintf(fp,"%s \n",message);
      }
    }
  }
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* close the file                                                  */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  if (fp != NULL) fclose(fp);

/*------------------------------------------------------------------------*/
/* Index of the end of the stuff to be written to the file                */
/*------------------------------------------------------------------------*/
 sprintf(command,"misc_file_handler 5 4");
 dummy = Tcl_GlobalEval(interp,command);
 if (strcmp(interp->result,"OK") != 0) {
   sprintf(event_message,"%s",interp->result);
   short_display_message(interp,event_message);
   short_display_message(interp,abort);
   goto end_histoscope;
 }
/*------------------------------------------------------------------------*/
/* Dump it to the file                                                    */
/*------------------------------------------------------------------------*/
 sprintf(command,"misc_file_handler 5 5");
 dummy = Tcl_GlobalEval(interp,command);
 if (strcmp(interp->result,"OK") != 0) {
   sprintf(event_message,"%s",interp->result);
   short_display_message(interp,event_message);
   short_display_message(interp,abort);
   goto end_histoscope;
 }
/*------------------------------------------------------------*/
/* end histoscope                                             */
/*------------------------------------------------------------*/
end_histoscope:
/**   hs_update();                                            **/
/*                                                                           */
/*   sprintf(event_message,"wait 10 seconds to give histoscope a chance");   */
/*   short_display_message(interp,event_message);                            */
/*   sleep(10);                                                              */
/*   hs_update();                                                            */
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Now a loop waiting for the user to close histoscope                       */
/* If she does not want to close histoscope, then update it instead          */
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/**  strcpy(temp,"empty");                                                  **/
/**  while (strcmp(temp,"close") != 0) {                                    **/
/**       hs_update();                                                      **/
/**       dummy = Tcl_Eval(interp,msg3);                                    **/
/**       strcpy(temp,interp->result);                                      **/
/**     }                                                                   **/
/**   dummy = hs_save_file("histoscope.out");                               **/
/**   hs_complete();                                                        **/
/*------------------------------------------------------------------------*/
/* Close the output file                                                  */
/*------------------------------------------------------------------------*/
 sprintf(command,"misc_file_handler 5 1");
 dummy = Tcl_GlobalEval(interp,command);
 if (strcmp(interp->result,"OK") != 0) {
   sprintf(event_message,"%s",interp->result);
   short_display_message(interp,event_message);
   short_display_message(interp,abort);
 }
/*---------------------------------------------------------------------------*/
/* Tell the user that we are done                                            */
/*---------------------------------------------------------------------------*/
 sprintf(event_message,"\n \n COMPLETED TEST FOR SHORTS");
 short_display_message(interp,event_message);
/*---------------------------------------------------------------------------*/
/* done                                                                      */
/*---------------------------------------------------------------------------*/
    return TCL_OK;
}

/*********************************************************************/
/* returns 1 if chip is on top side, 2 if chip is on bottom side      */
/*********************************************************************/
int cal_side(int chip) {
  if (chip >= number_of_chips_top) return 2;
  return 1;
}

/*********************************************************************/
/* definition of the command "shorts_test"                           */
/*********************************************************************/
void shorts_test_define(Tcl_Interp* interp) {
  Tcl_CreateCommand(interp, "shorts_test", shorts_testCmd, (ClientData) NULL,
                    (Tcl_CmdDeleteProc *) NULL);
}

/***************************************************************************/
/* Display message                                                         */
/***************************************************************************/
void short_display_message(Tcl_Interp* interp, char* message)
{
  static char in[]    = ".pltw.text insert end \"";
  static char cmd11[] = "update";
  static char cmd0[]  = ".pltw.text yview -pickplace end";
  char command[200]; 
  int dummy;

  sprintf(command,"%s %s \n\"",in,message);
  dummy = Tcl_Eval(interp,command);
  dummy = Tcl_Eval(interp,cmd0);
  dummy = Tcl_Eval(interp,cmd11);
}

