/* 
 * VME Teststand Software
 *
 * Code revised by Armin Karcher ( karcher@design.lbl.gov)
 *
 * Design and Template by:
 *   Eric Gottlieb  (egott@unm.edu)
 *   Tim Thomas     (thomas@hev1.phys.unm.edu)
 *   Micheal Gold   (gold@hepv1.phys.unm.edu)
 *
 */

#ifndef cardlist_h
#define cardlist_h

#include "error.h"
#include "reglist.h"
#include <sys/types.h>
#ifdef vxworks
#include <types/vxTypesOld.h>
#endif

#define VME_MAX_BASES 32

struct vme_card 
{
  char* classname;
  char* instname[VME_MAX_BASES];
  int index;
  vme_vmetype* base[VME_MAX_BASES];
  int bases;
};

typedef struct vme_card* vme_card;

extern vme_card VME_Cards[]; /* a master list of the cards (null terminiated) */

void vmeInitCards();
int vmeBase2Index(vme_vmetype* base);
vme_card vmeName2Card(char* name);
int vmeName2Inst(char* name);

void vmeAddCardClass(vme_card* c, char* name);
void vmeDeleteCards(); /* delete all cards */

vme_vmetype* vmeAddCardBase(vme_card card, char* instname, vme_vmetype* base);

#endif
