/* -*- C -*- */

/* 
 * VME Teststand Software
 *
 * Code revised by Armin Karcher (karcher@design.lbl.gov)
 *
 * Design and Template by:
 *   Eric Gottlieb  (egott@unm.edu)
 *   Tim Thomas     (thomas@hev1.phys.unm.edu)
 *   Micheal Gold   (gold@hepv1.phys.unm.edu)
 *
 */

#ifndef EXECUTOR_H
#define EXECUTOR_H

#include "semaphore.h"

struct vme_execparams {
  /* public: these are available for user modification (ie: on backend) */

  int events;        /* how many events should we take */
  char server[256];   /* the name of the server to be used */

  /* private: should not be touched on backend */

  int changed;       /* has this structure been modified? */
  int running;       /* is executor running? */
  SEM_ID semaphore;  /* used to lock/unlock the params */
};

extern struct vme_execparams VME_ExecParams;

void vmeExecutor();

#endif
