/* 
 * VME Teststand Software
 *
 * Code revised by Armin Karcher (karcher@design.lbl.gov)
 *
 * Design and Template by:
 *   Eric Gottlieb  (egott@unm.edu)
 *   Tim Thomas     (thomas@hev1.phys.unm.edu)
 *   Micheal Gold   (gold@hepv1.phys.unm.edu)
 *
 */

#ifndef front_h
#define front_h

#include <sys/types.h>
#ifdef vxworks
#include <types/vxTypesOld.h>
#endif
#include "cardlist.h"
#include "rpc.h"

vme_rc vmeResetFront();
vme_rc vmeWrite(int c, vme_register r, vme_vmetype v);
vme_rc vmeRead(int c, vme_register r);
vme_rc vmeSet(int c, vme_register r);
vme_rc vmeClear(int c, vme_register r);
vme_rc vmeTest(int c, vme_register r);
vme_rc vmeFileWrite(int c, vme_register r, int address, char* fname);
vme_rc vmeFileRead(int c, vme_register r, int address, int len, char* fname);
vme_rc vmeBuffWrite(int c, vme_register r, vme_vmetype* data, int length);
vme_rc vmeBuffRead(int c, vme_register r, vme_vmetype* data, int length);

vme_rc vmeGetState(int c, int classindex, vme_register* registers, vme_vmetype* values);
vme_vmetype* vmeAddCard(vme_card card, char* instname, vme_vmetype* base);
void vmeAddCardType(char* name);
vme_rc vmeWait(int card, vme_register bit_reg, vme_vmetype pole, int seconds);

vme_rc vmeVmeWrite(vme_vmetype* base,int offset,vme_vmetype value);
vme_rc vmeVmeRead(vme_vmetype* base,int offset);

vme_rc vmeFrontDisplay(char* mess);

vme_rc vmeExecControl(vme_user_params p);

void vmeAddRegister(vme_register* regptr, char* name, char* class, enum vme_regtype type, enum vme_access access, 
		 int offset, vme_vmetype mask, vme_vmetype vmask, int shift, vme_card card);

#endif
