/* 
 * VME Teststand Software
 *
 * Code revised by ArminKarcher (karcher@design.lbl.gov)
 *
 * Design and Template by:
 *   Eric Gottlieb  (egott@unm.edu)
 *   Tim Thomas     (thomas@hev1.phys.unm.edu)
 *   Micheal Gold   (gold@hepv1.phys.unm.edu)
 *
 */

/* $Id: low.h,v 1.1.1.1 1995/05/05 16:16:18 egott Exp $ */

#ifndef LOW_H
#define LOW_H

#include <sys/types.h>

#ifdef vxworks
#include <types/vxTypesOld.h>
#endif

#include "error.h"
#include "reglist.h"

/* 
 * generic low level routines/methods  
 *
 */

/* struct vme_reg is mentioned (rather than just vme_reg or vme_register)
 * here because it is needed and this file
 * is included by reglist.h.  Doing this resolves the recursion.
 */
/*
struct vme_reg;
typedef struct vme_reg* vme_register;
*/

/* these routines are used as methods by "registers" in reglist.c.  They are further
 * described both in low.c and in the documentation
 */
vme_rc vmeLowSet        (vme_vmetype* base, vme_register reg);
vme_rc vmeLowClear      (vme_vmetype* base, vme_register reg);
vme_rc vmeLowTest       (vme_vmetype* base, vme_register reg);
vme_rc vmeLowNotTest    (vme_vmetype* base, vme_register reg);
vme_rc vmeLowBitSet     (vme_vmetype* base, vme_register reg, vme_vmetype value);
vme_rc vmeLowBitsWrite  (vme_vmetype* base, vme_register reg, vme_vmetype value);
vme_rc vmeLowBitsSet    (vme_vmetype* base, vme_register reg, vme_vmetype value);
vme_rc vmeLowBitsRead   (vme_vmetype* base, vme_register reg);
vme_rc vmeLowDecodeWrite(vme_vmetype* base, vme_register reg, vme_vmetype value);
vme_rc vmeLowDecodeBitsSet(vme_vmetype* base, vme_register reg, vme_vmetype value);
vme_rc vmeLowDecodeRead (vme_vmetype* base, vme_register reg);
vme_rc vmeLowWrite      (vme_vmetype* base, vme_register reg, vme_vmetype value);
vme_rc vmeLowRead       (vme_vmetype* base, vme_register reg);

vme_rc vmeLowBuffWrite(vme_vmetype* base, vme_register fifo,vme_vmetype* buff, int len, vme_rc m);
vme_rc vmeLowBuffRead(vme_vmetype* base, vme_register fifo, vme_vmetype* buff, int len, vme_rc m);
vme_rc vmeLowContig2Buff(vme_vmetype* base, vme_register array, vme_vmetype* buff, int len, vme_rc m);
vme_rc vmeLowBuff2Contig(vme_vmetype* base, vme_register array, vme_vmetype* buff, int len, vme_rc m);

vme_rc vmeLowVSet(vme_vmetype* base, vme_register reg);
vme_rc vmeLowVClear(vme_vmetype* base, vme_register reg);
vme_rc vmeLowBitsVSet(vme_vmetype* base, vme_register reg, vme_vmetype value);
vme_rc vmeLowDecodeBitsVSet(vme_vmetype* base, vme_register reg, vme_vmetype value);

#endif
