/* 
 * DAQ Teststand 
 *
 * Code by Armin Karcher (karcher@design.lbl.gov)
 */

#include <stdio.h>
#include <sys/types.h>
#ifdef vxworks
#include <types/vxTypesOld.h>
#endif

#include "unmcp.h"
#include "front.h"
#include "low.h"

vme_card vme_cp;

vme_register vme_cp1;
vme_register vme_cp2;
vme_register vme_cp3;
vme_register vme_cp4;
vme_register vme_cp5;
vme_register vme_cp6;
vme_register cp_ram;

void vmeAddcpRegisters()
{

/* these constants are just for conveniance and to make the code below more readable */
  const int FIFO = VME_FIFO;
  const int CONTIG = VME_CONTIG;
  const int WORD = VME_WORD;
  const int BITS = VME_BITS;
  const int BIT = VME_BIT;

  const int RO = VME_R_ACCESS;
  const int WO = VME_W_ACCESS;
  const int RW = VME_RW_ACCESS;
  const int WV = VME_WV_ACCESS;
  const int RWV = VME_RW_ACCESS | VME_V_ACCESS;
  const int RD = VME_RD_ACCESS;

/* vmeAddReg&register, name, class, type, access, offset, mask, vmask, shift, card) */

  vmeAddReg(&cp_ram,  "cp_ram",  "memory",  CONTIG,  RW, 0x000000, 0xffffffff, 0x0000,  0, vme_cp);

  vmeAddReg(&vme_cp1,"cp1",  "generic",WORD,RW, 0, 0xffffffff, 0x0000,  0, vme_cp);
  vmeAddReg(&vme_cp2,"cp2",  "generic",WORD,RW, 1, 0xffffffff, 0x0000,  0, vme_cp);
  vmeAddReg(&vme_cp3,"cp3",  "generic",WORD,RW, 2, 0xffffffff, 0x0000,  0, vme_cp);
  vmeAddReg(&vme_cp4,"cp4",  "generic",WORD,RW, 3, 0xffffffff, 0x0000,  0, vme_cp);
  vmeAddReg(&vme_cp5,"cp5",  "generic",WORD,RW, 4, 0xffffffff, 0x0000,  0, vme_cp);
  vmeAddReg(&vme_cp6,"cp6",  "generic",WORD,RW, 5, 0xffffffff, 0x0000,  0, vme_cp);
  vmeAddContig(cp_ram,vmeLowBuff2Contig,vmeLowContig2Buff,NULL,NULL,0x5000);

 }

