/* 
 * Daq-Board Teststand Software
 *
 *
 *Code by:
 *   Armin Karcher (karcher@design.lbl.gov)
 * Design and Template by
 *   Eric Gottlieb  (egott@unm.edu)
 *   Tim Thomas     (thomas@hev1.phys.unm.edu)
 *   Micheal Gold   (gold@hepv1.phys.unm.edu)
 *
 */

#ifndef UNMDAQ_H
#define UNMDAQ_H

#include <sys/types.h>
#ifdef vxworks
#include <types/vxTypesOld.h>
#endif
#include "error.h"
#include "low.h"
#include "reglist.h"
#include "cardlist.h"


extern vme_card vme_daq;

extern vme_register daq_dram;
extern vme_register daq_vram1;
extern vme_register daq_vram2;
extern vme_register daq_board_reset;
extern vme_register daq_hreset;
extern vme_register daq_cpu_gbl;
extern vme_register daq_cpu_smi;
extern vme_register daq_pm_type;
extern vme_register daq_int_ppc_en;
extern vme_register daq_int_vme_en;
extern vme_register daq_vram_xfer;
extern vme_register daq_vram_dir;
extern vme_register daq_busy;
extern vme_register daq_sclk_enable;
extern vme_register daq_vme_int;
extern vme_register daq_inc_qc;
extern vme_register daq_dec_qc;
extern vme_register daq_led;
extern vme_register daq_send_sync;
extern vme_register daq_en_fast_ctl;
extern vme_register daq_en_model;
extern vme_register daq_vram_full_pointer;
extern vme_register daq_vram_af_level;
extern vme_register daq_vram_page;
extern vme_register daq_fifo_af_level;
extern vme_register daq_fifo_full_level;
extern vme_register daq_vram_full;
extern vme_register daq_vram_af;
extern vme_register daq_vram_empty; 
extern vme_register daq_pm_full;
extern vme_register daq_pm_af;
extern vme_register daq_fifo_full;
extern vme_register daq_fifo_af;
extern vme_register daq_fifo_empty; 
extern vme_register daq_uart_int;
extern vme_register daq_timer2_int;
extern vme_register daq_timer1_int;
extern vme_register daq_timer0_int;
extern vme_register daq_pm_int;
extern vme_register daq_xfer_done;
extern vme_register daq_fast_int;
extern vme_register daq_pm_full_int;
extern vme_register daq_vram_full_int;
extern vme_register daq_fifo_full_int;
extern vme_register daq_ppc_mail_int;
extern vme_register daq_msk_uart;  
extern vme_register daq_msk_timer2; 
extern vme_register daq_msk_timer1; 
extern vme_register daq_msk_timer0;
extern vme_register daq_msk_pm_int;
extern vme_register daq_msk_xfer_done;
extern vme_register daq_msk_fast_ctl;
extern vme_register daq_msk_pm_full;
extern vme_register daq_msk_vf;
extern vme_register daq_msk_ff;
extern vme_register daq_msk_ppc_mail;
extern vme_register daq_irq_vector;
extern vme_register daq_irq_level;
extern vme_register daq_vme_mailbox;
extern vme_register daq_ppc_mailbox;
extern vme_register daq_num_pages;
extern vme_register daq_num_buffs;   
extern vme_register daq_model_occ;   
extern vme_register daq_que_ctr; 
extern vme_register daq_curr_evt; 
extern vme_register daq_fast_ctl_timebase;
extern vme_register daq_fifo_read;
extern vme_register daq_timer0;
extern vme_register daq_timer1;   
extern vme_register daq_timer2; 
extern vme_register daq_timer_ctrl;  
extern vme_register daq_uart_ctrl_a;  
extern vme_register daq_uart_data_a;  
extern vme_register daq_uart_ctrl_b;  
extern vme_register daq_uart_data_b;  
extern vme_register pm_end_flag;  
extern vme_register pm_link_lock;  
extern vme_register pm_rx_idle;  
extern vme_register pm_tx_idle;  
extern vme_register pm_en_fast_ctl;  
extern vme_register pm_cmd_reg;  
extern vme_register pm_ch_msk;  
extern vme_register pm_wrd_cnt;  
extern vme_register pm_timeout;  
extern vme_register pm_int_dne;  
extern vme_register pm_int_timeout;  
extern vme_register pm_int_link_err;  
extern vme_register pm_msk_transfer_dne;  
extern vme_register pm_msk_timeout;  
extern vme_register pm_msk_link_error;  

void vmeAddDaqRegisters();
vme_rc vmePmCommand();

#endif
