/* 
 * Daq-Board Teststand Software
 *
 *
 *Code by:
 *   Armin Karcher (karcher@design.lbl.gov)
 * Design and Template by
 *   Eric Gottlieb  (egott@unm.edu)
 *   Tim Thomas     (thomas@hev1.phys.unm.edu)
 *   Micheal Gold   (gold@hepv1.phys.unm.edu)
 *
 */

#ifndef UNMPRE_H
#define UNMPRE_H

#include <sys/types.h>
#ifdef vxworks
#include <types/vxTypesOld.h>
#endif
#include "error.h"
#include "low.h"
#include "reglist.h"
#include "cardlist.h"


extern vme_card vme_pre;  /*CAN NOT be simultaneously used with 
                            final DAQ card */
extern vme_register daq_dram;
extern vme_register daq_vram1;
extern vme_register daq_vram2;
extern vme_register daq_vram_page;
extern vme_register daq_vram_af_level;
extern vme_register daq_board_reset;
extern vme_register daq_assrt_chkstp;
extern vme_register daq_led;
extern vme_register daq_vram_dir;
extern vme_register daq_smi;
extern vme_register daq_mcp;
extern vme_register daq_sreset;
extern vme_register daq_hreset;
extern vme_register daq_sclk_enable;
extern vme_register daq_cpu_gbl;
extern vme_register daq_cpu_smi;
extern vme_register daq_pm_type;
extern vme_register daq_fifo_af_level;
extern vme_register daq_fifo_full_level;
extern vme_register daq_pm_error;
extern vme_register daq_chkstp;
extern vme_register daq_pm_error_int;
extern vme_register daq_pm_int;
extern vme_register daq_xfer_done_int;
extern vme_register daq_pm_int;
extern vme_register daq_vf_int;
extern vme_register daq_ff_int;
extern vme_register daq_vme_mail_int;
extern vme_register daq_ppc_mail_int;
extern vme_register daq_pm_error_reset;
extern vme_register daq_pm_reset;
extern vme_register daq_xfer_done_reset;
extern vme_register daq_pm_reset;
extern vme_register daq_vf_reset;
extern vme_register daq_ff_reset;
extern vme_register daq_vme_mail_reset;
extern vme_register daq_ppc_mail_reset;
extern vme_register daq_msk_pm_error;
extern vme_register daq_msk_pm;
extern vme_register daq_msk_xfer_done;
extern vme_register daq_msk_fast_ctl;
extern vme_register daq_msk_pm_full;
extern vme_register daq_msk_vf;
extern vme_register daq_msk_ff;
extern vme_register daq_msk_vme_mail;
extern vme_register daq_msk_ppc_mail;
extern vme_register daq_fifo;
extern vme_register daq_vme_mailbox;
extern vme_register daq_ppc_mailbox;
extern vme_register pm_trailer_en;  
extern vme_register pm_opto_rdy;  
extern vme_register pm_rx_idle;  
extern vme_register pm_tx_idle;  
extern vme_register pm_en_fast_ctl;  
extern vme_register pm_rst_link;  
extern vme_register pm_cmd_reg;  
extern vme_register pm_ch_msk;  
extern vme_register pm_rx_wrd_cnt;  
extern vme_register pm_tx_wrd_cnt;  
extern vme_register pm_timeout;  
extern vme_register pm_eot;  
extern vme_register pm_opto;  
extern vme_register pm_int_dne;  
extern vme_register pm_int_timeout;  
extern vme_register pm_int_link_err;  
extern vme_register pm_int_rx;  
extern vme_register pm_int_tx;  
extern vme_register pm_int_protocol;  
extern vme_register pm_msk_transfer_dne;  
extern vme_register pm_msk_timeout;  
extern vme_register pm_msk_link_error;  
extern vme_register pm_msk_rx;  
extern vme_register pm_msk_tx;  
extern vme_register pm_msk_protocol;  
extern vme_register pm_clr_transfer_dne;  
extern vme_register pm_clr_timeout;  
extern vme_register pm_clr_link_error;  
extern vme_register pm_clr_rx;  
extern vme_register pm_clr_tx;  
extern vme_register pm_clr_protocol;  

void vmeAddPreRegisters();
vme_rc vmePmCommand();
void vram_wait();
void data_2_vram();

#endif
