// -*- C++ -*-

// 
// VME Teststand Software
//
// Code revised by Armin Karcher (karcher@design.lbl.gov)
//
// Design and Template by:
//   Eric Gottlieb  (egott@unm.edu)
//   Tim Thomas     (thomas@hev1.phys.unm.edu)
//   Micheal Gold   (gold@hepv1.phys.unm.edu)
//

#ifndef BACKDATA_H
#define BACKDATA_H

#include <String.h>
#include "debugHandler.h"
#include "backrpc.h"

class VMEData : public DebugHandler
{

public: // ----------------------- public ------------------------
  VMEData(vme_data cdata, String name = "unknown");
  VMEData(const VMEData& vmeData);
  ~VMEData();
  int len() const;
  vme_data_item* data() const;

protected: // -------------------- protected ---------------------

private: // ---------------------- private -----------------------
  int _length;
  vme_data_item* _data;
  static int _count;
  char _name[32];

};

#endif
