// -*- C++ -*-

// 
// VME Teststand Software
//
// Code revised by Armin Karcher (karcher@design.lbl.gov)
//
// Design and Template by:
//   Eric Gottlieb  (egott@unm.edu)
//   Tim Thomas     (thomas@hev1.phys.unm.edu)
//   Micheal Gold   (gold@hepv1.phys.unm.edu)
//

#ifndef BACKSWITCH_H
#define BACKSWITCH_H

#include <String.h>
#include <list.h>          // from stl == standard template library (came w/ libg++ 2.6.2)
#include "debugHandler.h"
#include "backUser.h"
#include "backData.h"

class SwitchYard : public DebugHandler
{

public: // ----------------------- public ------------------------
  SwitchYard(String name = "switchYard");
  ~SwitchYard();
  int* users();
  void addUser(User* u);
  void removeUser(User* u);
  char* name(int id);                      // get name
  char* doCmd(int id,String cmd);             // execute command
  void state(int id, enum vme_userstate);  // set state
  enum vme_userstate state(int id);        // get state
  void eat(VMEData vmeData);

protected: // -------------------- protected ---------------------

private: // ---------------------- private -----------------------
  User* _find(int id);
  int _checkid(int id) const;
  char* _doCmd(String cmd);

  static int _oneExists;
  list<User*> _userlist;

};

#endif
