// -*- C++ -*-

// 
// VME Teststand Software
//
// Code revised by Armin Karcher (karcher@design.lbl.gov)
//
// Design and Template by:
//   Eric Gottlieb  (egott@unm.edu)
//   Tim Thomas     (thomas@hev1.phys.unm.edu)
//   Micheal Gold   (gold@hepv1.phys.unm.edu)
//

#ifndef BACKUSER_H
#define BACKUSER_H

#include <String.h>
#include "debugHandler.h"
#include "backTypes.h"
#include "backData.h"

class User : public DebugHandler
{

public: // ----------------------- public ------------------------
  User(String name = "unknown_user"); 
  ~User();
  int id() const;
  String name() const;
  String doCmd(String cmd);
  void state(enum vme_userstate state); // set state
  enum vme_userstate state() const;     // get state 
  void eat(VMEData vmeData);

protected: // -------------------- protected ---------------------

private: // ---------------------- private -----------------------
  static int _masterid;
  int _id;
  String _name;
  enum vme_userstate _state;

};

#endif
