/* -*- C++ -*- */
/* 
 * VME Teststand Software
 *
 * Code revised by Armin Karcher (karcher@design.lbl.gov)
 *
 * Design and Template by:
 *   Eric Gottlieb  (egott@unm.edu)
 *   Tim Thomas     (thomas@hev1.phys.unm.edu)
 *   Micheal Gold   (gold@hepv1.phys.unm.edu)
 *
 */

#ifndef VME_BACKSERVER_ID
#define VME_BACKSERVER_ID 0x20003333
#endif

#define MAXUSERS 100

typedef int idArray<MAXUSERS>;

#define MAXDATA 100

struct vme_data_item 
{
  short address;
  short counts;
};

typedef struct vme_data_item vme_data<MAXDATA>;

program BACKSERVER_PROGRAM {
  version BACKSERVER_VERSION {
    int VMEHELLO(string) = 1;
    idArray VMEBACKUSERS() = 2;
    int VMEGETUSERSTATE(int) = 3;
    void VMESETUSERSTATE(int,int) = 4;
    string VMEGETUSERNAME(int) = 5;
    void VMESENDDATA(vme_data) = 6;
    string VMESENDCMD(int,string) = 7;
  } = 1;
} = VME_BACKSERVER_ID;

/* 
 * VME_SERVER_ID is a macro variable which is supplied by
 * the makefile.  While this software is under development it
 * should be a number between 0x20000000 and 0x3fffffff
 *
 */
