// -*- C++ -*-

// 
// VME Teststand Software
//
// Code revised by Armin Karcher (karcher@design.lbl.gov)
//
// Design and Code by:
//   Eric Gottlieb  (egott@unm.edu)
//   Tim Thomas     (thomas@hev1.phys.unm.edu)
//   Micheal Gold   (gold@hepv1.phys.unm.edu)
//

#ifndef DEBUGHANDLER_H
#define DEBUGHANDLER_H

#include <String.h>
#include "errorHandler.h"

class DebugHandler : public ErrorHandler
{

public: // ----------------------- public -----------------------
  DebugHandler(String classname = "unknown", String instname = "unknown");
  ~DebugHandler();

protected: // -------------------- protected --------------------
  virtual void debug(String s = "") const;            // exits program after outputing message
  virtual void constructionNote(String s = "") const; // for use in a constructer
  virtual void destructionNote(String s = "") const;  // for use in a destructer

private: // ---------------------- private ----------------------

};

#endif
