#############################################################################
#  This procedure checks that the number of chips and the
#  and the number of buffers and the
#  number of sides on an hybrid are okay
#  returns zero if everything checks out
#############################################################################
proc cal_check_chip_number {} {

# all global variables
    source cal_global.tcl

# variable for talk_to
    global talk_to

# do not allow for illegal number of buffers
    set good [test_value Cal_number_of_buffers $Cal_number_of_buffers 1 4]
    if {$good == 1} {return $good}

# do not allow for illegal number of sides on a hybrid
    set good [test_value Cal_Side_Hybrid $Cal_Side_Hybrid 1 2]
    if {$good == 1} {return $good}

# do not allow for illegal number of chips
    if {$Cal_Side_Hybrid == 1} {
	set good [test_value Cal_number_of_chips $Cal_number_of_chips 1 10]
	if {$good == 1} {return}
    } elseif {$Cal_Side_Hybrid == 2} {
	set good [test_value Cal_number_of_chips $Cal_number_of_chips 2 20]
	if {$good == 1} {return $good}
    }
    set good [test_value Cal_number_of_chips_top $Cal_number_of_chips_top 1 10]
    if {$good == 1} {return $good}


# if it is a two sided hybrid, we better have an even number of chips
#   if {$Cal_Side_Hybrid == 2} {
#       set temp [expr $Cal_number_of_chips/2]
#       set temp [expr int($temp)]
#       set temp [expr $temp*2]
#       if {$temp != $Cal_number_of_chips} {
#	   set dialog 0       
#	   toplevel .dialog
#           grab set .dialog
#           label .dialog.label -text "For a two sided hybrid \n the number of chips should be even"
#           button .dialog.done -text "Okay" -command "set cal_dialog 1"
#           pack .dialog.label .dialog.done -side top -in .dialog
#           tkwait variable cal_dialog
#           grab release .dialog
#           destroy .dialog
#	   set good 1
#	   return $good
#       }
#   }

# if it is a one sided hybrid, the number of chips and the number of
# chips on the top side of the hybrid better be the same.....
   if {$Cal_Side_Hybrid == 1} {
       if {$Cal_number_of_chips != $Cal_number_of_chips_top} {
	   cal_display_error_message "Error.\nOne sided hybrid.\nNo. of chips must be = No. of chips on top side"
	   set good 1 
	   return $good
       }
   }

# if it is a two sided hybrid, check that there are between 1 and 10 
# chips on the bottom side of the hybrid
   if {$Cal_Side_Hybrid == 2} {
       set nb [expr $Cal_number_of_chips-$Cal_number_of_chips_top]
       if {$nb < 1 || $nb > 10} {
	   cal_display_error_message "Error.\nBottom side of hybrid has $nb chips.\nShould be between 1 and 10"
	   set good 1
	   return $good
       }
   }



# everything is okay
   set good 0
   return $good
}

