proc cal_chip_menu {selected_chip} {

  source cal_global.tcl
  global Temp_Cal_min_threshold  
  global Temp_Cal_max_threshold  
  global Temp_Cal_step_threshold 
  global Temp_Cal_min_charge     
  global Temp_Cal_max_charge     
  global Temp_Cal_step_charge   
  global Temp_Cal_jitter            
  global Temp_Cal_shaping_time   
  global Temp_Cal_sampling_rate
  global Temp_Cal_skip
  global Temp_Cal_readout_direction
  global Temp_Cal_respond
  global Temp_Cal_clock_through
  global Temp_Cal_test_pattern
  global Temp_Cal_Set_Clock_B
  global Temp_Cal_calib_mask 
  global Temp_Cal_channel_mask 
  global Temp2
  global Temp3

  global chip_menu_talk

    toplevel .chip_menu_$selected_chip  -bg #00f

    frame .chip_menu_$selected_chip.f0 -relief raised -bd 2  -bg #00f
    frame .chip_menu_$selected_chip.f1 -relief raised -bd 2  -bg #00f
    frame .chip_menu_$selected_chip.f2 -relief raised -bd 2  -bg #00f
    frame .chip_menu_$selected_chip.f3 -relief raised -bd 2  -bg #00f
    frame .chip_menu_$selected_chip.f4 -relief raised -bd 2  -bg #00f
    frame .chip_menu_$selected_chip.f5 -relief raised -bd 2  -bg #00f
    frame .chip_menu_$selected_chip.f6 -relief raised -bd 2  -bg #00f
    frame .chip_menu_$selected_chip.f7 -relief raised -bd 2  -bg #00f
    frame .chip_menu_$selected_chip.f9 -relief raised -bd 2  -bg #00f
    frame .chip_menu_$selected_chip.f8 -relief raised -bd 2  -bg #00f
    frame .chip_menu_$selected_chip.f10 -relief raised -bd 2  -bg #00f
    frame .chip_menu_$selected_chip.f11 -relief raised -bd 2  -bg #00f

    pack  	.chip_menu_$selected_chip.f0  \
		.chip_menu_$selected_chip.f1  \
		.chip_menu_$selected_chip.f2  \
		.chip_menu_$selected_chip.f3  \
		.chip_menu_$selected_chip.f4  \
		.chip_menu_$selected_chip.f5  \
		.chip_menu_$selected_chip.f6  \
		.chip_menu_$selected_chip.f7  \
		.chip_menu_$selected_chip.f8  \
		.chip_menu_$selected_chip.f9  \
		.chip_menu_$selected_chip.f10  \
		.chip_menu_$selected_chip.f11  \
			-side top  \
			-pady 8

    grab set .chip_menu_$selected_chip

# first an explanation

    message .chip_menu_$selected_chip.msg   \
		-width 15c  \
		-justify center  \
		-relief ridge  \
		-bg #aff   \
		-highlightthickness 0  \
		-text "Select parameters for chip number  $selected_chip. \n \nClick OK to accept the new settings, click CANCEL to cancel"

    pack .chip_menu_$selected_chip.msg  \
		-in .chip_menu_$selected_chip.f0




# copy the settings into temporary settings
    
         set Temp_Cal_min_threshold  $Cal_min_threshold($selected_chip)
         set Temp_Cal_max_threshold  $Cal_max_threshold($selected_chip)
         set Temp_Cal_step_threshold $Cal_step_threshold($selected_chip)
         set Temp_Cal_min_charge     $Cal_min_charge($selected_chip)
         set Temp_Cal_max_charge     $Cal_max_charge($selected_chip)
         set Temp_Cal_step_charge    $Cal_step_charge($selected_chip)
         set Temp_Cal_jitter         $Cal_jitter($selected_chip)   
         set Temp_Cal_shaping_time   $Cal_shaping_time($selected_chip)
         set Temp_Cal_sampling_rate  $Cal_sampling_rate($selected_chip)
         set Temp_Cal_skip           $Cal_skip($selected_chip)
         set Temp_Cal_readout_direction $Cal_readout_direction($selected_chip)
         set Temp_Cal_respond        $Cal_respond($selected_chip)
         set Temp_Cal_clock_through  $Cal_clock_through($selected_chip)
         set Temp_Cal_test_pattern   $Cal_test_pattern($selected_chip)
         set Temp_Cal_Set_Clock_B    $Cal_Set_Clock_B($selected_chip)
         set j 0
         while {$j <= 7} {
	     set Temp_Cal_calib_mask($j) $Cal_calib_mask($selected_chip,$j)
	     set Temp_Cal_channel_mask($j) $Cal_channel_mask($selected_chip,$j)
	     incr j 1
	 }



# Here for the thresholds

	 label .chip_menu_$selected_chip.tlmin  \
		-text "Minimum threshold"  \
		-bg #8dd  \
		-highlightthickness 0
	 entry .chip_menu_$selected_chip.temin  \
		-width 4   \
		-textvariable Temp_Cal_min_threshold   \
		-relief sunken  \
		-bg #aff   \
		-highlightcolor #f00  \
		-highlightbackground #8dd
	 label .chip_menu_$selected_chip.tlmax  \
		-text "Maximum threshold"  \
		-bg #8dd  \
		-highlightthickness 0
	 entry .chip_menu_$selected_chip.temax  \
		-width 4  \
		-relief sunken  \
		-bg #aff  \
		-textvariable Temp_Cal_max_threshold   \
		-highlightcolor #f00  \
		-highlightbackground #8dd
	 label .chip_menu_$selected_chip.tlstp  \
		-text "Step"  \
		-bg #8dd  \
		-highlightthickness 0
	 entry .chip_menu_$selected_chip.testp  \
		 -width 4  \
		-relief sunken  \
		-bg #aff  \
		-textvariable Temp_Cal_step_threshold    \
		-highlightcolor #f00  \
		-highlightbackground #8dd

         pack 	.chip_menu_$selected_chip.tlmin  \
		.chip_menu_$selected_chip.temin  \
		.chip_menu_$selected_chip.tlmax  \
		.chip_menu_$selected_chip.temax  \
		.chip_menu_$selected_chip.tlstp  \
		.chip_menu_$selected_chip.testp  \
			-side left  \
			-padx 4  \
			-pady 1   \
			-expand 1  \
			-in .chip_menu_$selected_chip.f1

# Here for the charge injection

	 label .chip_menu_$selected_chip.qlmin \
		 -text "Minimum charge inj" \
		 -bg #8dd \
		 -highlightthickness 0
	 entry .chip_menu_$selected_chip.qemin \
		 -width 4 \
		 -bg #aff \
		 -relief sunken \
		 -textvariable Temp_Cal_min_charge  \
		 -highlightcolor #f00 \
		 -highlightbackground #8dd
	 label .chip_menu_$selected_chip.qlmax \
		 -text "Maximum charge inj" \
		 -bg #8dd \
		 -highlightthickness 0
	 entry .chip_menu_$selected_chip.qemax \
		 -width 4 \
		 -bg #8dd \
		 -relief sunken \
		 -textvariable Temp_Cal_max_charge  \
		 -bg #aff  \
		 -highlightcolor #f00 \
		 -highlightbackground #8dd
	 label .chip_menu_$selected_chip.qlstp \
		 -text "Step" \
		 -bg #8dd \
		 -highlightthickness 0
	 entry .chip_menu_$selected_chip.qestp \
		 -width 4 \
		 -bg #8dd \
		 -relief sunken \
		 -textvariable Temp_Cal_step_charge \
		 -bg #aff \
		 -highlightcolor #f00 \
		 -highlightbackground #8dd
         pack .chip_menu_$selected_chip.qlmin \
	      .chip_menu_$selected_chip.qemin \
	      .chip_menu_$selected_chip.qlmax \
	      .chip_menu_$selected_chip.qemax \
	      .chip_menu_$selected_chip.qlstp \
	      .chip_menu_$selected_chip.qestp \
	      -padx 4 \
	      -side left \
	      -in .chip_menu_$selected_chip.f2

# Here for shaping time, sampling rate, skip control

         frame .chip_menu_$selected_chip.f3.f1 -bg #8dd
         frame .chip_menu_$selected_chip.f3.f2 -bg #8dd
         frame .chip_menu_$selected_chip.f3.f3 -bg #8dd
	 pack .chip_menu_$selected_chip.f3.f1 \
	      .chip_menu_$selected_chip.f3.f2 \
	      .chip_menu_$selected_chip.f3.f3 \
	      -side left \
	      -in .chip_menu_$selected_chip.f3 \
	      -padx 20

         label .chip_menu_$selected_chip.f3.f1.label \
		 -text "Shaping time" \
		 -bg #8dd \
		 -highlightthickness 0
         radiobutton .chip_menu_$selected_chip.f3.f1.sh100 \
		 -text "100 nsec" \
		 -variable Temp_Cal_shaping_time \
		 -value 0  \
		 -bg #8dd \
		 -activebackground #7cc \
		 -highlightthickness 0
         radiobutton .chip_menu_$selected_chip.f3.f1.sh200 \
		 -text "200 nsec" \
		 -variable Temp_Cal_shaping_time \
		 -value 1  \
		 -bg #8dd \
		 -activebackground #7cc \
		 -highlightthickness 0
         radiobutton .chip_menu_$selected_chip.f3.f1.sh300 \
		 -text "300 nsec" \
		 -variable Temp_Cal_shaping_time \
		 -value 2  \
		 -bg #8dd \
		 -activebackground #7cc \
		 -highlightthickness 0
         radiobutton .chip_menu_$selected_chip.f3.f1.sh400 \
		 -text "400 nsec" \
		 -variable Temp_Cal_shaping_time \
		 -value 3  \
		 -bg #8dd \
		 -activebackground #7cc \
		 -highlightthickness 0
         pack .chip_menu_$selected_chip.f3.f1.label \
	      .chip_menu_$selected_chip.f3.f1.sh100 \
	      .chip_menu_$selected_chip.f3.f1.sh200 \
	      .chip_menu_$selected_chip.f3.f1.sh300 \
	      .chip_menu_$selected_chip.f3.f1.sh400 \
	      -side top \
	      -fill x \
	      -in .chip_menu_$selected_chip.f3.f1

         label .chip_menu_$selected_chip.f3.f2.label \
		 -text "Sampling rate" \
		 -bg #8dd
         radiobutton .chip_menu_$selected_chip.f3.f2.sr30 \
		 -text "30 MHz  " \
		 -variable Temp_Cal_sampling_rate \
		 -value 0  \
		 -bg #8dd  \
		 -activebackground #7cc \
		 -highlightthickness 0
         radiobutton .chip_menu_$selected_chip.f3.f2.sr20 \
		 -text "20 MHz  " \
		 -variable Temp_Cal_sampling_rate \
		 -value 1  \
		 -bg #8dd \
		 -activebackground #7cc \
		 -highlightthickness 0
         radiobutton .chip_menu_$selected_chip.f3.f2.sr15 \
		 -text "15 MHz  " \
		 -variable Temp_Cal_sampling_rate \
		 -value 2 \
		 -bg #8dd \
		 -activebackground #7cc \
		 -highlightthickness 0
         radiobutton .chip_menu_$selected_chip.f3.f2.srnw \
		 -text "No write" \
		 -variable Temp_Cal_sampling_rate \
		 -value 3 \
		 -bg #8dd \
		 -activebackground #7cc   \
		 -highlightthickness 0           
          pack .chip_menu_$selected_chip.f3.f2.label  \
		.chip_menu_$selected_chip.f3.f2.sr30 \
		.chip_menu_$selected_chip.f3.f2.sr20 \
		.chip_menu_$selected_chip.f3.f2.sr15 \
		.chip_menu_$selected_chip.f3.f2.srnw -side top -in .chip_menu_$selected_chip.f3.f2 -fill x

         label .chip_menu_$selected_chip.f3.f3.label -text "Skip Control" -bg #8dd
         radiobutton .chip_menu_$selected_chip.f3.f3.skno -text  "No skip  " -variable Temp_Cal_skip -value 0 -bg #8dd -activebackground #7cc  -highlightthickness 0
         radiobutton .chip_menu_$selected_chip.f3.f3.sk2nd -text "Every 2nd" -variable Temp_Cal_skip -value 1 -bg #8dd -activebackground #7cc  -highlightthickness 0          
         radiobutton .chip_menu_$selected_chip.f3.f3.sk3rd -text "Every 3rd" -variable Temp_Cal_skip -value 2 -bg #8dd -activebackground #7cc -highlightthickness 0
         radiobutton .chip_menu_$selected_chip.f3.f3.sk4th -text "Every 4th" -variable Temp_Cal_skip -value 3 -bg #8dd -activebackground #7cc -highlightthickness 0
         pack .chip_menu_$selected_chip.f3.f3.label  .chip_menu_$selected_chip.f3.f3.skno .chip_menu_$selected_chip.f3.f3.sk2nd .chip_menu_$selected_chip.f3.f3.sk3rd .chip_menu_$selected_chip.f3.f3.sk4th -side top -in .chip_menu_$selected_chip.f3.f3 -fill x


# Here readout direction, respond, clock through, set clock b

         frame .chip_menu_$selected_chip.f4.f1 -bg #8dd
         frame .chip_menu_$selected_chip.f4.f2 -bg #8dd
         frame .chip_menu_$selected_chip.f4.f3 -bg #8dd
         frame .chip_menu_$selected_chip.f4.f4 -bg #8dd
	 pack .chip_menu_$selected_chip.f4.f1 \
              .chip_menu_$selected_chip.f4.f2 \
              .chip_menu_$selected_chip.f4.f3 \
              .chip_menu_$selected_chip.f4.f4 \
              -side left \
	      -in .chip_menu_$selected_chip.f4 \
	      -padx 15

         label .chip_menu_$selected_chip.f4.f1.label \
		 -text "Readout Direction" \
		 -bg #8dd -highlightthickness 0
         radiobutton .chip_menu_$selected_chip.f4.f1.right \
		 -text "To the left " \
		 -variable Temp_Cal_readout_direction \
		 -value 0 -bg #8dd  \
		 -activebackground #7cc \
		 -highlightthickness 0
         radiobutton .chip_menu_$selected_chip.f4.f1.left \
		 -text  "To the right" \
		 -variable Temp_Cal_readout_direction \
		 -value 1 \
		 -bg #8dd \
		 -activebackground #7cc \
		 -highlightthickness 0
         pack .chip_menu_$selected_chip.f4.f1.label  \
	      .chip_menu_$selected_chip.f4.f1.right \
	      .chip_menu_$selected_chip.f4.f1.left  \
	      -side top \
	      -fill x \
	      -in .chip_menu_$selected_chip.f4.f1

### (NB the respond to read cannot be arbitrary.....)
###         label .chip_menu_$selected_chip.f4.f2.label \
###		 -text "Respond to read" \
###		 -bg #8dd \
###		 -highlightthickness 0
###         radiobutton .chip_menu_$selected_chip.f4.f2.yes \
###		 -text "yes" \
###		 -variable Temp_Cal_respond \
###		 -value 1 \
###		 -bg #8dd \
###		 -activebackground #7cc \
###		 -highlightthickness 0
###         radiobutton .chip_menu_$selected_chip.f4.f2.no \
###		 -text "no " \
###		 -variable Temp_Cal_respond \
###		 -value 0 \
###		 -bg #8dd \
###		 -activebackground #7cc \
###		 -highlightthickness 0
###         pack .chip_menu_$selected_chip.f4.f2.label  \
###		 .chip_menu_$selected_chip.f4.f2.yes \
###		 .chip_menu_$selected_chip.f4.f2.no  \
###		 -side top \
###		 -fill x \
###		 -in .chip_menu_$selected_chip.f4.f2
###

          if {$Temp_Cal_respond == 0} {
	      set flag1 "NO"
	      set flag2 "   "
	  } else {
	      set flag1 "YES"
	      set flag2 "   "
	  }
	  if {$selected_chip == "all"} {
	      set flag1 "  DEPENDS  "
	      set flag2 "ON THE CHIP"
	  }
         label .chip_menu_$selected_chip.f4.f2.label \
		 -text "Respond to read" \
		 -bg #8dd \
		 -highlightthickness 0
         label .chip_menu_$selected_chip.f4.f2.yn \
		 -text "$flag1" \
		 -bg #f00 \
		 -highlightthickness 0
         label .chip_menu_$selected_chip.f4.f2.blank \
		 -text $flag2 \
		 -bg #f00 \
		 -highlightthickness 0
         pack .chip_menu_$selected_chip.f4.f2.label  \
		 .chip_menu_$selected_chip.f4.f2.yn \
		 .chip_menu_$selected_chip.f4.f2.blank  \
		 -side top \
		 -fill x \
		 -in .chip_menu_$selected_chip.f4.f2




         label .chip_menu_$selected_chip.f4.f3.label \
		 -text "Clock through" \
		 -bg #8dd -highlightthickness 0
         radiobutton .chip_menu_$selected_chip.f4.f3.no \
		 -text "no " \
		 -variable Temp_Cal_clock_through \
		 -value 0 \
		 -bg #8dd \
		 -activebackground #7cc \
		 -highlightthickness 0
         radiobutton .chip_menu_$selected_chip.f4.f3.yes \
		 -text "yes" \
		 -variable Temp_Cal_clock_through \
		 -value 1 \
		 -bg #8dd \
		 -activebackground #7cc \
		 -highlightthickness 0
         pack .chip_menu_$selected_chip.f4.f3.label \
	      .chip_menu_$selected_chip.f4.f3.yes \
	      .chip_menu_$selected_chip.f4.f3.no  \
	      -side top \
	      -fill x \
	      -in .chip_menu_$selected_chip.f4.f3


         label .chip_menu_$selected_chip.f4.f4.label \
		 -text "Set Clock B" \
		 -bg #8dd \
		 -highlightthickness 0
         radiobutton .chip_menu_$selected_chip.f4.f4.no \
		 -text "No Select " \
		 -variable Temp_Cal_Set_Clock_B \
		 -value 0 \
		 -bg #8dd \
		 -activebackground #7cc \
		 -highlightthickness 0
         radiobutton .chip_menu_$selected_chip.f4.f4.b \
		 -text  "B Selected" \
		 -variable Temp_Cal_Set_Clock_B \
		 -value 1 \
		 -bg #8dd \
		 -activebackground #7cc \
		 -highlightthickness 0
         pack .chip_menu_$selected_chip.f4.f4.label  \
	      .chip_menu_$selected_chip.f4.f4.no \
	      .chip_menu_$selected_chip.f4.f4.b  \
	      -side top \
	      -fill x \
	      -in .chip_menu_$selected_chip.f4.f4



# Here for the calibration mask

         label .chip_menu_$selected_chip.f5.label \
		 -text "CALIBRATION MASKS (In Hex)" -bg #aff \
		 -highlightthickness 0
         button .chip_menu_$selected_chip.f5.b0 \
                -text "Set all to " \
                -command {
		    set j 0
		    while {$j <=7} {
			set Temp_Cal_calib_mask($j) $Temp2
			incr j 1
		    }
		} \
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0
         button .chip_menu_$selected_chip.f5.easy \
                -text "Easy setup" \
                -command cal_set_masks \
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0

	entry .chip_menu_$selected_chip.f5.e0 \
		     -width 6 \
		     -relief sunken \
		     -textvariable Temp2 \
		     -bg #aff \
		     -highlightcolor #f00 \
		     -highlightbackground #8dd
         pack .chip_menu_$selected_chip.f5.label \
	      .chip_menu_$selected_chip.f5.b0 \
	      .chip_menu_$selected_chip.f5.e0 \
	      .chip_menu_$selected_chip.f5.easy \
		 -side left \
		 -padx 6 \
		 -in .chip_menu_$selected_chip.f5

         set j 0
         while {$j <= 7} {
	     set k1 [expr $j*16]
	     set k2 [expr $k1+15]
	     set this_frame f7
	     if {$j <= 3} {
		 set this_frame f6
	     }
	     label .chip_menu_$selected_chip.$this_frame.l$j \
		     -text "Bits $k1-$k2" \
		     -bg #8dd \
		     -highlightthickness 0
	     entry .chip_menu_$selected_chip.$this_frame.e$j \
		     -width 6 \
		     -relief sunken \
		     -textvariable Temp_Cal_calib_mask($j) \
		     -bg #aff  \
		     -highlightcolor #f00 \
		     -highlightbackground #8dd
	     pack .chip_menu_$selected_chip.$this_frame.l$j \
		  .chip_menu_$selected_chip.$this_frame.e$j \
		  -side left \
		  -padx 4 \
		  -in .chip_menu_$selected_chip.$this_frame
             incr j 1
	 }
	 

# Here for the channel mask


         label .chip_menu_$selected_chip.f8.label \
		 -text "CHANNEL MASKS (In Hex)" -bg #aff \
		 -highlightthickness 0
         button .chip_menu_$selected_chip.f8.b0 \
                -text "Set all to " \
                -command {
		    set j 0
		    while {$j <=7} {
			set Temp_Cal_channel_mask($j) $Temp3
			incr j 1
		    }
		} \
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0
         button .chip_menu_$selected_chip.f8.easy \
                -text "Easy setup" \
                -command cal_set_masks \
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0
	entry .chip_menu_$selected_chip.f8.e0 \
		     -width 6 \
		     -relief sunken \
		     -textvariable Temp3 \
		     -bg #aff \
		     -highlightcolor #f00 \
		     -highlightbackground #8dd




         pack .chip_menu_$selected_chip.f8.label \
		 .chip_menu_$selected_chip.f8.b0 \
		 .chip_menu_$selected_chip.f8.e0 \
		 .chip_menu_$selected_chip.f8.easy \
		 -side left \
		 -padx 6 \
		 -in .chip_menu_$selected_chip.f8
         set j 0
         while {$j <= 7} {
	     set k1 [expr $j*16]
	     set k2 [expr $k1+15]
	     set this_frame f10
	     if {$j <= 3} {
		 set this_frame f9
	     }
	     label .chip_menu_$selected_chip.$this_frame.l$j \
		     -text "Bits $k1-$k2" \
		     -bg #8dd -highlightthickness 0
	     entry .chip_menu_$selected_chip.$this_frame.e$j \
		     -width 6 \
		     -relief sunken \
		     -textvariable Temp_Cal_channel_mask($j) \
		     -bg #aff \
		     -highlightcolor #f00 \
		     -highlightbackground #8dd
	     pack .chip_menu_$selected_chip.$this_frame.l$j \
		  .chip_menu_$selected_chip.$this_frame.e$j \
		  -side left \
		  -padx 4 \
		  -in .chip_menu_$selected_chip.$this_frame
             incr j 1
	 }
	 
# Here for the ok and cancel buttons, as well as the digital test pattern

        set chip_menu_talk 0
        frame .chip_menu_$selected_chip.f11.f1 -bg #00f
        frame .chip_menu_$selected_chip.f11.f2 -bg #00f
        pack .chip_menu_$selected_chip.f11.f1 \
	     .chip_menu_$selected_chip.f11.f2 \
	     -side left -padx 20 \
	     -in .chip_menu_$selected_chip.f11
        frame .chip_menu_$selected_chip.f11.f2.f1 -bg #00f
        frame .chip_menu_$selected_chip.f11.f2.f2 -bg #00f 
        pack  .chip_menu_$selected_chip.f11.f2.f1 \
	      .chip_menu_$selected_chip.f11.f2.f2 \
	      -side left -in .chip_menu_$selected_chip.f11.f2


        button .chip_menu_$selected_chip.f11.f1.ok \
		-text "OK" \
		-command "set chip_menu_talk 1" \
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0
        button .chip_menu_$selected_chip.f11.f1.cancel \
		-text "CANCEL" \
		-command "set chip_menu_talk 2" \
		-bg #8dd \
		-activebackground #7cc \
		-highlightthickness 0

        label .chip_menu_$selected_chip.f11.f2.f1.l \
		-text "Test Pattern   " \
		-bg #8dd  \
		-highlightthickness 0
        entry .chip_menu_$selected_chip.f11.f2.f1.e \
		-width 3 -relief sunken \
		-textvariable Temp_Cal_test_pattern \
		-bg #aff \
		-highlightcolor #f00 \
		-highlightbackground #8dd
        label .chip_menu_$selected_chip.f11.f2.f2.l \
		-text "Max jitter time (decimal)" \
		-bg #8dd \
		-highlightthickness 0
        entry .chip_menu_$selected_chip.f11.f2.f2.e \
		-width 3 \
		-relief sunken \
		-textvariable Temp_Cal_jitter \
		-bg #aff \
		-highlightcolor #f00 \
		-highlightbackground #8dd
        pack .chip_menu_$selected_chip.f11.f1.ok \
	     .chip_menu_$selected_chip.f11.f1.cancel \
	     -padx 4 \
	     -side left \
	     -in .chip_menu_$selected_chip.f11.f1


        pack .chip_menu_$selected_chip.f11.f2.f1.l \
	     .chip_menu_$selected_chip.f11.f2.f1.e \
	     -side left \
	     -padx 4 \
	     -in .chip_menu_$selected_chip.f11.f2.f1

        pack .chip_menu_$selected_chip.f11.f2.f2.l \
	     .chip_menu_$selected_chip.f11.f2.f2.e \
	     -side left \
	     -padx 4 \
	     -in .chip_menu_$selected_chip.f11.f2.f2



# Here we wait for the user to hit the OK or CANCEL button... we need to check
# the ranges of all the variables (sigh !)


        while {$chip_menu_talk == 0} {

              tkwait variable chip_menu_talk
	      if {$chip_menu_talk == 2} {
	         grab release .chip_menu_$selected_chip
	         destroy .chip_menu_$selected_chip
	         return
	      }

              set good [test_value Temp_Cal_min_threshold $Temp_Cal_min_threshold 0 63]
	      if {$good == 1} {
	         grab set .chip_menu_$selected_chip
		 set chip_menu_talk 0
		 continue
	      }


              set good [test_value Temp_Cal_max_threshold $Temp_Cal_max_threshold 0 63]
	      if {$good == 1} {
	         grab set .chip_menu_$selected_chip
		 set chip_menu_talk 0
		 continue
	      }


              set good [test_value Temp_Cal_step_threshold $Temp_Cal_step_threshold 1 63]
	      if {$good == 1} {
	         grab set .chip_menu_$selected_chip
		 set chip_menu_talk 0
		 continue
	      }


              set good [test_value Temp_Cal_min_charg $Temp_Cal_min_charge 0 63]
	      if {$good == 1} {
	         grab set .chip_menu_$selected_chip
		 set chip_menu_talk 0
		 continue
	      }


              set good [test_value Temp_Cal_max_charge $Temp_Cal_max_charge 0 63]
	      if {$good == 1} {
	         grab set .chip_menu_$selected_chip
		 set chip_menu_talk 0
		 continue
	      }


              set good [test_value Temp_Cal_step_charge $Temp_Cal_step_charge 1 63]
	      if {$good == 1} {
	         grab set .chip_menu_$selected_chip
		 set chip_menu_talk 0
		 continue
	      }


              set good [test_value Temp_Cal_min_charge $Temp_Cal_min_charge 0 $Temp_Cal_max_charge]
	      if {$good == 1} {
	         grab set .chip_menu_$selected_chip
		 set chip_menu_talk 0
		 continue
	      }

              set good [test_value Temp_Cal_min_threshold $Temp_Cal_min_threshold 0 $Temp_Cal_max_threshold]
	      if {$good == 1} {
	         grab set .chip_menu_$selected_chip
		 set chip_menu_talk 0
		 continue
	      }


	      set j 0
	      while {$j <= 7} {
		  set Temp_Cal_calib_mask($j) [fixup_hex $Temp_Cal_calib_mask($j)]
		  set good [test_value Temp_Cal_calib_mask($j) $Temp_Cal_calib_mask($j) 0x0 0xffff]
		  if {$good == 1} {
		      grab set .chip_menu_$selected_chip
		      set chip_menu_talk 0
		      incr j 1
		      continue
		  }

		  set Temp_Cal_channel_mask($j) [fixup_hex $Temp_Cal_channel_mask($j)]
		  set good [test_value Temp_Cal_channel_mask($j) $Temp_Cal_channel_mask($j) 0x0 0xffff]
		  if {$good == 1} {
		      grab set .chip_menu_$selected_chip
		      set chip_menu_talk 0
		      incr j 1
		      continue
		  }
		  incr j 1
	      }
	      if {$good == 1} {continue}

	      set good [test_value Temp_Cal_test_pattern $Temp_Cal_test_pattern 0 15]
	      if {$good == 1} {
		  grab set .chip_menu_$selected_chip
		  set chip_menu_talk 0
		  continue
	      }


	      set good [test_value Temp_Cal_jitter $Temp_Cal_jitter 0 31]
	      if {$good == 1} {
		  grab set .chip_menu_$selected_chip
		  set chip_menu_talk 0
		  continue
	      }




	      set temp_temp $Cal_readout_direction($selected_chip)
	      set Cal_readout_direction($selected_chip) $Temp_Cal_readout_direction
	      set good [cal_check_direction]
 	      if {$good == -9999} {
		  set Cal_readout_direction($selected_chip) $temp_temp
		  grab set .chip_menu_$selected_chip
		  set chip_menu_talk 0
		  continue
	      }


	  }


# Okay, FINALLY, if we get here it is because we are accepting the selection


         set Cal_min_threshold($selected_chip)  $Temp_Cal_min_threshold
         set Cal_max_threshold($selected_chip)  $Temp_Cal_max_threshold
         set Cal_step_threshold($selected_chip) $Temp_Cal_step_threshold
         set Cal_min_charge($selected_chip)     $Temp_Cal_min_charge
         set Cal_max_charge($selected_chip)     $Temp_Cal_max_charge
         set Cal_step_charge($selected_chip)    $Temp_Cal_step_charge
         set Cal_jitter($selected_chip)         $Temp_Cal_jitter   
         set Cal_shaping_time($selected_chip)   $Temp_Cal_shaping_time
         set Cal_sampling_rate($selected_chip)  $Temp_Cal_sampling_rate
         set Cal_skip($selected_chip)           $Temp_Cal_skip
         set Cal_readout_direction($selected_chip) $Temp_Cal_readout_direction
##         set Cal_respond($selected_chip)        $Temp_Cal_respond
         set Cal_clock_through($selected_chip)  $Temp_Cal_clock_through
         set Cal_test_pattern($selected_chip)   $Temp_Cal_test_pattern
         set Cal_Set_Clock_B($selected_chip)    $Temp_Cal_Set_Clock_B
         set j 0
         while {$j <= 7} {
	     set Cal_calib_mask($selected_chip,$j) $Temp_Cal_calib_mask($j)
	     set Cal_channel_mask($selected_chip,$j) $Temp_Cal_channel_mask($j)
	     incr j 1
	 }

# and if the selected_chip was all, we update all of the chips...
# we also warn the user about possible changes in readout_direction
         if {$selected_chip == "all"} {
#####	 cal_warn_readout_direction
	 set do_readout_dir \
	     [cal_yes_no "Do you really want to reset the readout direction?"]
	 set do_masks \
	     [cal_yes_no "Do you want\nto set the masks\non all chips?\n"]
         set i 0
          while {$i < $Cal_number_of_chips} {
           set  Cal_min_threshold($i)     $Temp_Cal_min_threshold
           set  Cal_max_threshold($i)     $Temp_Cal_max_threshold
           set  Cal_step_threshold($i)    $Temp_Cal_step_threshold
           set  Cal_min_charge($i)        $Temp_Cal_min_charge
           set  Cal_max_charge($i)        $Temp_Cal_max_charge
           set  Cal_step_charge($i)       $Temp_Cal_step_charge
           set  Cal_jitter($i)            $Temp_Cal_jitter   
           set  Cal_shaping_time($i)      $Temp_Cal_shaping_time
           set  Cal_sampling_rate($i)     $Temp_Cal_sampling_rate
           set  Cal_skip($i)              $Temp_Cal_skip
	   if {$do_readout_dir == "YES"} {
	       set  Cal_readout_direction($i) $Temp_Cal_readout_direction
	   }
##           set  Cal_respond($i)           $Temp_Cal_respond
           set  Cal_clock_through($i)     $Temp_Cal_clock_through
           set  Cal_test_pattern($i)      $Temp_Cal_test_pattern
           set  Cal_Set_Clock_B($i)      $Temp_Cal_Set_Clock_B
           if {$do_masks == "YES"} {
	       set  j 0
	       while {$j <= 7} {
		   set  Cal_calib_mask($i,$j) $Temp_Cal_calib_mask($j)
		   set  Cal_channel_mask($i,$j) $Temp_Cal_channel_mask($j)
		   incr j 1
	       }
	   }
	   incr i 1
        }
# also, since this is the window for 'all' chips, ask the user about charge inj
# for two sided hybrids
        if {$Cal_Side_Hybrid == 2} {
	    cal_ask_charge
	}
    }

       grab release .chip_menu_$selected_chip
       destroy .chip_menu_$selected_chip
       return



}
         
proc cal_warn_readout_direction {} {
global cal_dialog
     set cal_dialog 0
#- the current grab
     set grab_current [grab current]

     toplevel .cal_warn -bg #00f
     grab set .cal_warn
     label .cal_warn.label \
	   -text "WARNING: \n You have changed the readout direction in \n a way that may or may not please you.... \n you can reset it by clicking on \n
\n Readout Direction Setup \n \n " \
	   -bd 2 \
           -bg #aff \
	   -highlightthickness 0
     button .cal_warn.b \
	     -text "Okay" \
	     -command "set cal_dialog 1" \
	     -relief raised \
	     -bd 2 \
	     -bg #f00 \
	     -activebackground #7cc \
	     -highlightthickness 0
     pack .cal_warn.label .cal_warn.b -side top -in .cal_warn

     tkwait variable cal_dialog
     grab release .cal_warn    
     if {[string length $grab_current] != 0} {
        grab set $grab_current
     }
     destroy .cal_warn
     return
}
#-----------------------------------------------------------------------------
# Ask the user what to do about charge injection parameters for 2 sided hybrid
#-----------------------------------------------------------------------------
proc cal_ask_charge {} {
    source cal_global.tcl
    global cal_dialog
    global cal_ask_choice

    if {$Cal_Side_Hybrid == 1} {return}

#- the current grab
     set grab_current [grab current]

    set cal_dialog 0
    set cal_ask_choice 0
    toplevel .cal_ask     -bg #00f
    frame    .cal_ask.f1  -bg #00f
    frame    .cal_ask.f2  -bg #00f
    pack     .cal_ask.f1 .cal_ask.f2 -in .cal_ask -side top
    grab set .cal_ask
    label .cal_ask.lbl \
	   -text "You have set the parameters on a two sided hybrid in a global way.\nThe meaning of the charge injection settings varies on the two sides.\n\nFor consistency, you may want to change the charge parameters that\nyou have just set (Q) to 63-Q.  In this case, the minimum and maximum\nsettings will also be switched appropriately\n\n   How would you like to proceed ?" \
           -bg #aff \
	   -highlightthickness 0
    radiobutton .cal_ask.r0 \
		 -text " Leave it as is, thank you       " \
		 -variable cal_ask_choice \
		 -value 0  \
		 -bg #8dd \
		 -activebackground #7cc \
		 -highlightthickness 0
    radiobutton .cal_ask.r1 \
		 -text " Change parameters on TOP side   " \
		 -variable cal_ask_choice \
		 -value 1  \
		 -bg #8dd \
		 -activebackground #7cc \
		 -highlightthickness 0
    radiobutton .cal_ask.r2 \
		 -text " Change parameters on BOTTOM side" \
		 -variable cal_ask_choice \
		 -value 2  \
		 -bg #8dd \
		 -activebackground #7cc \
		 -highlightthickness 0
     button .cal_ask.ok \
	         -text "Okay" \
		 -command "set cal_dialog 1" \
		 -relief raised \
		 -bd 2 \
		 -bg #f00 \
		 -activebackground #7cc \
		 -highlightthickness 0
    pack .cal_ask.lbl .cal_ask.r0 .cal_ask.r1 .cal_ask.r2 \
	         -side top -anchor w \
		 -pady 5 \
		 -in .cal_ask.f1
    pack .cal_ask.ok -in .cal_ask.f2
#- wait for the OK button to be pressed
     tkwait variable cal_dialog
     if {$cal_ask_choice == 0} {
        grab release .cal_ask
        if {[string length $grab_current] != 0} {
	    grab set $grab_current
	}
        destroy .cal_ask
        return
     } elseif {$cal_ask_choice == 1} {
	 set first 0
	 set last  [expr $Cal_number_of_chips_top - 1]
     } elseif {$cal_ask_choice == 2} {
	 set first $Cal_number_of_chips_top
	 set last [expr $Cal_number_of_chips - 1]
     }
     set i $first
     while {$i <= $last} {
	 set temp1 $Cal_min_charge($i)
	 set temp2 $Cal_max_charge($i)
	 set Cal_min_charge($i) [expr 63 - $temp2]
	 set Cal_max_charge($i) [expr 63 - $temp1]
	 incr i 1
     }
        grab release .cal_ask
        if {[string length $grab_current] != 0} {
	    grab set $grab_current
	}
        destroy .cal_ask
        return
 }



