proc cal_format_check {} {
 source cal_global.tcl
 global cal_talk
 global bit

# this variable is needed for the CANCEL and OKAY buttons
    set cal_talk 0

# store the values of the bits in Cal_format_check
    for {set i 0} {$i < 9} {incr i 1} {
	if {$i == 0} {
	    set j 1
	} else {
	    set j [expr $j*2]
	}
	if { [expr $Cal_format_check & $j] != 0 } {
	    set bit($i) 1
	} else {
	    set bit($i) 0
	}
    }

# store the strings associated with the bits
    set name(0)  "Check for start bit          "
    set name(1)  "Check that all chips reported"
    set name(2)  "Check data-status bit        "
    set name(3)  "Check trigger tag            "
    set name(4)  "Check trigger time           "
    set name(5)  "Check valid chan number      "
    set name(6)  "Check no repeat channels     "
    set name(7)  "Check TOT cannot be zero     "
    set name(8)  "Check trailer                "

# setup the window
      toplevel .format_check -bg #00f
      grab set .format_check
      label .format_check.tit -bg #8dd -highlightthickness 0 \
            -text "List of enabled format checks" -anchor w
      pack  .format_check.tit -side top -pady 8
      for {set i 0} {$i < 9} {incr i 1} {
	  checkbutton .format_check.cb$i \
                     -text $name($i) \
                     -variable bit($i) \
                     -anchor w \
                     -bg #fff  \
                     -activebackground #8aa \
                     -highlightthickness 0\
                     -relief raised
	  pack .format_check.cb$i -side top
      }


   button .format_check.cancel \
           -text "CANCEL"  \
           -command "set cal_talk 2" \
           -bg #8dd \
           -activebackground #7cc  \
           -highlightthickness 0
   button .format_check.okay \
           -text "OKAY"  \
           -command "set cal_talk 1" \
           -bg #8dd \
           -activebackground #7cc  \
           -highlightthickness 0
   pack   .format_check.cancel \
          .format_check.okay  \
          -side top \
          -pady 8 


# wait for the user to hit the OK or CANCEL button
   while {$cal_talk == 0} {
       tkwait variable cal_talk
       if {$cal_talk == 1} {
	   set Cal_format_check 0
	   for {set i 0} {$i < 9} {incr i 1} {
	       	if {$i == 0} {
		    set j 1
		} else {
		    set j [expr $j*2]
		}
		if {$bit($i) == 1} {incr Cal_format_check $j}
	    }
	}
    }

# done
    destroy .format_check
}
###############################################################
###############################################################
###############################################################
proc cal_dump_format_check {} {
    global Cal_format_check

# store the strings associated with the bits
    set name(0)  "Check for start bit          "
    set name(1)  "Check that all chips reported"
    set name(2)  "Check data-status bit        "
    set name(3)  "Check trigger tag            "
    set name(4)  "Check trigger time           "
    set name(5)  "Check valid chan number      "
    set name(6)  "Check no repeat channels     "
    set name(7)  "Check TOT cannot be zero     "
    set name(8)  "Check trailer                "

    for {set i 0} {$i < 9} {incr i 1} {
	if {$i == 0} {
	    set j 1
	} else {
	    set j [expr $j*2]
	}
	if { [expr $Cal_format_check & $j] != 0 } {
	    puts "$name($i) ?       YES"
	} else {
	    puts "$name($i) ?       NO"
	}
    }
}
