proc cal_set_direction {} {

# global variables

   global Temp2_Cal_readout_direction
   global Temp2_Cal_ignore
   global Temp2_Cal_respond
   global cal_set_dir_talk
   source cal_global.tcl

# check hybrid and chip numbers

    set good [cal_check_chip_number]
    if {$good == 1} {return}
                        

# store parameters into temporary array
   set i 0
   while {$i < $Cal_number_of_chips} {
       set Temp2_Cal_readout_direction($i) $Cal_readout_direction($i)
       set Temp2_Cal_ignore($i) $Cal_ignore($i)
       set Temp2_Cal_respond($i) $Cal_respond($i)
       incr i 1
   }


# this variable is needed for the CANCEL and OKAY buttons
    set cal_set_dir_talk 0

# setup the window

   toplevel .set_direction -bg #00f
   grab set .set_direction

   frame .set_direction.f0 -relief raised -bd 2 -bg #00f
   pack  .set_direction.f0 -side top -pady 8
   label .set_direction.f0.lab -text "This menu allows the user to \n set the readout direction. \n \n NB The respond-to-read bit \n will be set automatically \n for correct token-passing protocol" -bg #8dd -highlightthickness 0
   pack .set_direction.f0.lab -fill x \
	-in .set_direction.f0

   set i 1
   while {$i <= $Cal_Side_Hybrid} {
       frame .set_direction.f$i -relief raised -bd 2 -bg #00f
       frame .set_direction.ftit$i -relief raised -bd 2 -bg #00f
       pack  .set_direction.ftit$i -side top -pady 8
       pack  .set_direction.f$i -side top -pady 8
       incr i 1
   }
   
   if {$Cal_Side_Hybrid == 1} {
       set nchip(1) $Cal_number_of_chips
   } else {
       set nchip(1) $Cal_number_of_chips_top
       set nchip(2) [expr $Cal_number_of_chips-$nchip(1)]
   }

   set side(1) "Top"
   set side(2) "Bottom"
   set this_chip 0
   set i 1
   while {$i <= $Cal_Side_Hybrid} {
        label .set_direction.ftit$i.lab -text "$side($i) Side of Hybrid" \
		-bg #8dd \
                                     -highlightthickness 0
        pack .set_direction.ftit$i.lab -fill x -in .set_direction.ftit$i
        set j 0
        while {$j < $nchip($i)} {


	    frame .set_direction.f$i.chip$this_chip
	    pack .set_direction.f$i.chip$this_chip \
		    -side left -padx 8 -in .set_direction.f$i


	    label .set_direction.f$i.chip$this_chip.label \
		   -text "Chip $this_chip" -bg #8dd -highlightthickness 0

	    radiobutton .set_direction.f$i.chip$this_chip.left -text "Left " \
                        -variable Cal_readout_direction($this_chip) \
                        -value 0 -bg #8dd \
                        -activebackground #7cc -highlightthickness 0

	    radiobutton .set_direction.f$i.chip$this_chip.right -text "Right" \
                        -variable Cal_readout_direction($this_chip) \
                        -value 1 -bg #8dd \
                        -activebackground #7cc -highlightthickness 0
           
            checkbutton .set_direction.f$i.chip$this_chip.ignore -text "Ignore" \
                        -variable Cal_ignore($this_chip) \
                        -bg #8dd \
                        -activebackground #7cc -highlightthickness 0
           

	    pack .set_direction.f$i.chip$this_chip.label \
		 .set_direction.f$i.chip$this_chip.left \
		 .set_direction.f$i.chip$this_chip.right \
                 .set_direction.f$i.chip$this_chip.ignore \
		        -side top -fill x \
			-in .set_direction.f$i.chip$this_chip


	    incr j 1
	    incr this_chip
	}
	incr i
    }


# Pack the CANCEL and OK buttons
   frame .set_direction.f100 -relief raised -bd 2 -bg #00f    
   pack  .set_direction.f100 -side top -pady 8
   button .set_direction.f100.cancel \
	   -text "CANCEL"  \
	   -command "set cal_set_dir_talk 2" \
	   -bg #8dd \
	   -activebackground #7cc  \
	   -highlightthickness 0
   button .set_direction.f100.okay \
	   -text "OKAY"  \
	   -command "set cal_set_dir_talk 1" \
	   -bg #8dd \
	   -activebackground #7cc  \
	   -highlightthickness 0
   pack   .set_direction.f100.cancel \
          .set_direction.f100.okay  \
	  -side left \
	  -padx 4    \
	  -fill x    \
	  -in .set_direction.f100


# Here we wait for the user to hit the OK or cancel button
# If she hits the CANCEL button, we restore the settings to 
# their initial values.....
# If she hits the OKAY button, we will check that the values make sense;
# if they make sense, we return, if they dont we'll wait 
# for her to fix them............

   while {$cal_set_dir_talk == 0} {
       tkwait variable cal_set_dir_talk

       if {$cal_set_dir_talk == 2} {
           set i 0
           while {$i < $Cal_number_of_chips} {
             set Cal_readout_direction($i) $Temp2_Cal_readout_direction($i)
             set Cal_ignore($i) $Temp2_Cal_ignore($i)
             set Cal_respond($i) $Temp2_Cal_respond($i)
             incr i 1
	   }

	   grab release .set_direction
	   destroy .set_direction
	   return
       }


       grab release .set_direction
       set good [cal_check_direction]
      
       if {$good == -9999} {
          grab set .set_direction
          set cal_set_dir_talk 0
       } else {
             set status [cal_check_ignore]
	   if {$status == 1} {
              grab set .set_direction
              set cal_set_dir_talk 0
           } else { 
	     cal_set_respond_to_read $good
	     destroy .set_direction
	   }
       }
       

   }



return
}



########################################################################
#  This procedure does two things :
#     (1) it checks that the readout directions for all of the chips
#         and it warns the user if they are set incorrectly.  If they
#         are set incorrectly it returns -9999.
#     (2) if they are set correctly, it returns a bit mask of the
#         chips that should respond to the read command
########################################################################
proc cal_check_direction {} {

    source cal_global.tcl
    global cal_check_dir_dlg

    set cal_check_dir_dlg 0
    set return_code 0
    set good 0
    set i 1
    while {$i <= $Cal_Side_Hybrid} {


        if {$Cal_Side_Hybrid == 1} {
	    set first 0
	    set last [expr $Cal_number_of_chips - 1]
	} elseif {$i == 1} {
	    set first 0
	    set last [expr $Cal_number_of_chips_top - 1]
	} else {
	    set first [expr $Cal_number_of_chips_top]
	    set last [expr $Cal_number_of_chips - 1]
	}


        set found_a_one "no"
	set found_a_zero "no"
	set j $first
	while {$j <= $last} {
	    if {$Cal_readout_direction($j) == 0} {
		set found_a_zero "yes"
		if {$found_a_one == "yes"} {
		    set good -9999
		}
	    } else {
		set found_a_one "yes"
	    }
	    incr j 1
	}


	if {$found_a_zero == "yes"} {
	    set temp [expr 1<<$first]
	    set return_code [expr $return_code | $temp]
	}
	if {$found_a_one == "yes"} {
	    set temp [expr 1<<$last]
	    set return_code [expr $return_code | $temp]
	}

	incr i 1
    }

    if {$good ==-9999} {
	set return_code $good
	toplevel .cal_check_dir_dialog -bg #00f
	grab set .cal_check_dir_dialog
	label .cal_check_dir_dialog.label -text "Your setup of the \n readout direction \n is not acceptable. \n \n Please fix it. \n" \
		-bd 2 -bg #aff -highlightthickness 0
	button .cal_check_dir_dialog.button \
	        -text "Okay"  \
		-command "set cal_check_dir_dlg 1" \
		-relief raised \
                -bd 2  \
                -bg #8dd  \
                -activebackground #7cc  \
                -highlightthickness 0
	pack .cal_check_dir_dialog.label \
	     .cal_check_dir_dialog.button \
	     -side top -pady 4 \
	     -in .cal_check_dir_dialog

	tkwait variable cal_check_dir_dlg 
	grab release .cal_check_dir_dialog
	destroy .cal_check_dir_dialog
    }

   
    return $return_code
}


#####################################################################
# this procedure checks if the "ignore" was set in a sensible way.
# it gives user a warning if he/she tries to ignore either all chips on
# one side of the hybrid or the rightmost few.
#####################################################################
proc cal_check_ignore {} {

 source cal_global.tcl
 global cal_check_ignore_dlg
  
     set cal_check_ignore_dlg 0
     set i 1
     set message ""
     set status 0
     set number_chips(1) 0
     set number_chips(2) 0 
     set number_ignored_chips(1) 0
     set number_ignored_chips(2) 0
     while {$i <= $Cal_Side_Hybrid} {
      
      if {$Cal_Side_Hybrid == 1} {
       set first 0
       set last [expr $Cal_number_of_chips - 1]
      } elseif {$i == 1} {
       set first 0
       set last [expr $Cal_number_of_chips_top - 1]
      } else {
       set first [expr $Cal_number_of_chips_top]
       set last [expr $Cal_number_of_chips - 1]
      }
     
    set number_chips($i) [expr $last-$first +1]
 
    set j $last
    while {$j >= $first} {
    if {$Cal_ignore($j) == 1} {
       set number_ignored_chips($i) [expr $number_ignored_chips($i) + 1] 
    } else {
      break
    }
     incr j -1
    }
  
    incr i 1
  }

  set k 1
  while {$k <= 2} {
      if {$k == 1} {
       set side "top"
      } else {
       set side "bottom"
      }

  if {$number_chips($k) == $number_ignored_chips($k)} {
      if {$number_chips($k) == 1} {
          set num "the only selected chip"
      } else {
          set num "all chips"
      }
           set status 1
           set newln "\n"
           set stuff "You are ignoring $num on the $side side. \n  Perhaps you might re-consider this? \n" 
	   set message $message$stuff$newln
    } else {
           if {$number_ignored_chips($k) > 1} {
            set status 1
            set newln "\n"
            set stuff "You are ignoring $number_ignored_chips($k) chips in a row on $side side.\n  Perhaps you might consider using fewer chips for this side? \n" 
            set message $message$stuff$newln 
	   }
    }

  incr k 1
  }   
 
       if {$status == 1} {
       toplevel .cal_check_ignore_dialog -bg #00f
       grab set .cal_check_ignore_dialog
       label .cal_check_ignore_dialog.label -text " $message"\
		-bd 2 -bg #aff -highlightthickness 0
	button .cal_check_ignore_dialog.button \
	        -text "Okay"  \
		-command "set cal_check_ignore_dlg 1" \
		-relief raised \
                -bd 2  \
                -bg #8dd  \
                -activebackground #7cc  \
                -highlightthickness 0
	pack .cal_check_ignore_dialog.label \
	     .cal_check_ignore_dialog.button \
	     -side top -pady 4 \
	     -in .cal_check_ignore_dialog

	tkwait variable cal_check_ignore_dlg 
	grab release .cal_check_ignore_dialog
	destroy .cal_check_ignore_dialog
     

 } #for the i while loop
 
 return $status
}
#####################################################################
# this sets the respond-to-read bits using the flag
# returned from the "cal_check_direction" procedure
#####################################################################
proc cal_set_respond_to_read {flag} {

global Cal_number_of_chips
global Cal_respond

   set i 0
   while {$i <= $Cal_number_of_chips} {
	    set temp  [expr 1<<$i]
            set temp2 [expr $flag&$temp]
            if {$temp2 == 0} {
		set Cal_respond($i) 0
	    } else {
		set Cal_respond($i) 1
	    }
	    incr i 1
	}
    return
    }







