proc cal_set_masks { } {
    global temp_chan_bit
    global temp_calib_bit
    global cal_set_masks_dialog
    global Temp_Cal_calib_mask
    global Temp_Cal_channel_mask

#- the dialog variable
    set cal_set_masks_dialog 0

#- the current grab
    set grab_current [grab current]

#- store the initial bit values
    set ibit 0
    set i    0
    while {$i < 8} {
	set j 0
	while {$j < 16} {
	    if {$j == 0} {
		set jbit 1
	    } else {
		set jbit [expr $jbit*2]
	    }
	    set temp_chan_bit($ibit)   [expr $Temp_Cal_channel_mask($i)& $jbit]
	    set temp_calib_bit($ibit)  [expr $Temp_Cal_calib_mask($i)  & $jbit]
            if {$temp_calib_bit($ibit) !=  0} {
		set temp_calib_bit($ibit) 1
	    }
            if {$temp_chan_bit($ibit) !=  0} {
		set temp_chan_bit($ibit) 1
	    }
	    incr j 1
	    incr ibit 1
	}
	incr i 1
    }

#- main window
    set tp cal_set_masks
    toplevel .$tp -bg #0ff
    grab set .$tp

#- istructions first, with CANCEL and OKAY buttons
    frame .$tp.f100 -bg #0ff
    pack .$tp.f100 -side top -in .$tp
    button .$tp.f100.okay -text "OKAY" \
	    -command "set cal_set_masks_dialog 1" \
           -bg #8dd \
           -activebackground #f00  \
           -highlightthickness 0
    button .$tp.f100.canc -text "CANCEL" \
	    -command "set cal_set_masks_dialog 2" \
           -bg #8dd \
           -activebackground #f00  \
           -highlightthickness 0
    label .$tp.f100.lab -bg #0ff -text \
    "Select bits for channel and calibration mask...button checked <-> bit = 1"
    pack  .$tp.f100.okay .$tp.f100.lab  .$tp.f100.canc  \
	    -in .$tp.f100 -in .$tp.f100 -fill x -pady 10 -padx 10 -side left


#- make the calibration mask label
    frame .$tp.f101 -bg #0ff
    pack  .$tp.f101 -side top -in .$tp
    label .$tp.f101.lab1 -bg #0ff -text "Calibration masks" 
    label .$tp.f101.lab2 -bg #0ff -text "             "
    pack  .$tp.f101.lab2  .$tp.f101.lab1 -in .$tp.f101 -fill x -side top

#- make frames for the bits...in the middle, insert the channel masks label
    set i 0
    while {$i < 16} {
	frame .$tp.f$i -relief raised -bd 2 -bg #00f
	pack .$tp.f$i -side top -in .$tp
	incr i 1
	if {$i == 8} {
	    frame .$tp.f102 -bg #0ff
	    pack  .$tp.f102 -side top -in .$tp
	    label .$tp.f102.lab1 -bg #0ff -text "Channel masks" 
	    label .$tp.f102.lab2 -bg #0ff -text "             "
	    pack  .$tp.f102.lab2  .$tp.f102.lab1 -in .$tp.f102 \
		    -fill x -side top
	}
    }

#- now pack the bit frames
    set iframe 0
    while {$iframe < 16} {
	set j 0
	while {$j < 16} {
	    set itemp [expr 16*$iframe + $j]
	    if {$iframe < 8} {
		set ibit $itemp
	    } else {
		set ibit [expr $itemp - 128]
	    }
	    if {$ibit < 10} {
		set display_bit "00$ibit"
	    } elseif {$ibit < 100} {
		set display_bit "0$ibit"
	    } else {
		set display_bit "$ibit"
	    }
	    if {$iframe < 8} {
	        checkbutton .$tp.f$iframe.$itemp \
			-text "$display_bit" \
                        -variable temp_calib_bit($ibit) \
                        -bg #8dd \
                        -activebackground #f00 -highlightthickness 0
	    } else {
	        checkbutton .$tp.f$iframe.$itemp \
			-text "$display_bit" \
                        -variable temp_chan_bit($ibit) \
                        -bg #8dd \
                        -activebackground #f00 -highlightthickness 0
	    }
	    pack .$tp.f$iframe.$itemp -side left -in .$tp.f$iframe
 	    incr j 1
	}
	incr iframe 1
    }

#- wait for the user to hit the OKAY or CANCEL button
   tkwait variable cal_set_masks_dialog

#- if the user hit OKAY, rewrite the masks
   if {$cal_set_masks_dialog == 1} {
       set ibit 0
       set i    0
       while {$i < 8} {
	   set Temp_Cal_channel_mask($i)  0
	   set Temp_Cal_calib_mask($i)    0
	   set j 0
	   while {$j < 16} {
	       if {$j == 0} {
		   set jbit 1
	       } else {
		   set jbit [expr $jbit*2]
	       }
	       if {$temp_calib_bit($ibit) !=  0} {
		   set Temp_Cal_calib_mask($i) \
			   [expr $Temp_Cal_calib_mask($i) | $jbit]
	       }
	       if {$temp_chan_bit($ibit) !=  0} {
		   set Temp_Cal_channel_mask($i) \
			   [expr $Temp_Cal_channel_mask($i) | $jbit]
	       }
	       incr ibit 1
	       incr j 1
	   }
	   set Temp_Cal_channel_mask($i) \
		   [format "0x%x" $Temp_Cal_channel_mask($i)]
	   set Temp_Cal_calib_mask($i) \
		   [format "0x%x" $Temp_Cal_calib_mask($i)]
	   incr i 1
       }

   }   

#- release the grab, give the grab back, get out of here
    grab release .$tp
    if {[string length $grab_current] != 0} {
	grab set $grab_current
    }
    destroy .$tp
}