#------------------------------------------------------------------------
# write defaults to file cal_default_file
#     write_misc (= YES or NO) is a flag to decide whether
#                the settings of the misc. tests are to be written out  
#     runtype is a string with a description of the run
#-----------------------------------------------------------------------
proc cal_write_defaults {cal_default_file write_misc runtype} {

    source cal_global.tcl
    source misc_global.tcl
    global part_name

    set f [open  $cal_default_file w]

#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# This chunk of code is new to version 1.0  (and subsequent)
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    puts $f "V1.11"

#- following added in 1.01 
    set this_date [exec date]
    puts $f $this_date
    puts $f $Cal_format_check

#- following added in 1.0
    puts $f $write_misc
    puts $f $runtype
    puts $f $part_name
    if {$write_misc == "YES"} {
#- general miscellaneous tests stuff
       for {set i 0} {$i < 5} {incr i 1} {
	   puts $f $misc_tests_list($i)
	   puts $f $misc_nrep($i)
	   if {$i != 2} { 
	       puts $f $misc_cal_dac_top($i,0)
	       puts $f $misc_cal_dac_bottom($i,0)
	   }
	   puts $f $misc_thr_dac($i)
       }

#- TOT specific
       puts $f $misc_ntot
       puts $f $misc_tot_dead
       for {set i 0} {$i < $misc_ntot} {incr i 1} {
	   puts $f $misc_cal_dac_top(2,$i)
	   puts $f $misc_cal_dac_bottom(2,$i)
	   puts $f $misc_tot($i)
	   puts $f $misc_tot_toll($i)
	   puts $f $misc_tot_shaping_time($i)
	   puts $f $misc_tot_test_it($i)
       }
#- TOT skip added in V1.02
       for {set i 0} {$i < $misc_ntot} {incr i 1} {
	   puts $f $misc_tot_skip($i)
       }

#- Time stamp specific
       puts $f $misc_tstamp_shift
       puts $f $misc_tstamp_toll
       puts $f $misc_tstamp_dead

#- here come the test for shorts stuff
       puts $f $misc_tests_list(5)
       puts $f $short_min_chip
       puts $f $short_max_chip
       puts $f $short_thresh
       puts $f $short_charge_top
       puts $f $short_charge_bottom
       puts $f $short_nrep
       for {set i -3} {$i < 4} {incr i 1} {
	   puts $f $short_chan($i)
       }
   }
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# end of version 1.0 chunk
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - -



       puts $f $Cal_compressed_format
       puts $f $Cal_one_at_a_time
       puts $f $Cal_number_of_chips_top
       puts $f $xy_scan
       puts $f $xy_which_axis
       puts $f $xy_x_initial
       puts $f $xy_y_initial
       puts $f $xy_step_size
       puts $f $xy_nstep
       puts $f $xy_start_flag


       puts $f $Cal_error_limit
       puts $f $Cal_histoscope
       puts $f $Cal_fake
       puts $f $Cal_write_file
       puts $f $Cal_number_of_events
       puts $f $Cal_number_of_chips
       puts $f $Cal_number_of_buffers
       puts $f $Cal_Side_Hybrid

       set i 0
       while {$i <= 19} {
         puts $f $Cal_min_threshold($i)
         puts $f $Cal_max_threshold($i)
         puts $f $Cal_step_threshold($i)
         puts $f $Cal_min_charge($i)
         puts $f $Cal_max_charge($i)
         puts $f $Cal_step_charge($i)
         puts $f $Cal_jitter($i)
         puts $f $Cal_shaping_time($i)
         puts $f $Cal_sampling_rate($i)
	 puts $f $Cal_skip($i)
         puts $f $Cal_readout_direction($i)
         puts $f $Cal_respond($i)  
         puts $f $Cal_clock_through($i)  
         puts $f $Cal_test_pattern($i)  
         puts $f $Cal_Set_Clock_B($i)  


         set j 0
         while {$j <= 7} {
            puts $f $Cal_calib_mask($i,$j)
            puts $f $Cal_channel_mask($i,$j)
            incr j 1
         }
	 incr i 1
       }

       set i all
       puts $f $Cal_min_threshold($i)
       puts $f $Cal_max_threshold($i)
       puts $f $Cal_step_threshold($i)
       puts $f $Cal_min_charge($i)
       puts $f $Cal_max_charge($i)
       puts $f $Cal_step_charge($i)
       puts $f $Cal_jitter($i)
       puts $f $Cal_shaping_time($i)
       puts $f $Cal_sampling_rate($i)
       puts $f $Cal_skip($i)
       puts $f $Cal_readout_direction($i)
       puts $f $Cal_respond($i)  
       puts $f $Cal_clock_through($i)  
       puts $f $Cal_test_pattern($i)  
       puts $f $Cal_Set_Clock_B($i)  

       set j 0
       while {$j <= 7} {
            puts $f $Cal_calib_mask($i,$j)
            puts $f $Cal_channel_mask($i,$j)
            incr j 1
       }
#------------------------------------------------
# Add the ignore flag starting from version 1.10
#------------------------------------------------
       for {set i 0} {$i <= 19} {incr i 1} {
	   puts $f $Cal_ignore($i)
       }


       close $f
       return

   }
##########################################################
proc cal_save_defaults {} {

      global cal_dialog
      global userfile
      set cal_dialog -1

      toplevel .save_def -bg #00f

      frame .save_def.f1 -relief raised -bd 2 -bg #00f
      frame .save_def.f2 -relief raised -bd 2 -bg #00f
      frame .save_def.f3 -relief raised -bd 2 -bg #00f
      pack .save_def.f1 .save_def.f2 .save_def.f3 -side top -pady 8

      grab set .save_def

      label .save_def.l1 \
      -text "Here you can choose to save \n defaults to a disk file. \n The default file is cal_defaults.store" \
      -bg #8dd -highlightthickness 0

   
      button .save_def.b1 \
      -text "Save into \n default file" -command "set cal_dialog 1" \
      -bg #8dd -activebackground #7cc -highlightthickness 0

      button .save_def.b2 \
      -text "Save into \n user file" \
      -command "set cal_dialog 2" \
      -bg #8dd -activebackground #7cc -highlightthickness 0


      button .save_def.b3 \
      -text "Cancel \n " \
      -command "set cal_dialog 3" \
      -bg #8dd -activebackground #7cc -highlightthickness 0



      label .save_def.luser \
      -text "User file :" \
      -bg #8dd -highlightthickness 0

      entry .save_def.lentry -relief sunken -width 30 -textvariable userfile 

      pack .save_def.l1 -in .save_def.f1

      pack .save_def.b1 .save_def.b2 .save_def.b3 \
      -side left -in .save_def.f2 

      pack .save_def.luser .save_def.lentry -side left \
      -padx 3 -in .save_def.f3

      tkwait variable cal_dialog
      grab release .save_def
      destroy .save_def

      set uuu "Defaults saved through Save Defaults button"

      if {$cal_dialog == 1} {cal_write_defaults cal_defaults.store YES $uuu}
      if {$cal_dialog == 2} {cal_write_defaults $userfile YES $uuu}
      if {$cal_dialog == 3} {return}

    return
}
