#####################################################
# This is the calibration window
######################################################
proc calibrate {} {

    source cal_global.tcl
    global data_directory
    global part_name
    global site
    if {![info exist Cal_number_of_chips]} {
       cal_get_defaults cal_defaults.store YES
    }
    cal_get_run_number


    set Cal_output_file [std_output_file run]
    set Cal_run "stop"

    if {![winfo exists .calibrate]} {
	toplevel .calibrate -bg #00f

# setup the frames
        frame .calibrate.f0 -bg #00f
        frame .calibrate.f1 -bg #00f
        frame .calibrate.f2 -bg #00f
        frame .calibrate.f3 -bg #00f
        frame .calibrate.f4 -bg #00f

        pack 	.calibrate.f0  \
                .calibrate.f1  \
		.calibrate.f2  \
		.calibrate.f3  \
		.calibrate.f4  \
			-side top  \
			-pady 3


# details of the run and help

	button .calibrate.help \
		-text "Help" \
		-command "cal_help .cal_help cal_helpfile" \
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0
	label .calibrate.run_number_label \
		-text "Run Number"   \
		-bg #8dd \
		-highlightthickness 0
	entry .calibrate.run_number_entry \
		-textvariable Cal_run_number  \
		-width 8 \
		-relief sunken \
		-bg #aff   \
		-highlightcolor #f00 \
		-highlightbackground #8dd \
		-selectbackground #0ff
	label .calibrate.num_events_label \
		-text "Number of Events" \
		-bg #8dd \
		-highlightthickness 0
	entry .calibrate.num_events_entry \
		-textvariable Cal_number_of_events   \
		-width 9 \
		-relief sunken \
		-bg #aff   \
		-highlightcolor #f00 \
		-highlightbackground #8dd \
		-selectbackground #0ff

	label .calibrate.num_chips_label \
		-text "No. of Chips" \
		-bg #8dd \
		-highlightthickness 0
	entry .calibrate.num_chips_entry \
		-relief sunken \
		-width 3 \
		-textvariable Cal_number_of_chips  \
		-bg #aff   \
		-highlightcolor #f00 \
		-highlightbackground #8dd \
		-selectbackground #0ff

	label .calibrate.num_chips_toplabel \
		-text "No. of Chips top side" \
		-bg #8dd \
		-highlightthickness 0
	entry .calibrate.num_chips_topentry \
		-relief sunken \
		-width 3 \
		-textvariable Cal_number_of_chips_top  \
		-bg #aff   \
		-highlightcolor #f00 \
		-highlightbackground #8dd \
		-selectbackground #0ff

	label .calibrate.num_buffers_label \
		-text "No. of Buffers" \
		-bg #8dd \
		-highlightthickness 0
	entry .calibrate.num_buffers_entry \
		-relief sunken \
		-width 1 \
		-textvariable Cal_number_of_buffers  \
		-bg #aff   \
		-highlightcolor #f00 \
		-highlightbackground #8dd \
		-selectbackground #0ff



        radiobutton .calibrate.oneside \
		-text "One-Sided Hybrid" \
                -variable Cal_Side_Hybrid \
		-value 1 \
		-anchor w\
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0\
		-relief raised
        radiobutton .calibrate.twoside \
		-text "Two-Sided Hybrid" \
                -variable Cal_Side_Hybrid \
		-value 2 \
		-anchor w \
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0\
		-relief raised


        pack    .calibrate.help \
                .calibrate.run_number_label \
		.calibrate.run_number_entry \
		.calibrate.num_events_label \
		.calibrate.num_events_entry \
                .calibrate.num_buffers_label \
		.calibrate.num_buffers_entry \
			-side left \
			-fill x \
			-in .calibrate.f0 \
			-padx 4 

	pack 	.calibrate.num_chips_label \
		.calibrate.num_chips_entry \
                .calibrate.num_chips_toplabel \
		.calibrate.num_chips_topentry \
		.calibrate.oneside \
		.calibrate.twoside \
			-side left \
			-fill x \
			-in .calibrate.f1 \
			-padx 4 

# Histoscope ?  Direction Setup ? Chip setup ?
	button .calibrate.chip_setup \
		-text "Chip \nSetup" \
		-command chip_setup  \
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0 \
		-relief raised
	button .calibrate.direction_setup \
		-text "Readout Direction\n  Setup" \
		-command cal_set_direction  \
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0 \
		-relief raised
	checkbutton .calibrate.toggle_hscope \
		-text "Use \nHistoScope" \
		-variable Cal_histoscope  \
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0\
		-relief raised
	checkbutton .calibrate.fake \
		-text "Fake \nevent" \
		-variable Cal_fake  \
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0\
		-relief raised
	label .calibrate.one_at_a_time_label \
		-text "No. of channels to\nbe calibrated at a time" \
		-bg #8dd \
		-highlightthickness 0
	entry .calibrate.one_at_a_time_entry \
		-relief sunken \
		-width 3 \
		-textvariable Cal_one_at_a_time  \
		-bg #aff   \
		-highlightcolor #f00 \
		-highlightbackground #8dd \
		-selectbackground #0ff
	button .calibrate.talk_histoscope \
		-text "Talk to \nHistoScope" \
		-command talk_histoscope  \
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0 \
		-relief raised



	pack    .calibrate.direction_setup \
		.calibrate.chip_setup \
		.calibrate.toggle_hscope \
		.calibrate.talk_histoscope \
                .calibrate.fake \
                .calibrate.one_at_a_time_label \
                .calibrate.one_at_a_time_entry \
		     -padx 3 \
		     -side left \
		     -in .calibrate.f2




# the filename.... and the XY stage stuff .. and the format checks
	checkbutton .calibrate.toggle_write \
		-text "Write \noutput file" \
		-variable Cal_write_file  \
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0\
		-relief raised
	checkbutton .calibrate.toggle_format \
		-text "Compress\noutput" \
		-variable Cal_compressed_format  \
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0\
		-relief raised
	entry .calibrate.filename \
		-width 33 \
		-relief sunken \
		-textvariable Cal_output_file \
		-bg #aff   \
		-highlightcolor #f00 \
		-highlightbackground #8dd \
		-selectbackground #0ff
        checkbutton .calibrate.xyscan \
		-text "XY\nScan" \
		-variable xy_scan  \
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0\
		-relief raised
	button .calibrate.xybutton \
		-text "XY scan\nsetup" \
		-command "xy_stage_window" \
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0
	button .calibrate.format \
		-text "Format\nChecks" \
		-command "cal_format_check" \
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0

	pack .calibrate.toggle_write \
	     .calibrate.toggle_format  \
             .calibrate.filename \
             .calibrate.xyscan \
             .calibrate.xybutton \
             .calibrate.format \
	     -side left \
	     -fill x \
	     -in .calibrate.f3 \
	     -padx 4



# close window, start, save defaults, load defaults, error limit 

	label .calibrate.error_limit_label \
		-text "Error Limit"   \
		-bg #8dd \
		-highlightthickness 0
	entry .calibrate.error_limit_entry \
		-textvariable Cal_error_limit  \
		-width 8 \
		-relief sunken \
		-bg #aff   \
		-highlightcolor #f00 \
		-highlightbackground #8dd \
		-selectbackground #0ff
        button .calibrate.exit \
		-text "Close Window" \
		-command "destroy .calibrate" \
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0
	button .calibrate.start \
		-text "Start The Run" \
		-command "start_running" \
		-bg #8dd  \
		-activebackground #7cc \
		-highlightthickness 0
	button .calibrate.sd1 \
		-text "Save Defaults" \
		-command "cal_save_defaults" \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0
	button .calibrate.rd1 \
		-text "Load Defaults" \
		-command "cal_choose_def" \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0
	pack  	.calibrate.start \
		.calibrate.sd1 .calibrate.rd1 \
		.calibrate.exit  \
                .calibrate.error_limit_label \
                .calibrate.error_limit_entry \
			-padx 5 \
			-pady 5 \
			-side left \
			-in .calibrate.f4
}
return
}

#----------------------------------------------------
# This procedure returns the name of the standard output
# file for this runnumber and for this part
# e.g. data_directory = /babar/data
#      part           = dummy
#      key            = run
#      runnumber      = 754
#       -------> /babar/data/dummy/run754.dat
#------------------------------------------------
proc std_output_file { key } {
 source cal_global.tcl
 global data_directory
 global part_name

    set data_directory [string trim $data_directory]
    set part_name      [string trim $part_name]
# make sure data_directory has a trailing slask
    set mytemp1 "/"
    set junk    [string trimright $data_directory "/"]
    if {$junk == $data_directory} {
	set data_directory $junk$mytemp1
    }

    set mytemp2 $key
    if {$part_name != ""} {
	set root_file $data_directory$part_name$mytemp1$mytemp2
    } else {
	set root_file $data_directory$mytemp2
    }
    set stdfile $root_file$Cal_run_number.dat
    return $stdfile
}







