proc chip_setup {} {

    global Cal_number_of_chips
    global selected_chip
    global chip_setup_action


# check that the number of chips is valid
    set good [cal_check_chip_number]
    if {$good == 1} {return}



    toplevel .chip_setup -bg #00f

    frame .chip_setup.f1 -bg #00f
    frame .chip_setup.f2 -bg #00f
    frame .chip_setup.f3 -bg #00f

    pack 	.chip_setup.f1  \
		.chip_setup.f2  \
		.chip_setup.f3 -in  \
		.chip_setup  \
			-side top  \
			-pady 2

    grab set .chip_setup
    message .chip_setup.msg  \
		-width 8c  \
		-justify center  \
		-relief raised  \
		-bg #aff  \
		-bd 2  \
		-text "Here you can change parameters for the chips.  Choose the chip you are interested in, then click OK.  Click CANCEL to abort"
    pack .chip_setup.msg  \
		-pady 2  \
		-padx 2  \
		-in .chip_setup.f1

    set i 0
    while {$i < $Cal_number_of_chips} {
	radiobutton .chip_setup.b$i  \
		-text "Chip $i"  \
		-variable selected_chip  \
		-value $i  \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0  \
		-anchor w
	incr i 1
    	}

    radiobutton .chip_setup.ball  \
		-text "All Chips"  \
		-variable selected_chip -value all  \
		-bg #8dd  \
		-activebackground #7cc   \
		-highlightthickness 0  \
		-anchor w 

    set i 0
    while {$i <  $Cal_number_of_chips} {
	pack .chip_setup.b$i  \
		-side bottom  \
		-fill x  \
		-in .chip_setup.f2
	incr i 1
    	}

    pack .chip_setup.ball  \
		-side bottom  \
		-in .chip_setup.f2


    set chip_setup_action 0
    button .chip_setup.ok  \
		-text "OK"  \
		-command "set chip_setup_action 1"  \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0
    button .chip_setup.cancel  \
		-text "CANCEL"  \
		-command "set chip_setup_action 2"  \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0
    pack 	.chip_setup.ok  \
		.chip_setup.cancel  \
			-side left  \
			-padx 3  \
			-in .chip_setup.f3


    while {$chip_setup_action == 0} {
        tkwait variable chip_setup_action
        if {$chip_setup_action == 2} {
           grab release .chip_setup
           destroy .chip_setup
	   return
	}
        if {$selected_chip != "all"} {
	   if {$selected_chip < 0 || $selected_chip >= $Cal_number_of_chips} {
	       set chip_setup_action 0
	   }
       }
   }

   grab release .chip_setup
   destroy .chip_setup
   cal_chip_menu $selected_chip

   

}
