###########################################################
# THIS FILE CONTAINS CODE FOR THE DCX VM100 MOTOR CONTROL
# MODULE AND FOR THE SONY LINEAR ENCODER READOUT AT UCSB
###########################################################
#5/18/96 sanjay 
#Hacked by Claudio, Nov 7 1996

source mutil.tcl
source msetup.tcl
source mtog.tcl
#include default values of parameters here
set ma 1
set mxcmd ""
set mn 1
set mvc "mr+"
set mva "mr-"
set stat1 "OFF"
set stat2 "OFF"
set x_encoder_out "??"
set y_encoder_out "??"
set xreq "Xr"
set yreq "Yr"
set dcmd " "
set reply " "



######################################################
# This is the procedure that pops up the motor window
######################################################
proc motor { } {
   global m_acc_def
   global m_ini_def
   global m_vel_def
   global m_acc
   global m_ini
   global m_vel
   global nstep_hilo



    set_default_motor_parameters
    set_default_encoder_parameters
    if {[winfo exists .motor]} {return}
    toplevel .motor -bg #00f
    global m_acc
    global m_ini
    global m_vel
    global ma 
    global mxcmd
    global mn 
    global mvc 
    global mva
    global stat1
    global stat2 
    global reply
    global dcmd
    global y_move_to
    global x_move_to
    global yc_move_to
    global xc_move_to
    global chan
    global chancoord
    global pitch


    if {[info exists chan(X)] == 0} {
# Phi channel number and X encoder position
    set chan(X)      188.8
    set chancoord(X) 73.0775
# Z channel number and Y encoder position
    set chan(Y)       544
    set chancoord(Y) -96.9345
# pitches
    set pitch(X) 0.055
    set pitch(Y) 0.100
}

# frames 
        frame .motor.f0 -bg #00f
        frame .motor.f1 -bg #00f
        frame .motor.f2 -bg #00f
        frame .motor.f3 -bg #00f
        frame .motor.f41 -bg #00f
        frame .motor.f42 -bg #00f
        frame .motor.f5 -bg #00f
        frame .motor.f6 -bg #00f
        frame .motor.f65 -bg #00f
        frame .motor.f7 -bg #00f
        frame .motor.f8 -bg #00f
        frame .motor.f9 -bg #00f
        frame .motor.f95 -bg #00f
        frame .motor.f96 -bg #00f
        frame .motor.f97 -bg #00f
        frame .motor.f98 -bg #00f
        frame .motor.f99 -bg #00f
        frame .motor.f100 -bg #00f
        frame .motor.f101 -bg #00f
        frame .motor.f11 -bg #00f
        frame .motor.f12 -bg #00f
        pack  .motor.f11  .motor.f12 \
              .motor.f0 .motor.f1 .motor.f2 .motor.f3  .motor.f41 \
              .motor.f42 .motor.f5 .motor.f6 .motor.f65 .motor.f7 \
              .motor.f95 .motor.f96 .motor.f97 .motor.f98 \
	      .motor.f99 .motor.f100 .motor.f101 .motor.f8 \
              .motor.f9  -side top -pady 2

# axis setup window
    label .motor.axis -text "Axis" -bg #8dd  -highlightthickness 0 -anchor w
    radiobutton .motor.one -text "X (1-phi)" -variable ma -value 1 -anchor e \
                -bg #8dd -activebackground #7cc
    radiobutton .motor.two -text "Y (2-z)" -variable ma -value 2 -anchor e \
                -bg #8dd -activebackground #7cc
    pack .motor.axis .motor.one .motor.two -side left -in .motor.f0 -ipadx 5
    
# single stepping window
     label .motor.mv  -text "Move"  -bg #8dd -anchor center \
           -height 2 -highlightthickness 0
     button .motor.clk -relief raised \
            -width 3 -text ">" \
            -command {move_axis_protect $ma "+" $mn} -bd 2 \
           -bg #8dd -activebackground #7cc  
     button  .motor.aclk -relief raised \
            -width 3  -text "<" \
            -command {move_axis_protect $ma "-" $mn} -bd 2 \
            -bg #8dd -activebackground #7cc  
     pack .motor.mv .motor.clk .motor.aclk  \
          -fill x -side left -in .motor.f1 -ipadx 3




     one_lentry .motor.step "Steps" .motor.numsteps 10 mn .motor.f2 6
     label .motor.stepsize \
     -text " 1 step = 0.015875 mm" \
     -bg #ff0 -highlightthickness 0
     pack .motor.stepsize -in .motor.f2 -side left -padx 2

# one_button .motor.param "Parameter Setup" motor_psetup .motor.f3 0 

#status buttons..
mstatus 1
mstatus 2
mstatb

#coordinates..
mxpos
mypos

           


#move to position
     button .motor.mpbx -text "Move to x-position (mm) --> " \
	     -command {move_to_position_interactive X $x_move_to} \
             -bg #8dd -anchor center \
             -height 2 -highlightthickness 0 
     entry .motor.mpex \
           -width 9   \
           -textvariable x_move_to \
           -relief sunken  \
           -bg #aff   \
           -highlightcolor #f00  \
           -highlightbackground #8dd
     pack .motor.mpbx .motor.mpex  -padx 4 -fill x -side left \
           -in .motor.f95 -ipadx 3

     button .motor.mpby -text "Move to y-position (mm) --> " \
	     -command {move_to_position_interactive Y $y_move_to} \
             -bg #8dd -anchor center \
             -height 2 -highlightthickness 0 
     entry .motor.mpey \
           -width 9   \
           -textvariable y_move_to \
           -relief sunken  \
           -bg #aff   \
           -highlightcolor #f00  \
           -highlightbackground #8dd
     pack .motor.mpby .motor.mpey  -padx 4 -fill x -side left \
           -in .motor.f96 -ipadx 3

     button .motor.mpbxc -text "Move to phi (x) channel  --> " \
	     -command {move_to_channel_interactive X $xc_move_to} \
             -bg #8dd -anchor center \
             -height 2 -highlightthickness 0 
     entry .motor.mpexc \
           -width 9   \
           -textvariable xc_move_to \
           -relief sunken  \
           -bg #aff   \
           -highlightcolor #f00  \
           -highlightbackground #8dd
     pack .motor.mpbxc .motor.mpexc  -padx 4 -fill x -side left \
           -in .motor.f97 -ipadx 3

     button .motor.mpbyc -text "Move to z   (y) channel   --> " \
	     -command {move_to_channel_interactive Y $yc_move_to} \
             -bg #8dd -anchor center \
             -height 2 -highlightthickness 0 
     entry .motor.mpeyc \
           -width 9   \
           -textvariable yc_move_to \
           -relief sunken  \
           -bg #aff   \
           -highlightcolor #f00  \
           -highlightbackground #8dd
     pack .motor.mpbyc .motor.mpeyc  -padx 4 -fill x -side left \
           -in .motor.f98 -ipadx 3


# correspondance between channel and position
     label .motor.lphich1  -text "Phi chan"  -bg #8dd -anchor center \
           -height 1 -highlightthickness 0
     entry .motor.ephich1 -width 5 -textvariable chan(X) -relief sunken \
	     -bg #aff -highlightcolor #f00 -highlightbackground #8dd
     label .motor.lphich2  -text "-> X = "  -bg #8dd -anchor center \
           -height 1 -highlightthickness 0
     entry .motor.ephich2 -width 9 -textvariable chancoord(X) -relief sunken \
	     -bg #aff -highlightcolor #f00 -highlightbackground #8dd
     label .motor.lphich3  -text " mm "  -bg #8dd -anchor center \
           -height 1 -highlightthickness 0
     pack .motor.lphich1 .motor.ephich1 .motor.lphich2 .motor.ephich2 \
          .motor.lphich3 -padx 2 -fill x -side left \
          -in .motor.f99 -ipadx 3

     label .motor.lzch1  -text "Z chan  "  -bg #8dd -anchor center \
           -height 1 -highlightthickness 0
     entry .motor.ezch1 -width 5 -textvariable chan(Y) -relief sunken \
	     -bg #aff -highlightcolor #f00 -highlightbackground #8dd
     label .motor.lzch2  -text "-> Y = "  -bg #8dd -anchor center \
           -height 1 -highlightthickness 0
     entry .motor.ezch2 -width 9 -textvariable chancoord(Y) -relief sunken \
	     -bg #aff -highlightcolor #f00 -highlightbackground #8dd
     label .motor.lzch3  -text " mm "  -bg #8dd -anchor center \
           -height 1 -highlightthickness 0
     pack .motor.lzch1 .motor.ezch1 .motor.lzch2 .motor.ezch2 \
          .motor.lzch3 -padx 2 -fill x -side left \
          -in .motor.f100 -ipadx 3

# pitches
    label .motor.pitch1 -text "Pitch in mm: " -bg #8dd -anchor center \
           -height 1 -highlightthickness 0
    label .motor.pitch2 -text " Phi = " -bg #8dd -anchor center \
           -height 1 -highlightthickness 0
    entry .motor.epitch1 -width 4 -textvariable pitch(X) -relief sunken \
	     -bg #aff -highlightcolor #f00 -highlightbackground #8dd
    label .motor.pitch3 -text " Z = " -bg #8dd -anchor center \
           -height 1 -highlightthickness 0
    entry .motor.epitch2 -width 4 -textvariable pitch(Y) -relief sunken \
	     -bg #aff -highlightcolor #f00 -highlightbackground #8dd
    pack .motor.pitch1 .motor.pitch2 .motor.epitch1 .motor.pitch3 \
         .motor.epitch2  -padx 4 -fill x -side left \
          -in .motor.f101 -ipadx 3


     one_button .motor.hlp "Help" \
                "cal_help .motor_help motor_helpfile"   .motor.f11 10
     xit .motor .motor.f11 10
     one_button .motor.bexpert "Expert.." motor_expert .motor.f11 10




    return
}

#################################################################
# procedure that calls mxc but pops up a window in case of error
#################################################################
proc mxc_protect { value } {
   set good [mxc $value]
    if {$good != 0} {
       cal_display_error_message "Error from mailbox"
    }
    return $good
}
##############################################################################
# Move axis to given channel interactively
##############################################################################
proc move_to_channel_interactive { axis ich } {
    source cal_global.tcl
    global chancoord
    global chan
    global pitch

# Y axis makes sense only if hibrid is two-sided
    if {$axis == "Y" && $Cal_Side_Hybrid != 2} {
       cal_display_error_message \
       "Cannot go to selected Z channel because the HDI is one-sided"
	return
    }

# check that channel coordinate and channel value for the known position
# are valid real numbers...also the channel that we should be moving to.
    set good [check_real $chancoord($axis)]
    if {$good != 0} {
        cal_display_error_message "Coordinate $chancoord($axis) is not real"
        return
    }
    set good [check_real $chan($axis)]
    if {$good != 0} {
        cal_display_error_message "Channel $chan($axis) is not real"
        return
    }
    set good [check_real $ich]
    if {$good != 0} {
        cal_display_error_message "Channel $ich is not real"
        return
    }

# check that the pitch makes sense
    set good [check_real $pitch($axis)]
    if {$good != 0} {
        cal_display_error_message "Pitch for axis $axis is not real"
        return
    }
    if {$pitch($axis) <= 0} {
	cal_display_error_message "Pitch for axis $axis must be > 0"
        return
    }

# make sure that the channel numbers are valid
    if {$axis == "X"} {
       set min_chan 0
       set max_chan [expr 128 * $Cal_number_of_chips_top]
       incr max_chan -1
    } else {
	set min_chan [expr 128 * $Cal_number_of_chips_top]
        set max_chan [expr 128 * $Cal_number_of_chips]
       incr max_chan -1
    }
    if {$ich < $min_chan || $ich > $max_chan} {
	cal_display_error_message \
	"Illegal channel no. $ich on axis $axis: \n should be between $min_chan and $max_chan"
        return
    }

# okay, now figure out where we should go.......    
    set deltach  [expr $ich - $chan($axis)]
    set distance [expr $deltach * $pitch($axis)]
    if {$axis == "X"} {
	set distance [expr -1 * $distance]
    }
    set coordinate [expr $distance + $chancoord($axis)]
#    puts "$axis $coordinate"
    motor_tell $axis $coordinate
    set good [move_to_position $axis $coordinate]
    if {$good != "OK"} {
	cal_display_error_message $good
    }
    destroy .motor_tell
    mxpos
    mypos
}

##############################################################################
# This just calls move_to_position, and also displays possible error messages
#############################################################################
proc move_to_position_interactive { axis coord } {
   set good [check_real $coord]
    if {$good != 0} {
       cal_display_error_message \
       "Attempt to move axis $axis \n to a non-real coordinate \n Coordinate value is $coord" 
	return
    }
   motor_tell $axis $coord
   set good [move_to_position $axis $coord]
   if {$good != "OK"} {
       cal_display_error_message $good
   }
   destroy .motor_tell
   mxpos
   mypos
}

######################################################################
# procedure to pop up a window and thell the user where we want to go
######################################################################
proc motor_tell { axis coord } {
     toplevel .motor_tell -bg #ff0
     label .motor_tell.label \
           -text "Moving \n $axis axis to \n $coord" \
           -bd 2 -bg #aff -highlightthickness 0 
     pack .motor_tell.label -in .motor_tell -side top -pady 20 -padx 20
     update
}
##################################################################
# move a given axis ("X") or ("Y") to a given coordinate (in mm)
# return "OK" or an error message
##################################################################
proc move_to_position { axis coord } {
    global stat1
    global stat2

#-- step size in mm
    set step_size 0.015875
    set half_step_size [expr $step_size/2.]

#-- maximum number of iteration
    set max_iter 5

#-- tollerance. When is close enough really enough ? (mm)
    set tollerance [expr $step_size/2.]

#-- check that the axis is legal
    if {$axis != "X" && $axis != "Y"} {
	return "called move_to_position with illegal axis = $axis"
    }

#-- get the axis number
   set axis_number 1
   if {$axis == "Y"} {set axis_number 2}

#-- start the iteration
    set iter 0
    set loop_max [expr $max_iter+1]
    while {$iter < $loop_max} {
        set current_iter [expr $iter+1]

#-- get the present coordinate
        set position [find_x_or_y $axis 1200]
        if {$position == 999} {
	    return "error reading out encoder after iteration no. $iter"
	}
    
#-- are we close enough already ?
        set delta  [expr $coord-$position]
        set adelta [expr abs($delta)]
        if {$adelta <= $tollerance} {return OK}

#-- if we have already done the maximum number of iterations, quit
        if {$current_iter == $loop_max} {
	    return "Unable to get to the required position...sorry"
	}

#-- how many steps do we need ?
        set nsteps [expr $adelta/$step_size]
        set nsteps [expr int($nsteps)]
        set temp   [expr $nsteps*$step_size]
        set temp   [expr $adelta-$temp]
        if {$temp > $half_step_size} {incr nsteps 1}

#-- and in which direction ?
        set direction +
        if {$delta < 0} {
	    set direction -
	}
        
#-- If the number of steps is < 4, we have to be careful, and 
#   move twice. First we move in the "right" direction by 10,
#   and the "backwards" by 10-nsteps 
#   here we flag these instances
        set twice 0
        if {$nsteps < 4} {
	    set twice [expr 10-$nsteps]
	    set nsteps 10
	}

#-- check that the motor is on
        mstatus $axis_number
        if {$axis_number == 1 && $stat1 != "ON"} {
	   return "motor is OFF before iteration $current_iter"
        }
        if {$axis_number == 2 && $stat2 != "ON"} {
	   return "motor is OFF before iteration $current_iter"
        }

#-- now move the axis
        set good [move_axis $axis_number $direction $nsteps]
        if {$good != 0} {
	    return "error from move_axis during iteration $current_iter"
	}

#-- make sure the motor is done moving before proceeding
    set good [wait_for_motor_done_moving $axis_number]
    if {$good != 0} {
	return "error waiting for motor done, iteration $current_iter
    }
#-- check that the motor is still on
    mstatus $axis_number
    if {$axis_number == 1 && $stat1 != "ON"} {
	return "motor is OFF after iteration $current_iter"
    }
    if {$axis_number == 2 && $stat2 != "ON"} {
	return "motor is OFF after iteration $current_iter"
    }

#-- special case now, we have to move a second time in reversed direction
        if {$twice != 0} {
	    if {$direction == "+"} {
		set direction -
	    } else {
		set direction +
	    }
            set good [move_axis $axis_number $direction $twice]
	    if {$good != 0} {
		return "error from move_axis during iteration $current_iter"
	    }
#-- make sure the motor is done moving before proceeding
            set good [wait_for_motor_done_moving $axis_number]
            if {$good != 0} {
	       return "error waiting for motor done, iteration $current_iter"
            }
#-- check that the motor is still on
            mstatus $axis_number
            if {$axis_number == 1 && $stat1 != "ON"} {
	       return "motor is OFF after iteration $current_iter"
            }
            if {$axis_number == 2 && $stat2 != "ON"} {
	       return "motor is OFF after iteration $current_iter"
	    }
	
	}
#- next iteration
	incr iter 1

}

# NB we should never get here, since we should always be returning
# from inside the loop.  If for some reason we do end up here, scream...
 return "move_to_position: Code should never get here \n..Something is really wrong"

}
###########################################################
# returns after the motor is done moving
###########################################################
proc wait_for_motor_done_moving { axis_number } {

    set imax 100000
    set i 1
    while {$i > 0} {
	set value [mstatus $axis_number]
        set value [expr $value & 8]
        if {$value != 0} {return 0}
        if {$i == $imax} {
	   toplevel .too_much
           set grab .too_much
           label .too_much.l -text 
                "It is taking a long time \n for the motor to report a done" \
		-bg #8dd -highlightthickness 0  
           button .too_much.b1 
                  -text "Abort" \
                  -command "set i -999" \
                  -bg #8dd  \
                  -activebackground #7cc \
                  -highlightthickness 0
           button .too_much.b2 
                  -text "Continue" \
                  -command "set i 1" \
                  -bg #8dd  \
                  -activebackground #7cc \
                  -highlightthickness 0

	    pack .too_much.l .too_much.b1 .too_much.b2 -side top -in .too_much
	    tkwait variable i
	    destroy .too_much
	}
        incr i 1
    }
    return $i
}
######################################################
# This procedure sets the default encoder parameters
######################################################
proc set_default_encoder_parameters {} {

#- X and Y must be absolute
   mdwr XA
   after 800
   mdwr YA
   after 800
}
##################################################
# This procedure sets the default values of motor
# parameters.  It also downloads the parameters 
# for the ***_def(1) (see below)
# IT WILL DO IT ONLY ONCE
##################################################
proc set_default_motor_parameters {} {

#  These are the parameters for the motor. There are two sets of
#  default values, for number of steps > or <= to nstep_hilo (1=lo 2=hi)
#  We also keep the current values.......
   global m_acc_def
   global m_ini_def
   global m_vel_def
   global m_acc
   global m_ini
   global m_vel
   global nstep_hilo
   global m_defaults_done_already
       
   set dummy [info exists m_defaults_done_already]
   if {$dummy == 1} {return}
   set m_defaults_done_already "YES"
   set m_acc_def(1) 50
   set m_ini_def(1) 10
   set m_vel_def(1) 50
   set m_acc_def(2) 4
   set m_ini_def(2) 4
   set m_vel_def(2) 4
   set nstep_hilo 100
   set i 1
   while {$i < 3} {
       set good [write_motor_parameters $i $m_acc_def(1) $m_ini_def(1) $m_vel_def(1)]
       if {$good != 0} {
           cal_display_error_message \
	       "error in set_default_motor_parameters..writing motor $i"
       }
   incr i 1
   }
   return $good
}
###########################################################
# This procedure updates the motor parameters, if necessary.
# Returns zero if everything is OKAY
###########################################################
proc update_motor_parameters { axis_number nsteps } {
   global m_acc_def
   global m_ini_def
   global m_vel_def
   global m_acc
   global m_ini
   global m_vel
   global nstep_hilo

#- check the call parameters first
   set good [test_value axis_number $axis_number 1 2]
   if {$good != 0} {return $good}
   set good [test_value nsteps $nsteps 0 9999999]    
   if {$good != 0} {return $good}

#- now see if anything needs to be updated
   set update 0
   set istep 1
   if {$nsteps > $nstep_hilo} {set istep 2}
   if {$m_acc($axis_number) != $m_acc_def($istep)} {set update 1}
   if {$m_vel($axis_number) != $m_vel_def($istep)} {set update 1}
   if {$m_ini($axis_number) != $m_ini_def($istep)} {set update 1}
   if {$update == 0} {return 0}

#- Yes, looks like we need to update
   set acc $m_acc_def($istep)
   set ini $m_ini_def($istep)
   set vel $m_vel_def($istep)
   set good [write_motor_parameters $axis_number $acc $ini $vel]
   return $good
}
##############################################
# This procedure writes the motor parameters
# Returns zero if everything is okay
##############################################
proc write_motor_parameters { axis_number acc ini vel } {
   global m_acc
   global m_ini
   global m_vel

#- check the call parameters first
   set good [test_value axis_number $axis_number 1 2]
   if {$good != 0} {return $good}
   set good [test_value acc $acc 0 255]
   if {$good != 0} {return $good}
   set good [test_value acc $ini 0 255]
   if {$good != 0} {return $good}
   set good [test_value acc $vel 0 255]
   if {$good != 0} {return $good}

#- now write them out to the board
    if {$axis_number == 1} {
	set command 1sa$acc,1si$ini,1sv$vel
        set good [mxc $command]
    } else {
	set command 2sa$acc,2si$ini,2sv$vel
	set good [mxc $command]
    }
    if {$good == 0} {
       set m_acc($axis_number) $acc	    
       set m_ini($axis_number) $ini
       set m_vel($axis_number) $vel	    
    }
    return $good
}
############################################################
# Procedure to move the axis...assumes that motor is on
# Returns zero if it is okay
# NB this does not check for the axis to be done moving
# before returning
############################################################
proc move_axis { axis_number direction nsteps } {

#- check the call parameters first
   set good [test_value axis_number $axis_number 1 2]
   set good [test_value nsteps $nsteps 0 9999999]    
   if {$good != 0} {return $good}
   if {$direction != "+" && $direction != "-"} {return 1}

#- update the motor settings if necessary
   set good [update_motor_parameters $axis_number $nsteps]
   if {$good != 0} {return $good}

#- now move the axis
   set axis_number_move 1mr
   if {$axis_number == 2} {set axis_number_move 2mr}
   set good [mxc $axis_number_move$direction$nsteps]

#- done
   return $good
}
#######################################################################
# procedure that calls move_axis but pops up a window in case of error
# Also, it does not return until we are done moving
#######################################################################
proc move_axis_protect { axis_number direction nsteps } {
   global stat1
   global stat2

#- check to see if the axis is on
   getstat
   if {$axis_number == 1 && $stat1 != "ON"} {
       cal_display_error_message "Motor 1 is OFF"
       return
   }
   if {$axis_number == 2 && $stat2 != "ON"} {
       cal_display_error_message "Motor 2 is OFF"
       return
   }

#- call move_axis
   set good [move_axis $axis_number $direction $nsteps]
   if {$good != 0} {
       cal_display_error_message "move_axis returns error. \n Error is $good"
       return
   }

#-wait for the axis to be done moving before returning
   wait_for_motor_done_moving $axis_number
}
#######################################################################
# pops up the window with expert setups
#######################################################################
proc motor_expert {} {
   global m_acc_def
   global m_ini_def
   global m_vel_def
   global m_acc
   global m_ini
   global m_vel
   global nstep_hilo

    if {[winfo exists .motor_expert]} {return}

        toplevel .motor_expert -bg #00f
        frame .motor_expert.f20 -bg #00f
        frame .motor_expert.f222 -bg #00f
        frame .motor_expert.f10 -bg #00f
        frame .motor_expert.f201 -bg #00f
        frame .motor_expert.f4 -bg #00f
        frame .motor_expert.f8 -bg #00f
        frame .motor_expert.f9 -bg #00f
        frame .motor_expert.f90 -bg #00f
        frame .motor_expert.f91 -bg #00f
        frame .motor_expert.f91.1 -bg #00f
        frame .motor_expert.f91.2 -bg #00f
        pack .motor_expert.f20 \
             .motor_expert.f222 \
             .motor_expert.f10 \
	     .motor_expert.f201 \
             .motor_expert.f4 \
             .motor_expert.f8 \
             .motor_expert.f9 \
             .motor_expert.f90 \
             .motor_expert.f91 \
	-in .motor_expert -side top -padx 2 -pady 5
        pack  .motor_expert.f91.1 .motor_expert.f91.2 \
		-side left -in .motor_expert.f91 -padx 2 -pady 2
        set j 1
        while {$j < 3} {
	    set i 1
	    while {$i < 5} { 
		frame .motor_expert.f91.$j.$i -bg #00f 
		pack .motor_expert.f91.$j.$i -side top \
			-in .motor_expert.f91.$j
                incr i 1
	    }
	    incr j 1
	}

#warning for expert
     label .motor_expert.label \
     -text "These are for experts only. \n Use at your own risk" \
     -bg #ff0 -highlightthickness 0
     one_button .motor_expert.close "Close" "destroy .motor_expert" \
      .motor_expert.f20 10
     pack .motor_expert.label -in .motor_expert.f20 -side left


#reset digital display unit
     label .motor_expert.careful \
     -text "CAREFUL: Resetting Digital Display\nwill put it into incremental mode" \
     -bg #ff0 -highlightthickness 0
     pack .motor_expert.careful -in .motor_expert.f222 -side left -padx 2
     label .motor_expert.drst  -text "Reset Digital Display "  \
           -bg #8dd -anchor center \
           -height 2 -highlightthickness 0 
     button .motor_expert.drx -relief raised -width 4 -text "X(1-phi)" \
             -command {mdwr x } -bd 2 \
             -bg #8dd -activebackground #7cc  
     button  .motor_expert.dry -relief raised   -width 4  -text "Y(2-z)" \
             -command {mdwr y } -bd 2 \
             -bg #8dd -activebackground #7cc  
     pack .motor_expert.drst .motor_expert.drx .motor_expert.dry \
	     -padx 4 -fill x -side left \
             -in .motor_expert.f10 -ipadx 3


#absolute vs incremental mode
     button .motor_expert.xabs -relief raised -width 8 \
	     -text "Set X(1-phi) in\nabsolute\nmode" \
             -command {mdwr XA } -bd 2 \
             -bg #8dd -activebackground #7cc  
     button .motor_expert.yabs -relief raised -width 8 \
	     -text "Set Y(2-z) in\nabsolute\nmode" \
             -command {mdwr YA } -bd 2 \
             -bg #8dd -activebackground #7cc  
     button .motor_expert.xinc -relief raised -width 8 \
	     -text "Set X(1-phi) in\nincremental\nmode" \
             -command {mdwr XI } -bd 2 \
             -bg #8dd -activebackground #7cc  
     button .motor_expert.yinc -relief raised -width 8 \
	     -text "Set Y(2-z) in\nincremental\nmode" \
             -command {mdwr YI } -bd 2 \
             -bg #8dd -activebackground #7cc  
     pack .motor_expert.xabs .motor_expert.yabs \
	      .motor_expert.xinc .motor_expert.yinc \
	      -in .motor_expert.f201 -side left





# Command for DXC module
     one_bentry .motor_expert.exe  "DXC Command" \
     {mxc_protect $mxcmd} .motor_expert.cmd 25 \
     mxcmd .motor_expert.f4 0


     one_bentry .motor_expert.dexe  "DDU command" \
           {mdwr $dcmd} .motor_expert.dcmd 25 dcmd .motor_expert.f8 0
     set reply ""
     one_blabel .motor_expert.dreply "DDU reply      " \
           {updat_reply} .motor_expert.drep 25 $reply .motor_expert.f9 0


# Now the motor settings
     one_lentry .motor_expert.nstep_hilo1 \
	     "No. of step boundary for motor settings" \
             .motor_expert.nstep_hilo2 5 nstep_hilo .motor_expert.f90 10

     label .motor_expert.msg1 -bg #8dd -highlightthickness 0 \
                 -text "Small no. of steps:"
     label .motor_expert.msg2 -bg #8dd -highlightthickness 0 \
                 -text "Large no. of steps:"
     
     set i 1
     while {$i < 3} {
         pack .motor_expert.msg$i -side top -in .motor_expert.f91.$i.1
         one_lentry .motor_expert.acc$i "Acceleration" \
		 .motor_expert.accl$i 4 \
                    m_acc_def($i) .motor_expert.f91.$i.2 6
         one_lentry .motor_expert.vel$i "Velocity      " \
		 .motor_expert.vell$i 4 \
                    m_vel_def($i) .motor_expert.f91.$i.3 6
         one_lentry .motor_expert.ini$i "Initial Rate  " \
		 .motor_expert.inil$i 4 \
                    m_ini_def($i) .motor_expert.f91.$i.4 6
	 incr i 1
     }



}
##########################################################
# procedure to turn on/off the dc level that controls
# whether we do a normal calibration run (off) or an LED
# scan (ON).  We will be using output channel 16.
# Returns zero if everything is OKAY
##########################################################
proc dc_level_on {} {
  set good [mxc ct16,ch16,cn16]
  return $good
}
proc dc_level_off {} {
  set good [mxc ct16,ch16,cf16]
  return $good
}
##########################################################
# procedure to turn on/off the dc level that controls
# the delay select.  We will be using output channel 16.
# Returns zero if everything is OKAY
##########################################################
proc delay_select_on {} {
  set good [mxc ct10,ch10,cn10]
  return $good
}
proc delay_select_off {} {
  set good [mxc ct10,ch10,cf10]
  return $good
}



