#//////////////////////////////////////////////////////////////////////////////
#
# improved pm command window - alu
# more "improvements"        - claudio
#
#//////////////////////////////////////////////////////////////////////////////
#
#Written By Armin Karcher
# 12/95
# At Lawrence Berkeley National Laboratory
#
#//////////////////////////////////////////////////////////////////////////////

# --- set X defaults for this application widgets
proc osv_setxdefaults {} {
  option clear
  
  option add *troughColor         #dfdfdf user
  option add *selectBackground    #bfdfff user
  option add *disabledForeground  #7f7f7f user
  
  option add *background          #00f    user
  option add *foreground          black   user
  option add *activeBackground    #7cc    user
  option add *activeForeground    black   user
  option add *selectColor         black   user

  option add *Frame*background    #00f    user
  option add *Label*background    #8dd    user

  option add *Entry*background    #aff    user
  option add *Entry*highlightColor  #f00    user
  option add *Entry*highlightBackground     #8dd    user
  option add *Entry*selectBackground      #0ff    user

  option add *Button*background   #8dd    user
  option add *Button*highlightThickness   0	user
}

osv_setxdefaults

# --- variable used to stop loops
set alu(keepgoing) 0

# --- shorten invocation by hand
proc pmcmd {} { osv_pmcmd }

# --- call osv_vme_pmCommand, but only if we are not already looping
# --- this should protect from hitting buttons too many times
proc pre_osv_vme_pmCommand { bottone {opcode 0x00} {nbytes 0} {direction 0}} {
  global alu
  if {$alu(keepgoing) == 0} {
      osv_vme_pmCommand $bottone $opcode $nbytes $direction
  }
}

# --- loop on vme_pmCommand according to user setup
proc osv_vme_pmCommand { bottone {opcode 0x00} {nbytes 0} {direction 0} } {
  global alu

# --- check that all the parameters are kosher  
  set good [test_value "card number" $alu(xcardn) 0 20] 
  if {$good != 0} {return}
  set good [test_value "address/tag" $alu(xtag) 0x0 0x1f]
  if {$good != 0} {return}
  set good [test_value "channel mask" $alu(xchan) 0x1 0xf]
  if {$good != 0} {return}
  set good [test_value "number of repetitions" $alu(xnev) 0 9999999]
  if {$good != 0} {return}

  set chip_data 0
  set chip_data "$alu(xcdata1) $alu(xcdata2) $alu(xcdata3) $alu(xcdata4)"

# --- flag that says that we are now looping
  set alu(keepgoing) 1

# --- store the global arrays into local arrays to prevent the
# --- user from screwing us up.  This is possible because of the
# --- "update" command below ......
  set loc_alu(xnev)   $alu(xnev)
  set loc_alu(xtag)   $alu(xtag)
  set loc_alu(xchan)  $alu(xchan)
  set loc_alu(xcardn) $alu(xcardn)

# --- now loop
  for { set i 0 } {$i < $loc_alu(xnev)} {incr i 1} {
    $bottone flash
    vme_pmCommand $loc_alu(xcardn) $opcode $loc_alu(xtag) $loc_alu(xchan) \
	$direction $nbytes $chip_data
    update
    if {$alu(keepgoing) == 0} { break }
  }
  set alu(keepgoing) 0
}

proc command_window { } {
  source site.tcl
  global alu
  set t osv_pmcmd
  
  if {![winfo exists .$t]} {

# --- pm cmd window
    toplevel .$t

# --- frame 'btnfrm' for Help & Close
    set bf $t.btnfrm

    pack [frame .$bf] -pady 2 
    
    pack [button .$bf.b0 -text "Help" \
	-relief raised  \
	-command {cal_help .pmcom_help pmcom_helpfile}] \
	-side left -padx 5
    
    pack [button .$bf.b2 -text "Stop loop" \
	-relief raised  \
	-command {global alu; set alu(keepgoing) 0}] \
	-side left   -padx 5
    
    pack [button .$bf.b1 -text "Close Window" \
	-relief raised  \
	-command "destroy .$t"] -side left -padx 5 
    
# --- frame 'main'
    set h $t.main

    pack [frame .$h ] \
	-pady 2 -side top

# --- Send Command To PM on Card #
    pack [frame .$h.f] \
	-pady 2 -anchor w
    pack [label .$h.f.l \
	-text "Send Command To PM on Card #" ] \
	-side left -padx 2
    set alu(xcardn) 0
    pack [entry .$h.f.e -textvariable alu(xcardn) \
	-width 8\
	-relief sunken ] \
	-side left -padx 2

# --- Channel Mask & Address/Tag
    pack [frame .$h.s] \
	-pady 2 -anchor w
    label .$h.s.lch -text "Channel Mask\n"
    set alu(xchan) 0x1
    entry .$h.s.ech -textvariable alu(xchan) \
	-width 8\
	-relief sunken
    label .$h.s.lad -text "Address/Tag\n(5 bits, switched)"
    set alu(xtag) 0
    entry .$h.s.ead -textvariable alu(xtag) \
	-width 8\
	-relief sunken
    pack .$h.s.lch .$h.s.ech  -padx 2 -side left -in .$h.s 
    pack  .$h.s.lad .$h.s.ead -padx 2 -side left -in .$h.s 
    
# --- frame data
    pack [frame .$h.data] -pady 2 -side top
    
    set alu(xcdata1) "0 0 0 0 0 0 0 0"
    set alu(xcdata2) "0 0 0 0 0 0 0 0"
    set alu(xcdata3) "0 0 0 0 0 0 0 0"
    set alu(xcdata4) "0 0 0 0 0 0 0 0"
    
    pack [frame .$h.d1] \
	-pady 2 -anchor w
    label .$h.d1.l1 \
	-text "1st 8 data bytes:"
    entry .$h.d1.e1 -textvariable alu(xcdata1) \
	-width 24\
	-relief sunken
    pack .$h.d1.l1 .$h.d1.e1 \
	-padx 2 \
	-side left
    
    pack [frame .$h.d2] \
	-pady 2 -anchor w
    label .$h.d2.l2 \
	-text "2nd 8 data bytes:"
    entry .$h.d2.e2 -textvariable alu(xcdata2) \
	-width 24\
	-relief sunken
    pack .$h.d2.l2 .$h.d2.e2 \
	-padx 2 \
	-side left
    
    pack [frame .$h.d3] \
	-pady 2 -anchor w
    label .$h.d3.l3 \
	-text "3rd 8 data bytes:"
    entry .$h.d3.e3 -textvariable alu(xcdata3) \
	-width 24\
	-relief sunken
    pack .$h.d3.l3 .$h.d3.e3 \
	-padx 2 \
	-side left
    
    pack [frame .$h.d4] \
	-pady 2 -anchor w
    label .$h.d4.l4 \
	-text "4th 8 data bytes:"
    entry .$h.d4.e4 -textvariable alu(xcdata4) \
	-width 24\
	-relief sunken
    pack .$h.d4.l4 .$h.d4.e4 \
	-padx 2 \
	-side left
    
    pack \
	.$h.d1 \
	.$h.d2 \
	.$h.d3 \
	.$h.d4 \
	-pady 2 \
	-side top
    
# --- frame cmd
    set s $t.cmd
    pack [frame .$s ] -side top -fill x
    
# --- nev loop
    pack [frame .$s.nev] \
        -pady 2
    label .$s.nev.l -text "Repeat command"
    label .$s.nev.l2 -text "times"
    set alu(xnev) 1
    entry .$s.nev.e -textvariable alu(xnev) \
	-width 8\
	-relief sunken
    pack .$s.nev.l .$s.nev.e .$s.nev.l2 \
	-padx 2 \
	-side left
      
#
# vme_pmCommand
#   card#, opcode, address (4bit), chanel mask, bytecount, direction, data
#
# Opcodes are sent least significant bit first (of 5).
#
    
    pack [button .$s.b0 -text "No Op" \
        -activebackground #f00 \
	-relief raised  \
	-command "pre_osv_vme_pmCommand .$s.b0 0x00" \
	 ] -fill x
    
    pack [button .$s.b1 -text "Clear Readout" \
        -activebackground #f00 \
	-relief raised  \
	-command "pre_osv_vme_pmCommand .$s.b1 0x10" \
	] -fill x   
      
    pack [button .$s.b2 -text "Synch" \
        -activebackground #f00 \
	-relief raised  \
	-command "pre_osv_vme_pmCommand .$s.b2 0x08" \
	] -fill x    
    
    pack [button .$s.b3 -text "L1 Trigger Accept" \
        -activebackground #f00 \
	-relief raised  \
	-command "pre_osv_vme_pmCommand .$s.b3 0x18" \
	] -fill x  
	      
    pack [button .$s.b4 -text "Read Event" \
        -activebackground #f00 \
	-relief raised  \
	-command "pre_osv_vme_pmCommand .$s.b4 0x4 0x304" \
	] -fill x 
      
# +++ 0x304 ==> enough room for THREE (3) chips (for testing purposes)
		
    pack [button .$s.b5 -text "Calibration Strobe" \
        -activebackground #f00 \
	-relief raised  \
	-command "pre_osv_vme_pmCommand .$s.b5 0x14" \
	] -fill x  
      
    pack [button .$s.b6 -text "Write Control Register" \
        -activebackground #f00 \
	-relief raised  \
	-command "pre_osv_vme_pmCommand .$s.b6 0x1b 4 1" \
	] -fill x
      
    pack [button .$s.b7 -text "Write Calibration and Mask Register" \
        -activebackground #f00 \
	-relief raised  \
	-command "pre_osv_vme_pmCommand .$s.b7 0x07 32 1" \
	]  -fill x

    pack [button .$s.b8 -text "Read Registers" \
        -activebackground #f00 \
	-relief raised  \
	-command "pre_osv_vme_pmCommand .$s.b8 0x17 40" \
	] -fill x
	
    pack [button .$s.b9 -text "Master Reset" \
        -activebackground #f00 \
	-relief raised  \
	-command "pre_osv_vme_pmCommand .$s.b9 0x0F" \
	] -fill x  


    if {$site == "UCSB"} {
	pack [button .$s.b10 -text "Fire LED" \
	-activebackground #f00 \
	-relief raised \
	-command "fire_led .$s.b10" \
	] -fill x
    }


  }
}

proc fire_led { bottone } {
  global alu
  global site

  if {$site != "UCSB"} {
      cal_display_error_message "fire_led procedure not valid for site = $site"
      return
  }

  if {$alu(keepgoing) == 1} {
      return
  }

# --- flag that says that we are now looping
  set alu(keepgoing) 1

# --- store the global arrays into local arrays to prevent the
# --- user from screwing us up.  This is possible because of the
# --- "update" command below ......
  set loc_alu(xnev)   $alu(xnev)

#- set the DC level that enables the firing of the LED
   set good [dc_level_on]
   if {$good != 0} {
       cal_display_error_message "Error trying to set the DC level"
       return
   }

# --- now loop
  for { set i 0 } {$i < $loc_alu(xnev)} {incr i 1} {
    $bottone flash
    uplevel #0 {vme_set    daq_0(led)}
    uplevel #0 {vme_clear  daq_0(led)}
    update
    if {$alu(keepgoing) == 0} { break }
  }
  set alu(keepgoing) 0
  set good [dc_level_off]
  if {$good != 0} {
      cal_display_error_message "Error trying to turn off the DC level"
      return
  }
}
