# 
# VME Teststand Software
#
# Code revised by Armin Karcher (karcher@design.lbl.gov)
#
# Design and Code by:
#   Eric Gottlieb  (egott@unm.edu)
#   Tim Thomas     (thomas@hev1.phys.unm.edu)
#   Micheal Gold   (gold@hepv1.phys.unm.edu)
#
#

# text widget shell

proc puts.new { {a ""} {b ""} {c ""} } {
    global vme_shell_base
    set base $vme_shell_base
    set nonewline 0
    if {$a == "-nonewline"} {
	set a $b
	set b $c
	set nonewline 1
    }
    if {![catch [list tell $a]]} {
	if {$nonewline} {
	    puts.old -nonewline $a $b
	} else {
	    puts.old $a $b
	}
    } else {
	.$base.sh.text insert insert $a
	if {!$nonewline} { .$base.sh.text insert insert "\n" }
    }
}

proc whattodo {} {
    global vme_shell_base
    set base $vme_shell_base
    rename puts puts.old
    rename puts.new puts
    .$base.sh.text mark set insert {insert lineend}
    .$base.sh.text insert insert "\n"
    set cmdfrom {insert - 1 lines linestart + 6 chars}
    set cmdto {insert - 1 lines lineend}
    set command [.$base.sh.text get $cmdfrom $cmdto] 
    set result [uplevel [.$base.sh.text get $cmdfrom $cmdto]]
    .$base.sh.text insert insert $result
    if {$result != ""} {.$base.sh.text insert insert "\n"}
    .$base.sh.text insert insert "cwish>"
    .$base.sh.text yview {insert - 9 lines}
    rename puts puts.new
    rename puts.old puts
}

proc dumptext {} {
    global here vme_shell_base
    set base $vme_shell_base
    puts "here = [.$base.sh.text index here] and newpos = [.$base.sh.text index insert]"
    puts "text = \"[.$base.sh.text get here end]\""
}

proc loadfile file {
    global vme_shell_base
    set base $vme_shell_base
    .$base.sh.text delete 1.0 end
    set f [open $file]
    while {![eof $f]} {
	.$base.sh.text insert end [read $f 1000]
    }
    close $f
}

proc attach_shell {base} {
    global here vme_shell_base
    set vme_shell_base $base
    frame .$base.sh \
	-bg #00f\
	-highlightthickness 0

    pack .$base.sh -pady 1 -fill both -expand 1
    text .$base.sh.text \
	-relief ridge \
	-bd 2 \
	-height 10 \
	-width 40 \
	-yscrollcommand ".$base.sh.scroll set"\
	-bg #aff  \
	-highlightcolor #f00 \
	-highlightbackground #8dd \
	-highlightthickness 0 \
	-selectbackground #0ff
    
    scrollbar .$base.sh.scroll \
		-command ".$base.sh.text yview"\
		-highlightthickness 0 \
		-relief ridge \
		-bd 4 \
		-bg #8dd \
		-troughcolor #00f \
		-activebackground #7cc    

    pack .$base.sh.text -side left -padx 1 -pady 1 -fill both -expand 1
    pack .$base.sh.scroll -side right -padx 2 -pady 1 -fill y
    
    # games w/ the text widget
    
    .$base.sh.text insert insert "cwish>"
    
    bind .$base.sh.text <Return> +whattodo
    bind .$base.sh.text <Up>    { .$base.sh.text mark set insert {insert - 1 lines} }
    bind .$base.sh.text <Down>  { .$base.sh.text mark set insert {insert + 1 lines} }
    bind .$base.sh.text <Left>  { .$base.sh.text mark set insert {insert - 1 chars} }
    bind .$base.sh.text <Right> { .$base.sh.text mark set insert {insert + 1 chars} }
    
    .$base.sh.text mark set here 0.0
}
