##################################
# This is code to test for shorts
# by doing charge injection one channel
# at a time
##################################
proc shorts_window {} {
source cal_global.tcl
source misc_global.tcl

#-------
# if the cal_global variables are not filled, fill them.
#-------
#     if {![info exists Cal_number_of_chips]} {
#         cal_get_defaults cal_defaults.store YES
#     }
#--------------------
# fill some defaults
#--------------------
#     set  short_min_chip 0
#     set  short_max_chip $Cal_number_of_chips
#     incr short_max_chip -1
#     set  short_thresh 20
#     set  short_charge_top 15
#     set  short_charge_bottom [expr 63-$short_charge_top]
#     set  short_nrep 10
#--------------------------------------------
# probably better if these are defined
#--------------------------------------------
#  set Cal_run "stop"
#  cal_get_run_number
#-----------------------------------------
# if the window does not exist, make it
#-----------------------------------------
     if {![winfo exists .short]} {
         toplevel .short -bg #00f

# frames
         frame .short.f -bg #00f
         frame .short.f0 -bg #00f
         frame .short.f1 -bg #00f
         frame .short.f2 -bg #00f
         frame .short.f3 -bg #00f
         frame .short.f4 -bg #00f
         frame .short.f5 -bg #00f
         frame .short.f6 -bg #00f
         frame .short.f1.0 -bg #00f
         frame .short.f1.2 -bg #00f
         frame .short.f1.1 -bg #00f
         pack .short.f .short.f0 .short.f1 \
              .short.f2 .short.f3 .short.f4 .short.f5 .short.f6 \
	      -side top -pady 3
         pack .short.f1.0 .short.f1.2 .short.f1.1 \
		 -side left -padx 3 -in .short.f1
         
# message
         label .short.label \
               -text "\n Test for shorts by injecting charge \n one channel at a time" \
               -bg #ff0 \
               -highlightthickness 0
         pack .short.label -fill x -in .short.f
# load defaults, close, help
         button .short.exit -text Close \
                 -command {destroy .short} \
                 -bg #8dd  \
                 -activebackground #7cc  \
                 -highlightthickness 0
         button .short.rd1 \
               -text "Restore Defaults" \
               -command "prod_tests_defaults 15" \
               -bg #8dd  \
               -activebackground #7cc  \
               -highlightthickness 0
         button .short.help -text Help \
                 -command {cal_help .short_help short_helpfile} \
                 -bg #8dd  \
                 -activebackground #7cc  \
                 -highlightthickness 0
         pack .short.exit .short.help .short.rd1\
              -fill x -padx 5 -side left -in .short.f0

# number of chips
#         label .short.num_chips_label \
#                -text "No. of Chips\n(total)" \
#                -bg #8dd \
#                -highlightthickness 0
#         entry .short.num_chips_entry \
#                -relief sunken \
#                -width 3 \
#                -textvariable Cal_number_of_chips  \
#                -bg #aff   \
#                -highlightcolor #f00 \
#                -highlightbackground #8dd \
#                -selectbackground #0ff
# number of chips
#         label .short.num_chips_label2 \
#                -text "No. of Chips\n(top side)" \
#                -bg #8dd \
#                -highlightthickness 0
#         entry .short.num_chips_entry2 \
#                -relief sunken \
#                -width 3 \
#                -textvariable Cal_number_of_chips_top  \
#                -bg #aff   \
#                -highlightcolor #f00 \
#                -highlightbackground #8dd \
#                -selectbackground #0ff
#
# one-sided or two sided hybrid
#        radiobutton .short.oneside \
#                -text "One-Sided Hybrid" \
#                -variable Cal_Side_Hybrid \
#                -value 1 \
#                -anchor w\
#                -bg #8dd  \
#                -activebackground #7cc \
#                -highlightthickness 0\
#                -relief raised
#        radiobutton .short.twoside \
#                -text "Two-Sided Hybrid" \
#                -variable Cal_Side_Hybrid \
#                -value 2 \
#                -anchor w \
#                -bg #8dd  \
#                -activebackground #7cc \
#                -highlightthickness 0\
#                -relief raised
#
# pack number of chips, hybrid
#         pack .short.num_chips_label .short.num_chips_entry \
#	      -fill x -in .short.f1.0
#         pack .short.num_chips_label2 .short.num_chips_entry2 \
#	      -fill x -in .short.f1.2
#         pack  .short.oneside .short.twoside \
#	      -side top -fill x -in .short.f1.1
#
#
# chips to test / repetitions
         label .short.tn \
                -text "No. of repetitions" \
                -bg #8dd \
                -highlightthickness 0
         entry .short.nrep \
                -relief sunken \
                -width 3 \
                -textvariable short_nrep  \
                -bg #aff   \
                -highlightcolor #f00 \
                -highlightbackground #8dd \
                -selectbackground #0ff
         label .short.from \
                -text "Test chips from " \
                -bg #8dd \
                -highlightthickness 0
         entry .short.min_chip \
                -relief sunken \
                -width 3 \
                -textvariable short_min_chip  \
                -bg #aff   \
                -highlightcolor #f00 \
                -highlightbackground #8dd \
                -selectbackground #0ff
         label .short.to \
                -text " to " \
                -bg #8dd \
                -highlightthickness 0
         entry .short.max_chip \
                -relief sunken \
                -width 3 \
                -textvariable short_max_chip  \
                -bg #aff   \
                -highlightcolor #f00 \
                -highlightbackground #8dd \
                -selectbackground #0ff
         pack \
		 .short.tn .short.nrep \
		 .short.from .short.min_chip .short.to .short.max_chip \
		 -fill x -in .short.f2 -side left -padx 3


# Threshold / Charge injection
         label .short.tl \
                -text "Threshold" \
                -bg #8dd \
                -highlightthickness 0
         entry .short.thresh \
                -relief sunken \
                -width 3 \
                -textvariable short_thresh  \
                -bg #aff   \
                -highlightcolor #f00 \
                -highlightbackground #8dd \
                -selectbackground #0ff
         label .short.cl_top \
                -text "Charge\ntop of HDI" \
                -bg #8dd \
                -highlightthickness 0
         entry .short.charge_top \
                -relief sunken \
                -width 3 \
                -textvariable short_charge_top  \
                -bg #aff   \
                -highlightcolor #f00 \
                -highlightbackground #8dd \
                -selectbackground #0ff
         label .short.cl_bottom \
                -text "Charge\nbottom of HDI" \
                -bg #8dd \
                -highlightthickness 0
         entry .short.charge_bottom \
                -relief sunken \
                -width 3 \
                -textvariable short_charge_bottom  \
                -bg #aff   \
                -highlightcolor #f00 \
                -highlightbackground #8dd \
                -selectbackground #0ff
         pack  \
	      .short.tl .short.thresh \
	      .short.cl_top .short.charge_top \
	      .short.cl_bottom .short.charge_bottom \
	      -fill x -in .short.f3 -side left -padx 3


# message
         label .short.label2 \
               -text "\n    Examine response for channels :    \n " \
               -bg #ff0 \
               -highlightthickness 0
         pack .short.label2 -fill x -in .short.f4


# channels to plot
        set i -3
        while {$i<4} {
         checkbutton .short.cb$i \
                -text "$i " \
                -variable short_chan($i) \
                -anchor w\
                -bg #8dd  \
                -activebackground #7cc \
                -highlightthickness 0\
                -relief raised
          pack .short.cb$i -padx 1 -side left -in .short.f5
          incr i 1
	}

# do it
#        button .short.do_it -text "Do it now" \
#                 -command {start_shorts_test} \
#                 -bg #8dd  \
#                 -activebackground #7cc  \
#                 -highlightthickness 0
#        pack .short.do_it -pady 10 -side bottom -fill x -in .short.f6

}
}

###########################################
# check the variables, then call the C code
###########################################
proc start_shorts_test {} {
source cal_global.tcl
source site.tcl
global short_min_chip
global short_max_chip
global short_thresh
global short_charge_top
global short_charge_bottom
global short_chan
global short_nrep
#-----------------------------------------------
# check that we have a legal number of chips
#-----------------------------------------------
#  set good [cal_check_chip_number]
#  if {$good != 0} {return}
#-----------------------------------------------
# check that min and max are within range
#-----------------------------------------------
#  set cmax $Cal_number_of_chips
#  incr cmax -1
#  set good [test_value short_min_chip $short_min_chip 0 $cmax]
#  if {$good != 0} {return}
#  set good [test_value short_max_chip $short_max_chip $short_min_chip $cmax]
#  if {$good != 0} {return}
#---------------------------------------------------------------
# check that thresholds and charge injections are within range
#---------------------------------------------------------------
#  set good [test_value short_thresh $short_thresh 0 63]
#  if {$good != 0} {return}
#  set good [test_value short_charge_top $short_charge_top 0 63]
#  if {$good != 0} {return}
#  set good [test_value short_charge_bottom $short_charge_bottom 0 63]
#  if {$good != 0} {return}
#------------------------------------------------------------------
# if this is UCSB, we have to make sure that the DC level is OFF
# (also no delay select)
#------------------------------------------------------------------
  if {$site == "UCSB"} {
      set good [delay_select_off]
      if {$good != 0} {
	  cal_display_error_message "Error turning Delay Select OFF"
	  return
      }
      set good [dc_level_off]
      if {$good != 0} {
	  cal_display_error_message "Error trying to turn DC level OFF"
	  return
      }
  }
#------------------------------------------------------------------
# for this test we'll use the same text widget as the looped tests
#------------------------------------------------------------------
  make_pltw_widget
#------------------------------------------
# set the grab while we are doing the test
#------------------------------------------
  grab set .pltw
#----------------------------------------------------------
# the xy stage flag has better be off, also no compression
#---------------------------------------------------------
  set xy_scan_save $xy_scan
  set xy_scan 0
  set Cal_compressed_format_save $Cal_compressed_format
  set Cal_compressed_format 0
#------------------------------------------------
# now call the C-code that does the actual work
#------------------------------------------------
  shorts_test
#--------------------------------------------------------------------
# Set the xy scan and compression flags to whatever they used to be
#-------------------------------------------------------------------
  set xy_scan $xy_scan_save
  set Cal_compressed_format $Cal_compressed_format_save
#--------------------------------------------------------------------
# release the grab
#--------------------------------------------------------------------
  grab release .pltw
}
###########################################
# prompt the user to disconnect histoscope
###########################################
proc disconnect_histoscope {} {
    global cal_dialog
    set dialog 0
    toplevel .disconnect -bg #00f
    label .disconnect.label \
          -text "Are you ready to disconnect histoscope ?" \
          -bd 2  \
          -bg #aff\
          -highlightthickness 0
    button .disconnect.button -text "OKAY" \
	    -command {set cal_dialog 1} \
	    -relief raised -bd 2  \
                -bg #8dd  \
                -activebackground #7cc  \
                -highlightthickness 0
    pack .disconnect.label .disconnect.button -in .disconnect -side top

    grab set .disconnect
    tkwait variable cal_dialog
    grab release .disconnect
    destroy .disconnect
    return 0
}