#########################################################
# This file contains two global variables.  
# "site" is a switch to enable/disable features that may
#        be different at different sites
# "data_directory" is the root directory for writing out a bunch of the files
# The variable "data_directory" is filled from the environmental
# variable DATA_DIR
#
# this variable is used for writing out the following files
# (part_name is the name of the current part, XX is the run number):
#
# (i)    data_directory/parameter_runXX
# (ii)   data_directory/part_name/runXX.dat
# (iii)  data_directory/part_name/histoscope_xx.out
# (iv)   data_directory/part_name/histoscope_xx.hbook
# (v)    data_directory/part_name/chmskXX.dat
# (vi)   data_directory/part_name/bufferXX.dat
# (vii)  data_directory/part_name/totXX.dat
# (viii) data_directory/part_name/tstampXX.dat
# (ix)   data_directory/part_name/jitterXX.dat
# (x)    data_directory/part_name/shortsXX.dat
#
#  where
# (i)         file containing parameter for run XX.  It can be read back 
#             using, e.g. the "Load Defaults" button in the calibration window.
# (ii)        output data file for charge injection/threshold scans
# (iii)       histoscope file for charge injection/threshold scans
# (iv)        same as (iii) but in hbook format
# (vi) -> (x) output files for miscellaneous tests 
#
#########################################################
global env
global site
global data_directory
set site UCSB
set data_directory $env(DATA_DIR)
#-------
# make sure that data_directory ends with a slash
#-------
    set mytemp1 "/"
    set junk    [string trimright $data_directory "/"]
    if {$junk == $data_directory} {
        set data_directory $junk$mytemp1
    }
