##########################################################################
# This is the procedure to book, zero, or delete histograms on the fly
##########################################################################
proc talk_histoscope {} {

source cal_global.tcl
global histo_action
global hzero
global hdel
global hchan_min
global hchan_max
global hchip_min
global hchip_max
global hchan_num
global hchip_num
global histo_chan
global histo_chip
global typevar
global nbooked

# return if we are running
if {$Cal_run == "start" || $Cal_run == "resume"} {
    cal_display_error_message \
  "You must suspended or stoppped \n to talk to histoscope"
    grab set .run_menu
    return
}


# return if cal_histoscope is not set propoerly
if {$Cal_histoscope != 1} {
    cal_display_error_message "You need to have histoscope enabled"
    return
 }


# define the frames
 toplevel .histo -bg #00f 
 grab set .histo
 frame .histo.f0 -bg #00f 
 frame .histo.f1 -bg #00f 
 frame .histo.f2 -bg #00f 
 frame .histo.f3 -bg #00f 
 frame .histo.f4 -bg #00f 
 frame .histo.f5 -bg #00f 
 frame .histo.f6 -bg #00f 
 frame .histo.f100 -bg #00f 
 pack .histo.f0 .histo.f1 .histo.f2 .histo.f3 .histo.f100 .histo.f4 .histo.f5 \
      .histo.f6  -side top -pady 3 -in .histo

  set histo_action 0

# build the list of possible histograms
  set hist(0) "Hit frequency vs threshold"
  set hist(1) "Hit frequency vs charge inj"
  set hist(2) "TOT distribution"
  set hist(3) "Time stamp distribution"
  set hist(4) "2d TOT vs charge inj"
  set hist(5) "2d TOT vs thresh"
  set number_of_hist 6


# frame 0 : exit
  button .histo.exit \
	  -text "Exit  " \
	  -command "set histo_action -1" \
          -bg #8dd -activebackground #7cc -highlightthickness 0 -anchor w
   button .histo.dmem \
	   -text "Delete Histograms\n in Memory" \
	   -command "set nbooked 0" \
          -bg #8dd -activebackground #7cc -highlightthickness 0 -anchor w
   button .histo.bmem \
	   -text "Book Histograms\n in Memory" \
	   -command "store_book_hist 1 0 0 0 0 0 0 0" \
          -bg #8dd -activebackground #7cc -highlightthickness 0 -anchor w

   pack .histo.exit .histo.dmem .histo.bmem \
	   -side left -padx 3 -fill x -in .histo.f0


# frame 1 : zero histogram
  entry .histo.ezero \
	  -textvariable hzero \
	  -width 5 -bg #8dd -highlightthickness 0 
  button .histo.bzero \
	  -text "Zero Histogram Number :  " \
	  -command "set histo_action 1" \
          -bg #8dd -activebackground #7cc -highlightthickness 0 -anchor w
  label .histo.lzero \
	  -text " (0 for all)" \
          -bg #8dd -highlightthickness 0 
   pack .histo.bzero .histo.ezero .histo.lzero -side left -padx 3 -fill x \
	-in .histo.f1

# frame 2 : delete histogram
  entry .histo.edel \
	  -textvariable hdel \
	  -width 5 -bg #8dd -highlightthickness 0 
  button .histo.bdel \
	  -text "Delete Histogram Number :" \
	  -command "set histo_action 2" \
          -bg #8dd -activebackground #7cc -highlightthickness 0  -anchor w
  label .histo.ldel \
	  -text " (0 for all)" \
          -bg #8dd -highlightthickness 0 
  pack .histo.bdel .histo.edel .histo.ldel -side left -padx 3 -fill x \
	-in .histo.f2

# frame 3 : book histogram button
  button .histo.bbook \
	  -text "Book New Histogram  :" \
	  -command "set histo_action 3 " \
          -bg #8dd -activebackground #7cc -highlightthickness 0  -anchor w
  label .histo.lbook \
	  -text " (as defined below)" \
          -bg #8dd -highlightthickness 0 
  pack .histo.bbook .histo.lbook -side left -padx 3 -fill x \
	-in .histo.f3

# frame 100 : just some blank space
  label .histo.dummy -text " " \
          -bg #00f -highlightthickness 0 
  pack .histo.dummy -side left -fill x -in .histo.f100

# frame 4 : histogram type
   label .histo.typlabel \
	 -text "Histo type" \
          -bg #8dd -highlightthickness 0 
   tk_optionMenu .histo.typmenu typevar $hist(0) $hist(1) $hist(2) $hist(3) \
                 $hist(4) $hist(5)
   pack .histo.typlabel .histo.typmenu -side left -padx 3 \
	   -in .histo.f4


# frame 5 : chip selection (all 1  range 2  only one 3)
  frame .histo.f5.f1 -bg #00f 
  frame .histo.f5.f3 -bg #00f 
  frame .histo.f5.f3.1 -bg #00f 
  frame .histo.f5.f3.2 -bg #00f 
  frame .histo.f5.f3.3 -bg #00f 
  pack .histo.f5.f1 .histo.f5.f3 -side left \
	  -in .histo.f5 -padx 3
  pack .histo.f5.f3.1 .histo.f5.f3.2 .histo.f5.f3.3 -side top \
          -in .histo.f5.f3 -fill x 
  radiobutton .histo.chip_range -text "Chip Range from  " \
	  -variable histo_chip -value 2 -anchor w -bg #8dd \
	  -activebackground #7cc -highlightthickness 0 
  radiobutton .histo.chip_all -text "All Chips  " \
	  -variable histo_chip -value 1 -anchor w -bg #8dd \
	  -activebackground #7cc -highlightthickness 0 
  radiobutton .histo.chip_one -text "One Chip..number  " \
	  -variable histo_chip -value 3 -anchor w -bg #8dd \
	  -activebackground #7cc -highlightthickness 0 
  pack .histo.chip_range .histo.chip_all .histo.chip_one -side top \
	  -fill x -in .histo.f5.f1

  entry .histo.chip_min -textvariable hchip_min -width 3 -bg #8dd \
         -highlightthickness 0 
  label .histo.chip_to -text "  to  " \
          -bg #8dd -highlightthickness 0 
  entry .histo.chip_max -textvariable hchip_max -width 3 -bg #8dd \
         -highlightthickness 0 
  pack .histo.chip_min .histo.chip_to .histo.chip_max -side left \
        -fill x -padx 2 -in .histo.f5.f3.1

  label .histo.chip_blank -text " " \
          -bg #00f -highlightthickness 0 
  pack .histo.chip_blank -fill x -in .histo.f5.f3.2
  entry .histo.chip_num -textvariable hchip_num -width 3 -bg #8dd \
         -highlightthickness 0 
  pack .histo.chip_num -side left -in .histo.f5.f3.3


# frame 6 : channel selection (all 1  range 2  only one 3)
  frame .histo.f6.f1 -bg #00f 
  frame .histo.f6.f3 -bg #00f 
  frame .histo.f6.f3.1 -bg #00f 
  frame .histo.f6.f3.2 -bg #00f 
  frame .histo.f6.f3.3 -bg #00f 
  pack .histo.f6.f1 .histo.f6.f3 -side left \
	  -in .histo.f6 -padx 3
  pack .histo.f6.f3.1 .histo.f6.f3.2 .histo.f6.f3.3 -side top \
          -in .histo.f6.f3 -fill x 
  radiobutton .histo.chan_range -text "Channel Range from  " \
	  -variable histo_chan -value 2 -anchor w -bg #8dd \
	  -activebackground #7cc -highlightthickness 0 
  radiobutton .histo.chan_all -text "All Channels  " \
	  -variable histo_chan -value 1 -anchor w -bg #8dd \
	  -activebackground #7cc -highlightthickness 0 
  radiobutton .histo.chan_one -text "One Channel..number  " \
	  -variable histo_chan -value 3 -anchor w -bg #8dd \
	  -activebackground #7cc -highlightthickness 0 
  pack .histo.chan_range .histo.chan_all .histo.chan_one -side top \
	  -fill x -in .histo.f6.f1

  entry .histo.chan_min -textvariable hchan_min -width 3 -bg #8dd \
         -highlightthickness 0 
  label .histo.chan_to -text "  to  " \
          -bg #8dd -highlightthickness 0 
  entry .histo.chan_max -textvariable hchan_max -width 3 -bg #8dd \
         -highlightthickness 0 
  pack .histo.chan_min .histo.chan_to .histo.chan_max -side left \
        -fill x -padx 2 -in .histo.f6.f3.1

  label .histo.chan_blank -text " " \
          -bg #00f -highlightthickness 0 
  pack .histo.chan_blank -fill x -in .histo.f6.f3.2
  entry .histo.chan_num -textvariable hchan_num -width 3 -bg #8dd \
         -highlightthickness 0 
  pack .histo.chan_num -side left -in .histo.f6.f3.3


#----------------------------------------------
# Wait until someone hits a button
# histo_action values :
# -1 get out of here
#  1 zero histogram number hzero
#  2 delete histogram number hdel
#  3 book a histogram
#-----------------------------------------------
   set idummy 1
   while {$idummy > 0} {
     tkwait variable histo_action

     if {$histo_action == -1} {
       destroy .histo
       if {$Cal_run == "suspend"} {grab set .run_menu}
       return
     }




     if {$histo_action == 1 || $histo_action == 2} {
	 if {$Cal_run != "suspend"} {
            cal_display_error_message \
             "You must be suspended to zero or delete a histogram"
	    grab set .histo
	    set histo_action 0
	 }
     }


     if {$histo_action == 1 && $Cal_run == "suspend"} {
       set good 0
       set good [test_value hzero $hzero 0 99999]
       if {$good == 0} {
	   set message [pass_histoscope $histo_action $hzero 0 0 0 0 0]
	   if {$message != "OK"} {cal_display_error_message $message}
       }
       grab set .histo
       set histo_action 0
     } 

     if {$histo_action == 2 && $Cal_run == "suspend"} {
       set good 0
       set good [test_value hdel $hdel 0 99999]
       if {$good == 0} {
	   set message [pass_histoscope $histo_action $hdel 0 0 0 0 0]
	   if {$message != "OK"} {cal_display_error_message $message}
       }   
       grab set .histo
       set histo_action 0
     } 


     if {$histo_action == 3} {
	 set nchips $Cal_number_of_chips
	 incr nchips -1
         set hist_type 0
	 set i 0
	 while {$i < $number_of_hist} {
	     if {$hist($i) == $typevar} {set hist_type $i}
	     incr i 1
	 }
	 set good 0
	 set good [test_value histo_chan $histo_chan 1 3]
	 if {$good == 0} {
	     set good [test_value histo_chip $histo_chip 1 3]
	 }
	 if {$good == 0 && $histo_chan == 2} {
	     set good [test_value hchan_min $hchan_min 0 127]
             if {$good == 0} {
		 set good [test_value hchan_max $hchan_max $hchan_min 127]
	     }
	 }
	 if {$good == 0 && $histo_chip == 2} {
	     set good [test_value hchip_min $hchip_min 0 $nchips]
             if {$good == 0} {
		 set good [test_value hchip_max $hchip_max $hchip_min $nchips]
	     }
	 }
	 if {$good == 0 && $histo_chan == 3} {
	     set good [test_value hchan_num $hchan_num 0 127]
	 }
	 if {$good == 0 && $histo_chip == 3} {
	     set good [test_value hchip_num $hchip_num 0 $nchips]
	 }
	 if {$good == 0} {
	     if {$histo_chip == 3} {
		 set hchip_min $hchip_num
		 set hchip_max $hchip_num
	     } elseif {$histo_chip == 1} {
		 set hchip_min 0
		 set hchip_max $nchips
	     }
	     if {$histo_chan == 3} {
		 set hchan_min $hchan_num
		 set hchan_max $hchan_num
	     } elseif {$histo_chan == 1} {
		 set hchan_min 0
		 set hchan_max 127
	     }
		 
	     set message \
	     [pass_histoscope $histo_action 0 $hchip_min $hchip_max \
		             $hchan_min $hchan_max $hist_type]
	     if {$message != "OK"} {cal_display_error_message $message}
             if {$message == "OK"} {
		 store_book_hist 0 $histo_action 0 $hchip_min $hchip_max \
		             $hchan_min $hchan_max $hist_type
	     }

	 }

	 grab set .histo
	 set histo_action 0
	     
    }

}

return
}



#-----------------------------------------------------------------------
# procedure to store/book the booked histogram
# (flag=0 store, flag=1 book)
#-----------------------------------------------------------------------
proc store_book_hist {flag p1 p2 p3 p4 p5 p6 p7} {
    source cal_global.tcl
    global called_already
    global nbooked
    global sp1
    global sp2
    global sp3
    global sp4
    global sp5
    global sp6
    global sp7

    puts "$flag $p1 $p2 $p3 $p4 $p5 $p6 $p7"

    if {$flag == 0} {
	set dummy [info exists called_already]
	if {$dummy == 0} {
	    set nbooked 0
	    set called_already TRUE
	}
        incr nbooked 1
        set sp1($nbooked) $p1
        set sp2($nbooked) $p2
        set sp3($nbooked) $p3
        set sp4($nbooked) $p4
        set sp5($nbooked) $p5
        set sp6($nbooked) $p6
        set sp7($nbooked) $p7
     }  elseif {$flag == 1} {
	set i 1
	while {$i <= $nbooked} {
             puts "$flag $sp1($i) $sp2($i) $sp3($i) $sp4($i) $sp5($i) $sp6($i) $sp7($i)"
	     set message \
	     [pass_histoscope $sp1($i) $sp2($i) $sp3($i) $sp4($i) $sp5($i) \
	                      $sp6($i) $sp7($i)]
	     if {$message != "OK"} {
		 cal_display_error_message $message
		 return
	     }
	     incr i 1
	 }
     }



return
}


#-----------------------------------------------------------------------
# procedure to prompt the user to close the histoscope connection
#----------------------------------------------------------------------
proc cal_close_histoscope_connection {} {
 global close_histo_talk
 set close_histo_talk 0

 if {![winfo exists .cal_close_histo]} {
 toplevel .cal_close_histo -bg #ff0
 grab set .cal_close_histo
 label .cal_close_histo.label \
         -text "\n Run has finished \n To further update histoscope \n you may have to hit the \n update button several times" \
	 -bd 2 -bg #aff -highlightthickness 0 
 button .cal_close_histo.close \
         -text "Close Histoscope connection" \
         -command "set close_histo_talk close" \
	 -relief raised -bd 2 -bg #8dd \
	 -activebackground #7cc  \
         -highlightthickness 0
 button .cal_close_histo.update \
         -text "Update histoscope" \
         -command "set close_histo_talk update" \
	 -relief raised -bd 2 -bg #8dd \
	 -activebackground #7cc  \
         -highlightthickness 0
 pack .cal_close_histo.label \
      .cal_close_histo.close \
      .cal_close_histo.update \
        -in .cal_close_histo -side top -pady 20 -padx 20

 }

 tkwait variable close_histo_talk
 if {$close_histo_talk == "close"} {
       destroy .cal_close_histo
 }
 return $close_histo_talk
}
#-----------------------------------------------------------
# procedure to display an error message
#-----------------------------------------------------------
proc cal_display_error_message {error_message} {

 global error_talk
 set error_talk 0
 toplevel .cal_message -bg #ff0
 grab set .cal_message
 label .cal_message.label -text $error_message \
	 -bd 2 -bg #aff -highlightthickness 0 
 button .cal_message.ok -text "OKAY" -command "set error_talk 1" \
	 -relief raised -bd 2 -bg #8dd \
	 -activebackground #7cc  \
         -highlightthickness 0
 pack .cal_message.label .cal_message.ok -in .cal_message \
	 -side top -pady 20 -padx 20

 tkwait variable error_talk
 destroy .cal_message
 return
}



