# 
# VME Teststand Software
#
# Code revised by Armin Karcher (karcher@design.lbl.gov)
#
# Design and Template by:
#   Eric Gottlieb  (egott@unm.edu)
#   Tim Thomas     (thomas@hev1.phys.unm.edu)
#   Micheal Gold   (gold@hepv1.phys.unm.edu)
#
#

if {![info exists utils_exists]} {
    set utils_exists 1
    source fsbox.tcl
}

proc evoke {button} {
    global $button
    $button flash
    $button invoke
}

set textreqvar ""

proc textreq { {title "TextRequester"} {variable ""} } {
    global textrequesterwindow textrequestervariable
    set tr textrequesterwindow
    set v textrequestervariable
    set $v $variable
    toplevel .$tr \
		-bg #00f
    wm title .$tr $title
    label .$tr.l -bg #8dd -text "\n\n\n$title\n\n\n"
    entry .$tr.e \
		-textvariable $v \
		-relief sunken \
		-bg #aff  \
		-highlightcolor #f00 \
		-highlightbackground #8dd \
		-selectbackground #0ff

    bind .$tr.e <Return> "evoke .$tr.b.ok"
    frame .$tr.b
    pack .$tr.l .$tr.e .$tr.b \
		-pady 1 \
		-expand 1 \
		-fill x
    button .$tr.b.ok \
		-text "ok" \
		-command "destroy .$tr"\
		-relief raised  \
		-bd 2  \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0
    button .$tr.b.clear \
		-text "clear" \
		-command "set $v {}" \
		-relief raised  \
		-bd 2  \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0
    button .$tr.b.restore -text "restore" \
		-command "set $v \{$variable\}" \
		-relief raised  \
		-bd 2  \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0
    button .$tr.b.abort \
		-text "abort" \
		-relief raised  \
		-bd 2  \
		-bg #8dd  \
		-activebackground #7cc  \
		-highlightthickness 0  \
		-command "
			evoke .$tr.b.restore
			evoke .$tr.b.ok
    			"
    pack .$tr.b.ok .$tr.b.clear .$tr.b.restore .$tr.b.abort \
		-side left \
		-padx 1 \
		-expand 1 \
		-fill x
    grab set .$tr
    tkwait window .$tr
    return $textrequestervariable
}

