# 
# VME Teststand Software
#
# Code revised by Armin Karcher (karcher@design.lbl.gov)
#
# Design and Template by:
#   Eric Gottlieb  (egott@unm.edu)
#   Tim Thomas     (thomas@hev1.phys.unm.edu)
#   Micheal Gold   (gold@hepv1.phys.unm.edu)
#
#

# this_still_needs_work

# proc vme_VmeIoWindow {} {
#     global config
#     if {![info exists config(vme_state)]} { set config(vme_state) normal }
#     if {![info exists config(vme_title)]} { set config(vme_title) "Direct VME Access" }
#     if {![winfo exists .vme]} { toplevel .vme }
#     if {$config(vme_state) == "withdrawn"} { wm withdraw .vme }
#     if {$config(vme_state) == "iconified"} { wm iconify .vme }
#     if {$config(vme_state) == "normal"} {
#     wm title .vme $config(vme_title)
#     wm iconname .vme $config(vme_title)
# }

# proc vme_VmeIoWindow {} {
#     vmewindow
# }

proc vme_VmeIoWindow {} {
    global vme_VmeIoWindow
    if {![info exists vme_VmeIoWindow]} {
	set vme_VmeIoWindow(address) "0x0";
	set vme_VmeIoWindow(offset) 0;
	set vme_VmeIoWindow(read) "read";
	set vme_VmeIoWindow(read_value) "0x0";
	set vme_VmeIoWindow(inc) 0;
	set vme_VmeIoWindow(write_value) 0;
    }
    set x [toplevel .vmeIo -bg #00f]
    wm title .vmeIo "VME Access"
    wm minsize .vmeIo 100 100
    pack [button $x.close -text "close window" -width 28 -bg #8dd -activebackground #7cc -command "destroy $x"  -highlightthickness 0 ] -pady 2

    proc vme_VmeIoWindow_update {} {
	global vme_VmeIoWindow
	set vme_VmeIoWindow(temp) $vme_VmeIoWindow(inc)
	if {$vme_VmeIoWindow(temp) != 0} {evoke .vmeIo.inc.hold}
	evoke .vmeIo.val.read
	if {$vme_VmeIoWindow(temp) == 1} {
	    evoke .vmeIo.inc.inc
	} elseif { $vme_VmeIoWindow(temp) == -1} {
	    evoke .vmeIo.inc.dec
	}
    }	

    pack [frame $x.add -bg #8dd] -pady 2
    pack [label $x.add.l -text "address:" -bg #8dd -highlightthickness 0] -side left
    pack [entry $x.add.v -textvariable vme_VmeIoWindow(address) -width 11 -bd 2 -relief sunken -bg #aff -highlightcolor #f00 -highlightbackground #8dd] -side left
    bind $x.add.v <Return> vme_VmeIoWindow_update

    pack [label $x.add.loff -text "+" -bg #8dd -highlightthickness 0] -side left
    pack [entry $x.add.voff -textvariable vme_VmeIoWindow(offset) -width 6 -bd 2 -relief sunken -bg #aff -highlightcolor #f00 -highlightbackground #8dd] -side left
    bind $x.add.voff <Return> vme_VmeIoWindow_update

    pack [frame $x.val -bg #8dd -highlightthickness 0 ] -pady 1
    pack [button $x.val.read -textvariable vme_VmeIoWindow(read) -width 5  -bg #8dd -highlightthickness 0 -activebackground #7cc -command {
	incr vme_VmeIoWindow(offset) $vme_VmeIoWindow(inc)
	set vme_VmeIoWindow(read_value) [format "0x%4.4x" [vme_vmeread $vme_VmeIoWindow(address) $vme_VmeIoWindow(offset)]]
	.vmeIo.log.text insert end [format "0x%8.8x\[%2.2d\]  -> 0x%4.4x" $vme_VmeIoWindow(address) $vme_VmeIoWindow(offset) $vme_VmeIoWindow(read_value)]
	.vmeIo.log.text yview [expr [.vmeIo.log.text size] - int([ lindex [.vmeIo.log.scroll get] 1 ]) + 1] 
    }]  -side left -padx 2
    pack [label $x.val.readval -textvariable vme_VmeIoWindow(read_value) -width 11 -bd 2  -bg #aff -relief flat] -fill x -side left -padx 2
    
    pack [button $x.val.write -text "write"  -bg #8dd -highlightthickness 0 -activebackground #7cc -width 5 -command {
	vme_vmewrite $vme_VmeIoWindow(address) $vme_VmeIoWindow(offset) $vme_VmeIoWindow(write_value)
	.vmeIo.log.text insert end [format "0x%8.8x\[%2.2d\] <- 0x%4.4x" $vme_VmeIoWindow(address) $vme_VmeIoWindow(offset) $vme_VmeIoWindow(write_value)]
	.vmeIo.log.text yview [expr [.vmeIo.log.text size] - int([ lindex [.vmeIo.log.scroll get] 1 ]) + 1] 
        if {$vme_VmeIoWindow(readback)} {
	    evoke .vmeIo.val.read
	} else {
	    incr vme_VmeIoWindow(offset) $vme_VmeIoWindow(inc)
	}	    
    }] -side left -padx 2
    pack [entry $x.val.writeval -textvariable vme_VmeIoWindow(write_value) -width 11 -bd 2 -relief sunken  -bg #aff -highlightcolor #f00 -highlightbackground #8dd] -side left -padx 2
    bind $x.val.writeval <Return> "evoke $x.val.write"

    pack [frame $x.inc -bg #00f] -pady 1
    pack [radiobutton $x.inc.inc  -text "inc"  -variable vme_VmeIoWindow(inc) -value 1   -bg #8dd -highlightthickness 0 -activebackground #7cc -command {set vme_VmeIoWindow(read) "next"}] -side left -padx 4
    pack [radiobutton $x.inc.dec  -text "dec"  -variable vme_VmeIoWindow(inc) -value -1  -bg #8dd -highlightthickness 0 -activebackground #7cc -command {set vme_VmeIoWindow(read) "back"}] -side left -padx 4
    pack [radiobutton $x.inc.hold -text "hold" -variable vme_VmeIoWindow(inc) -value 0  -bg #8dd -highlightthickness 0 -activebackground #7cc -command {set vme_VmeIoWindow(read) "read"}] -side left -padx 4
    pack [checkbutton $x.inc.read -text "read back" -variable vme_vemWindow(readback)  -highlightthickness 0 -bg #8dd -activebackground #7cc -onvalue 1 -offvalue 0] -side left -padx 4
    if {![info exists vme_VmeIoWindow(readback)]} { set vme_VmeIoWindow(readback) 0 }

    pack [frame $x.log -relief raised -bd 2 -bg #8dd ] -pady 1 -fill both -side bottom -expand 1
    pack [listbox $x.log.text -relief ridge -bd 4 -highlightthickness 0 -yscrollcommand "$x.log.scroll set" -bg #8dd] -side left -padx 1 -pady 1 -fill both -expand 1
    pack [scrollbar $x.log.scroll -highlightthickness 0 -command "$x.log.text yview" -relief ridge -bd 4 -bg #8dd -troughcolor #00f -activebackground #7cc] -side right -padx 2 -pady 1 -fill y

}
